PROGRAM Example5;
{
        This is an example of the SuperFX unit.
        Copyright 1996,1997 by Just4Fun Productions

        This is the XMS version of EXAMPLE2

        It's PacMan! Just a simple showing how it could be done...
        Just a very simple demonstration of the "top-down" game genre..
        I haven't even found time to implement some ghosts, but you
        could try it you'r self!

        Features shown: - all directions scrolling
                        - how to check on background collision for top-down
                          (just look at player.detection)
                        - fadein, fadeout
                        - loading CFG file made with the SETUP program
                        - showing a HIGH screen image (360x480x256)
                        - Flip/Mirror the screen (press ALT while playing)

        Controls        : Use setup to select the movement controls,
                          ALT  to flip the screen
                          ESCAP to exit

}

{$R- $S- $I- $Q- $G+}

{$DEFINE USEDOSMEM }      { Use DOS to allocate memory }
{$IFDEF USEDOSMEM}
   {$M 16384,0,5000}      { now use MEMALLOC/DALLOC instead of GETMEM/FREEMEM}
{$ELSE}
   {$M 65520,0,655360}    { just use GETMEM/FREEMEM }
{$ENDIF}

USES CRT,SFX_XMS,SFX_VARS;

CONST PacManVersion = $003;  { Game version }
      CFGFile      = 'default.cfg';
      controltype  : byte = 1;
{}
{

        Misc variables

}
VAR  JoyPic              : array[1..2] of SpriteTyp;
     flipY               : integer;
     flipA               : integer;
{}
{
      Load the configuration ( using the SETUP program wich came with the
      SuperFX Engine)

      Expects: Nothing
      Returns: Nothing
}
PROCEDURE LoadCFG;
VAR F  :  file;
    SoundCardV : byte;          { we just use these for "fun" }
    PortV      : byte;
    IRQV       : byte;
    DMAV       : byte;
    SAMPLEV    : byte;
BEGIN
  assign(f,CFGFile);
  {$I-}
    reset(f,1);
  {$I+}
   if ioresult<>0 then exit;
      if not eof(f) then blockread(f,controlType,1);
      if not eof(f) then blockread(f,SoundCardV,1);
      if not eof(f) then blockread(f,PortV,1);
      if not eof(f) then blockread(f,IRQV,1);
      if not eof(f) then blockread(f,DMAV,1);
      if not eof(f) then blockread(f,SAMPLEV,1);
      {
        These values are directly read into the KEY array, so you can
        program using the "keys" LEFT,RIGHT,UP,DOWN, and the configuration
        will simple change these constants to the correct key-value
      }
      if not eof(f) then blockread(f,LEFT,1);
      if not eof(f) then blockread(f,RIGHT,1);
      if not eof(f) then blockread(f,DOWN,1);
      if not eof(f) then blockread(f,UP,1);

      if not eof(f) then blockread(f,JoyLeft,1);
      if not eof(f) then blockread(f,JoyRight,1);
      if not eof(f) then blockread(f,JoyDown,1);
      if not eof(f) then blockread(f,JoyUp,1);
  close(f);
END;
{}
{

    Pacman dot object counter...

}
VAR DOTS      : word;
{}
{

    Player Ojbect - for TopDown Games

}
TYPE TPlayerTopDown   =  object
      Xposition          : integer;
      Yposition          : integer;
      Flipped            : boolean;
      Yspeed,Xspeed      : real;
      CurrentIMG         : byte; { Current animation frame }

      score              : longint;     { take a guess?! }
      ScoreTXT           : string[9];   { the score is 9 digits }


        PROCEDURE Init;          { initialise the position, and variables }
        PROCEDURE Detection;     { detection of map-blocks (ground,wall,etc) }
        PROCEDURE Movement(tleft,tright,tup,tdown,tfire:boolean);
        PROCEDURE AddScore(points:word); { add points to the score }
        PROCEDURE ShowScore(x,y:word);   { show the score at X,Y position }
     end;

VAR  PlayerImages : array[0..15] of SpriteTyp;{ the sprite-data of the player}
     ImgNR        : byte;
     Player       : TplayerTopDown; { a complete PLAYER! }
{}
{
        Initialise the Player variables, and the map-position

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE TPlayerTopDown.Init;
BEGIN
        Xposition:=PlayerStartX shl TileShiftFactor;
        Yposition:=PlayerStartY shl TileShiftFactor;
        Flipped:=false;
        Xspeed:=0;
        Yspeed:=0;
        CurrentImg:=2;

        score:=000000000;
        ScoreTXT:='000000000';

       ASM
          mov ax,Xposition
          sub ax,160
          mov mapx,ax
          mov bx,Yposition
          sub bx,100
          mov mapY,bx
          Call Map_Calculate
       end;
END;
{}
{
        Add points to the score (score value, and scoreTEXT will be updated)

        Expects: Amount of points to increase the score with
        Returns: Nothing
}
PROCEDURE TPlayerTopDown.AddScore(points:word);
BEGIN
 inc(score,points);                     { increase score counter             }
 str(score,scoreTXT);                   { set it into a string only once     }
 while length(scoreTXT)<9 do scoreTXT:='0'+scoreTXT;
 scoreTXT[0]:=char(9);                  { make sure it's only 9 characters   }
END;
{}
{
        Show the score of the player

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE TPlayerTopDown.ShowScore(x,y:word);
BEGIN
 TEXT(x,y,scoreTXT);    { simply put the score on screen }
END;
{}
{
        Do detection on the player hitting background objects

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE TplayerTopDown.Detection;
VAR ty2,ty3,tx2,tx3   : word;
    x,y               : word;
    cbehind           : boolean;
    ctop              : boolean;
    cbot              : boolean;
    cright            : boolean;
    cleft             : boolean;
    wi,hi             : byte;
    xt,yt,
    mapt              : integer;
    dataptr           : pointer;
    bitflag,f_Frame   : byte;
BEGIN
 ASM
  mov ax,player.yposition
  shr ax,TileshiftFactor
  cmp ax,0
  jng @nodecreaseY
  dec ax
 @nodecreaseY:
  mov ty2,ax
  add ax,2
  mov ty3,ax
  mov ax,player.xposition
  shr ax,TileShiftFactor
  cmp ax,0
  jng @nodecreaseX
  dec ax
 @nodecreaseX:
  mov tx2,ax
  add ax,2
  mov tx3,ax

  mov cbehind,false
  mov ctop,false
  mov cbot,false
  mov cleft,false
  mov cright,false
  mov cleft,false
 END;

 { Get width and height of player image }
 wi:=PlayerImages[PlayerImages[currentIMG].c_Frame].width;
 hi:=PlayerImages[PlayerImages[currentIMG].c_Frame].height;

 FOR x:=tx2 to tx3 do begin
   xt:=x shl TileShiftFactor; { calculate X shl 5 only onces per vertical Row! }
   FOR y:=ty2 to ty3 do begin
   {==========================================================================
        Now get the blocks above,below,left and on the right side of the
        player
   ==========================================================================}
       BitFlag:=mapPos(x,y,mapBitflag);
       F_frame:=mapPos(x,y,mapF_Frame);
        yt:=y shl TileShiftFactor;
        {=====================================================================
            See if this block is not just empty-air
        =====================================================================}
        { Some testing now... }
        IF BITFLAG<>0 THEN BEGIN
           {==================================================================
              See behind player
           ==================================================================}
           IF NOT CBEHIND then
           if (collision( xt+8,yt+8,16,16,
                          xposition,yposition,wi,hi))
                          then begin
                             CASE BITFLAG of
                             { *****************
                                 Massive Block
                             ******************}
                                  2 : begin
                                         Player.AddScore(10);
                                         mem[seg(Map^):ofs(map^)+(((y*(mapwidth+1))+x) shl 1)]:=0;
                                         mem[seg(Map^):ofs(map^)+(((y*(mapwidth+1))+x) shl 1)+1]:=0;
                                         cbehind:=true;
                                         dec(DOTS);
                                      end;
                                  4 : begin
                                         Player.AddScore(25);
                                         mem[seg(Map^):ofs(map^)+(((y*(mapwidth+1))+x) shl 1)]:=0;
                                         mem[seg(Map^):ofs(map^)+(((y*(mapwidth+1))+x) shl 1)+1]:=0;
                                         cbehind:=true;
                                         dec(DOTS);
                                      end;

                             end; { case blocktype }
           end;

           {==================================================================
              See Top of player
           ==================================================================}
           IF NOT CTOP then
           if (yspeed<0.0) and (collision( xt+5,
                          yt+tiles[f_Frame].height-3,
                          tiles[f_Frame].width-10,5,
                          xposition,yposition,wi,10))
                          then begin
                             CASE BITFLAG of
                             { *****************
                                 Massive Block
                             ******************}
                                  1 : begin
                                         yposition:=yt+tiles[f_Frame].height;
                                         yspeed:=0;
                                         ctop:=true;
                                      end;
                             end; { case blocktype }
           end;
           {==================================================================
              See Bottom of player
           ==================================================================}
           IF NOT cbot then
           if (yspeed>0.0) and  (collision( xt+5,yt-1,tiles[f_Frame].width-10,7,
                           xposition,yposition+hi-5,wi,5))
                           then begin
                             CASE BITFLAG of
                             { **************
                                 Walk able
                             ****************}
                                  1  : begin
                                          yposition:=yt-hi;
                                          Yspeed:=0;
                                          cbot:=true;
                                         end;
                             end; { case blocktype }
           end;
           {==================================================================
              See Right Side of the player
           ==================================================================}
           if not cright then
           if (xspeed>0.0) and (collision(xt,yt+5,5,tiles[f_Frame].height-10,
                         xposition+wi,yposition,1,hi)) then begin
              CASE BITFLAG of
              {*******************
                   Massive Block
              ********************}
                1 : begin
                     xposition:=xt-wi;
                     xspeed:=0;
                     cright:=true;
                    end;
              end; { case blocktype }
           end;
           {==================================================================
              See Left Side of the player
           ==================================================================}
           if not cleft then
           if (xspeed<0) and
              (collision(xt,yt+5,tiles[f_Frame].width,
                         tiles[f_Frame].height-10,
                         xposition,yposition,1,hi)) then begin
              CASE BITFLAG of
              {*******************
                  Massive Block
              ********************}
                1 : begin
                     xposition:=xt+tiles[f_Frame].width;
                     xspeed:=0;
                     cleft:=true;
                    end;
              end; { case blocktype }
           end; { end left side }
    { --------------------------------------------------------------------- }
    END; { end collision_detection }
  END; { Y counter }
 END; { X counter }
END;
{}
{
        Check on a wall above the player.

        Expects: xpos,ypos and width+height of player-image
        Returns: TRUE if moving is possible
}
FUNCTION MOVETOP(xpos,ypos:integer;wi,hi:byte):boolean;
VAR ty2,tx2,tx3,ty3   : word;
    x,y               : word;
    ctop              : boolean;
    xt,yt,
    mapt              : integer;
    dataptr           : pointer;
    bitflag,f_Frame   : byte;
BEGIN
 ASM
  mov ax,ypos
  shr ax,TileshiftFactor
  cmp ax,0
  jng @nodecreaseY
  dec ax
 @nodecreaseY:
  mov ty2,ax
  add ax,2
  mov ty3,ax
  mov ax,xpos
  shr ax,TileShiftFactor
  cmp ax,0
  jng @nodecreaseX
  dec ax
 @nodecreaseX:
  mov tx2,ax
  add ax,2
  mov tx3,ax
  mov ctop,false
 END;

 movetop:=true;

 FOR x:=tx2 to tx3 do begin
   xt:=x shl TileShiftFactor; { calculate X shl 5 only onces per vertical Row! }
   FOR y:=ty2 to ty3 do begin
       BitFlag:=mapPos(x,y,mapBitflag);
       f_frame:=mapPos(x,y,mapF_frame);
        yt:=y shl TileShiftFactor;
           IF NOT CTOP then
           if (collision( xt+5,
                          yt+tiles[f_Frame].height-3,tiles[f_Frame].width-10,5,
                          xpos,ypos,wi,10))
                          then begin
                             CASE BITFLAG of
                             { *****************
                                 Massive Block
                             ******************}
                                  1 : begin
                                         movetop:=false;
                                         ctop:=true;
                                      end;
                             end; { case blocktype }
           end;

       END;
 END;
END;
{}
{
        Check on a wall under the player.

        Expects: xpos,ypos and width+height of player-image
        Returns: TRUE if moving is possible
}
FUNCTION MOVEBOT(xpos,ypos:integer;wi,hi:byte):boolean;
VAR ty2,tx2,tx3,ty3   : word;
    x,y               : word;
    ctop              : boolean;
    xt,yt,
    mapt              : integer;
    dataptr           : pointer;
    f_frame,bitflag   : byte;
BEGIN
 ASM
  mov ax,ypos
  shr ax,TileshiftFactor
  cmp ax,0
  jng @nodecreaseY
  dec ax
 @nodecreaseY:
  mov ty2,ax
  add ax,2
  mov ty3,ax
  mov ax,xpos
  shr ax,TileShiftFactor
  cmp ax,0
  jng @nodecreaseX
  dec ax
 @nodecreaseX:
  mov tx2,ax
  add ax,2
  mov tx3,ax
  mov ctop,false
 END;

 movebot:=true;

 FOR x:=tx2 to tx3 do begin
   xt:=x shl TileShiftFactor; { calculate X shl 5 only onces per vertical Row! }
   FOR y:=ty2 to ty3 do begin
       BitFlag:=mapPos(x,y,mapBitflag);
       F_Frame:=mapPos(x,y,mapF_frame);
        yt:=y shl TileShiftFactor;
           IF NOT CTOP then
               if (collision( xt+5,yt-1,tiles[f_Frame].width-10,7,
                              xpos,ypos+hi-5,wi,5))
                           then begin
                             CASE BITFLAG of
                             { **************
                                 Walk able
                             ****************}
                                  1  : begin
                                          movebot:=false;
                                          ctop:=true;
                                         end;
                             end; { case blocktype }
               end;
       END;
 END;
END;
{}
{
        Check on a wall left of the player.

        Expects: xpos,ypos and width+height of player-image
        Returns: TRUE if moving is possible
}
FUNCTION MOVELEFT(xpos,ypos:integer;wi,hi:byte):boolean;
VAR ty2,tx2,tx3,ty3   : word;
    x,y               : word;
    ctop              : boolean;
    xt,yt,
    mapt              : integer;
    dataptr           : pointer;
    bitflag,f_Frame   : byte;
BEGIN
 ASM
  mov ax,ypos
  shr ax,TileshiftFactor
  cmp ax,0
  jng @nodecreaseY
  dec ax
 @nodecreaseY:
  mov ty2,ax
  add ax,2
  mov ty3,ax
  mov ax,xpos
  shr ax,TileShiftFactor
  cmp ax,0
  jng @nodecreaseX
  dec ax
 @nodecreaseX:
  mov tx2,ax
  add ax,2
  mov tx3,ax
  mov ctop,false
 END;

 moveleft:=true;

 FOR x:=tx2 to tx3 do begin
   xt:=x shl TileShiftFactor; { calculate X shl 5 only onces per vertical Row! }
   FOR y:=ty2 to ty3 do begin
       BitFlag:=mapPos(x,y,mapBitflag);
       f_frame:=mapPos(x,y,mapF_Frame);
        yt:=y shl TileShiftFactor;
           IF NOT CTOP then
             if (collision(xt,yt+5,tiles[f_Frame].width,
                           tiles[f_Frame].height-10,
                         xpos,ypos,1,hi)) then begin
              CASE BITFLAG of
              {*******************
                  Massive Block
              ********************}
                1 : begin
                     moveleft:=false;
                     ctop:=true;
                    end;
              end; { case blocktype }
           end; { end left side }
       END;
 END;
END;
{}
{
        Check on a wall above the player.

        Expects: xpos,ypos and width+height of player-image
        Returns: TRUE if moving is possible
}
FUNCTION MOVERIGHT(xpos,ypos:integer;wi,hi:byte):boolean;
VAR ty2,tx2,tx3,ty3   : word;
    x,y               : word;
    ctop              : boolean;
    xt,yt,
    mapt              : integer;
    dataptr           : pointer;
    f_Frame,bitflag   : byte;
BEGIN
 ASM
  mov ax,ypos
  shr ax,TileshiftFactor
  cmp ax,0
  jng @nodecreaseY
  dec ax
 @nodecreaseY:
  mov ty2,ax
  add ax,2
  mov ty3,ax
  mov ax,xpos
  shr ax,TileShiftFactor
  cmp ax,0
  jng @nodecreaseX
  dec ax
 @nodecreaseX:
  mov tx2,ax
  add ax,2
  mov tx3,ax
  mov ctop,false
 END;

 moveright:=true;

 FOR x:=tx2 to tx3 do begin
   xt:=x shl TileShiftFactor; { calculate X shl 5 only onces per vertical Row! }
   FOR y:=ty2 to ty3 do begin
       Bitflag:=mapPos(x,y,mapBitflag);
       F_frame:=mapPos(x,y,mapF_frame);
        yt:=y shl TileShiftFactor;
           IF NOT CTOP then
              if (collision(xt,yt+5,5,tiles[f_Frame].height-10,
                            xpos+wi,ypos,1,hi)) then begin
              CASE BITFLAG of
              {*******************
                   Massive Block
              ********************}
                1 : begin
                     moveright:=false;
                     ctop:=true;
                    end;
              end; { case blocktype }

           end; { end left side }
       END;
 END;
END;
{}
{
        Do the player movements

        Expects: Nothing
        Returns: Nothing
}

PROCEDURE TPlayerTopDown.Movement;
BEGIN
   {
      Do the wall detections
   }
   Detection;
   {
      Horizontal movements
   }
   IF Tleft then begin
        if MOVELEFT(xposition,yposition,35,35) then begin
         if not Flipped then Flipped:=true;
         if currentIMG<>0 then currentIMG:=0;
         xspeed:=-1.6;
         yspeed:=0.0;
        end;
   end else IF Tright then begin
       if MOVERIGHT(xposition,yposition,35,35) then begin
        if FLIPPED then Flipped:=false;
        if currentIMG<>0 then currentIMG:=0;
        xspeed:=1.6;
        yspeed:=0.0;
       end;
   end;
   {
      Vertical movements
   }
   IF Tup then begin
          If MOVETOP(xposition,yposition,35,35) then begin
             if currentIMG<>4 then currentIMG:=4;
             yspeed:=-1.6;
             xspeed:=0.0;
          end;
   end else IF Tdown then begin
        if MOVEBOT(xposition,yposition,35,35) then begin
          if currentIMG<>8 then currentIMG:=8;
          yspeed:=1.6;
          xspeed:=0.0;
        end;
   end;

   AnimateArray(PlayerImages,ImgNR);

   Xposition:=Xposition+round(Xspeed);
   Yposition:=Yposition+round(Yspeed);
   {
     Calculate map positions
   }
   ASM
     mov ax,player.Xposition
     sub ax,155
     mov mapx,ax
     mov bx,player.Yposition
     sub bx,95
     mov mapY,bx
     Call Map_Calculate
   end;
   {
     Add player to image list
   }
   AddIMAGE( Xposition-MAPX,Yposition-MAPY,
             PlayerImages[PlayerImages[CurrentIMG].c_frame],Flipped,false);
END;
{}
{
        This will find a path thru a maze, from 1 point to another

        Expects: StartX and StartY, DestinationX and DestinationY
        Returns: 0 - move right, 1 - move left, 2 - move up, 3 - move down
}
FUNCTION FindPath(x1,y1,x2,y2:word):byte;
VAR  Cdir   : byte;
     Tdir   : byte;
BEGIN
 FindPath:=0;
 {
     First see what need priority
 }
END;
{}
{
        This procedure will go thru the map, and count the DOTs

        Expects: Nothing
        Returns: Nothing, but sets DOTS to the amount of dots.
}
PROCEDURE CountDots;
VAR  x,y : word;
BEGIN
 for y:=0 to mapHeight do begin
     for x:=0 to mapWidth do begin
         if (mapPos(x,y,mapBitflag)=2) or (mapPos(x,y,Mapbitflag)=4) then inc(DOTS);
     end;
 end;
END;
{}
BEGIN
 write('Locating library :');
   if not UseFile('SUPERFX.DFP') then begin
      halt_Error:='ERROR - File not found:SUPERFX.DFP';
      halt;
   end;
 writeln('ok');
 write('Loading config :');
   LoadCFG; write('.');                   { load the configuration file      }
 writeln('ok');
 writeln;
 writeln('press a key');
 repeat until anypressed;

 LoadPCXHigh(true,'sfxlogo.pcx');

 ImgNR:=GetXas(true,'pacman.xas',PlayerImages);   { load craft images                }

 GetXas(true,'blocks2.xas',tiles);         { load the tiles                   }
 LoadCharset(true,'charset.chr');         { read in a charset                }

 UseCopper:=false;     { no copper bars }
 UseLayer:=false;      { no layer }
 InitCopper;           { Initialise copper values                       }


 if not LoadMap(true,'game2.map') then begin { load a MAP file               }
    setTXTmode;                           { couldn't find a map              }
    halt;                                 { HALT the program!                }
 end;
 CountDots;

 fadeout(0,255);
 LoadPCXHigh(true,'pacman.pcx');
 for flipY:=0 to 20 do retrace;
 fadeout(0,255);

 InitVGAmode;                             { Initialise VGA mode }
 LoadPal(true,'palette.col');             { load the palette }

 {

    The next part will "swirl-calibrate" the joystick, if used...

 }
 IF ControlTYPE=2 then begin { Calibrate the joystick                   }
    GETXAS(true,'joystick.xas',joypic);  { read joystick images         }
    ASM
       call setpal                { set the palette we loaded             }
       mov ax,127                 { X position of image                   }
       mov bx,67                  { Y position of image                   }
       mov si,offset joypic       { first image                           }
       les di,[ds:si]             { get pointer to data                   }
       call SPRITENOMASK          { draw the sprite, no masking           }
       call ShowBitmap            { show the bitmap (image)               }
    END;
    REPEAT SAMPLE; UNTIL JoystickA or JoystickB or JoystickC or JoystickD;
    ASM
       mov ax,127                 { X position of image                   }
       mov bx,67                  { Y position of image                   }
       mov si,offset joypic       { get image offset                      }
       add si,10                  { and get data of second image          }
       les di,[ds:si]             { get pointer to data                   }
       call SPRITENOMASK          { draw the sprite, no masking           }
       call ShowBitmap            { show the bitmap (image)               }
    END;
    SwirlCalibrate;               { Do the "swirl" thing                  }
 END;

 Player.Init;
 SETPAL;               { set the correct pal                            }

 flipY:=0;
 flipA:=1;

 REPEAT

  CASE ControlTYPE of
   1 : Player.Movement(key[left],key[right],key[up],key[down],key[ctrl]);
   2 : BEGIN
          GetJoy;
          Player.Movement(Joystickleft,joystickright,joystickUp,joystickdown,JoystickB);
   end;
  END;

  UpdateMap;
  Retrace;

  if flipA<>0 then begin
     flip(flipY);
     inc(flipY,flipA);
     if flipY>198 then begin
        flipy:=198;
        flipA:=0;
     end;
     if flipY<2 then begin
        flipY:=2;
        flipA:=0;
     end;
  end else begin
      case flipY of
        2 : ShowBitmap;
      198 : FlipScreenY;
      end;
  end;

  Player.ShowScore(5,190);

  if key[alt] then begin
     case FlipY of
         2 : flipA:=4;
       198 : flipA:=-4;
     end;
  end;

 until (key[esckey]) or (dots=0);

 fadeout(0,255);

 setTXTMode;

END.

