PROGRAM IBall;
{
        IBall v0.1
 
        Programming:            Graphics:       Game Idea:
        P.Bestebroer            P.Bestebroer    Old C64 Game
 
        Copyright 1996,1997 by Just4Fun Productions
 
        Revision History:

        0.1      - Private Version
 

  This was included in the SFX engine only to show you some serious game
  programming tricks.

  Game:

  Get to the top before the time runs out (should be easy)
  Don't smash into the balls floating around
  Smash the white-signs as hard as you can for high- bonus points.


}
{$DEFINE USEDOSMEM }      { Use DOS to allocate memory... }
{$IFDEF USEDOSMEM}
   {$M 16384,0,5000}     { Minimum of HEAP memory needed }
{$ELSE}
   {$M 65520,0,655360}   { Maximum of HEAP memory needed }
{$ENDIF}

USES CRT,DOS,SuperFX,SFX_VARS;


CONST GameVersion = $001;               { game version                }
      CFGfile     = 'default.cfg';      { use the default config file }
      ControlType :byte = 1;            { 1-keyboard 2-joystick,read from CFG}
      GameOver    : boolean = false;
      LevelDone   : boolean = false;
{}

{}
VAR JoyPic              : array[1..2] of SpriteTyp;
    done                : boolean;
    zin                 : string;
    timer               : byte;
{}
{

        This will draw a horizontal line

        Expects: X1,Y1,X2 positions and the color
        Returns: Nothing
}
PROCEDURE HLine(X1,Y1,X2:word;Col1:word); ASSEMBLER;
ASM
   mov bx,Y1
   cmp bx,200
   jnl @OutOfBounds

   mov ax,X1
   mov cx,X2
   cmp ax,cx
   jl @XposOk
   xchg ax,cx
  @XposOk:

   cmp ax,318
   jb @X1Ok
   xor ax,ax
  @X1Ok:
   cmp cx,320
   jb @X2Ok
   mov cx,319
  @X2Ok:

   mov x1,ax
   mov x2,cx

   mov es,vpage_seg
   mov di,vpage_ofs

   mov cx,bx
   shl bx,6
   shl cx,8
   add bx,cx
   add di,bx
   add di,x1

   mov cx,x2
   sub cx,x1
   mov ax,col1

   rep stosb

  @OutOfBounds:
END;


{
                         BULLET CODE STARTS HERE
}

CONST PLAYERAI  = 1;
      ALIENAI   = 2;

{

    Player Ojbect - for IBALL ONLY

}
TYPE TPlayerPlatForm   =  object
      Xposition          : word;        { X position on the map in pixels }
      Yposition          : word;        { Y position on the map in pixels }
      MapYposition       : word;
      Flipped            : boolean;     { Using mirrored images? }
      firecount          : byte;
      time               : word;
      time2              : byte;

      Xadd,Yadd          : real;
      Yspeed,Xspeed      : real;        { X and Y speed }

      Energy             : word;

      score              : longint;     { take a guess?! }
      totBonus           : integer;
      ScoreTXT           : string[9];   { the score is 9 digits }
      timeTXT            : string[3];

      CurrentIMG         : byte; { Current animation frame }
        PROCEDURE Init;          { initialise the position, and variables }
        PROCEDURE SubInit;
        PROCEDURE Detection;     { detection of map-blocks (ground,wall,etc) }
        PROCEDURE Movement(tleft,tright,tup,tdown,tfire:boolean);
        PROCEDURE AddScore(points:word); { add points to the score }
     end;

VAR  PlayerImages : array[0..10] of SpriteTyp;{ the sprite-data of the player}
     Player       : TplayerPlatform;          { a complete PLAYER! }


TYPE PBull         = ^TBull;
     TBull         = record
        xposition,
        yposition     : integer;
        xspeed,yspeed : integer;
        f_Frame,                         { Animation frame data          }
        a_Frame,
        c_frame,
        t_frame,
        s_Frame     : byte;
        n_frame     : shortint;
        bitflags    : byte;

        energy      : byte;
        ai          : byte;
        BType       : byte;

        prev,next   : Pbull;
     end;

TYPE PAlien        = ^TAlien;
     TAlien        = record
        xposition,
        yposition     : integer;
        kill          : boolean;        { TRUE if kill-able }
        xspeed,yspeed : integer;
        bitflags      : byte;
        c_frame       : byte;

        energy        : byte;
        ai            : byte;

        prev,next   : PAlien;
     end;


VAR  firstalien  : PAlien;
     Lastalien   : PAlien;
     AlienIA     : word;         { amount of alien-sprite images}
     AlienOS     : integer;      { Alien on screen }
     AlienSprite : array[0..60] of SpriteTyp;

     firstbull : PBull;
     LastBull  : PBull;
     BulletIA       : word;
     BulletSprite   : array[1..60] of SpriteTyp;

FUNCTION Erase_Alien(Temp:PAlien):boolean; FORWARD;
{
                            Bullet Code
}
{
        Add a BULLET to the linked list

        Expects: X and Y position, X and Y speeds,
                 Sprite_Number, AI type, Bullet Type (who shot it?),
                 energy of bullet (power of bullet) and the time before
                 it is gone.
        Returns: True if succesfully added the bullet
}
FUNCTION Add_BULL(  Xpos2,Ypos2,xspeed2,yspeed2  :  integer;
                    F_Frame2,ai2,subai2,energy2  :  byte):boolean;
VAR  Temp     : PBull;
     i        : word;
     add      : word;
BEGIN
 ADD_BULL:=true;

 new(Temp);
 IF Temp=NIL then begin
    add_bull:=false;
    exit;
 END;

 IF FirstBULL=NIL  then begin
    LastBULL:=Temp;
    FirstBULL:=Temp;
    with FirstBULL^ do begin
         next:=NIL;
         prev:=Nil;
    end;
 END ELSE BEGIN
     LastBULL^.next:=temp;
     Temp^.prev:=LastBULL;
     LastBULL:=Temp;
     Temp^.next:=NIL;
 END;


 WITH TEMP^ do begin
  yposition:=ypos2+yspeed2+5;
  xspeed:=xspeed2;
  yspeed:=yspeed2;
  AI:=AI2;
  BTYPE:=subai2;
  energy:=energy2;
  {

        Get correct frame for bullet

  }
  i:=1;
  add:=low(bulletSprite);
  while i<>f_frame2 do begin
        if bulletsprite[add].a_Frame<>0 then add:=add+bulletsprite[add].a_Frame else inc(Add);
        inc(i);
  end;

  {

      Now set animation variables

  }
  f_Frame :=add;
  c_frame :=f_frame;
  a_frame :=BULLetSprite[f_Frame].a_frame;
  s_frame :=BULLetSprite[f_Frame].s_frame;
  t_frame :=s_frame;
  n_frame :=BULLetSprite[f_Frame].n_frame;
  bitflags:=BULLetSprite[f_Frame].bitflags;

  Xposition:=xpos2+(mem[seg(bulletsprite[c_frame].data^):ofs(bulletsprite[c_frame].data^)] shr 1);
  Yspeed:=Yspeed2;
 END;
END;
{}
{

        Erase a BULLET object from the linked-list

        Expects: pointer to BULLET object  that needs to be ERASED!
        Returns: True if succesfull
}
FUNCTION Erase_BULL(Temp:PBULL):boolean;
VAR  next_bull,
     prev_bull  : PBULL;
     i        : integer;
     msize    : word;
BEGIN
  erase_BULL:=true;
  if Temp=NIL then begin
     erase_BULL:=false;
     exit;
  end;

  prev_BULL:=Temp^.prev;
  next_BULL:=Temp^.next;

  if prev_BULL=NIL then begin
     FirstBUll:=next_Bull;
  end else Prev_bull^.next:=next_bull;

  if next_bull=NIL then begin
     LastBULL:=prev_Bull;
  end else Next_Bull^.prev:=prev_Bull;

  dispose(Temp);
END;
{}
{
        Handle the BULLET- linked list

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE do_BULL;
VAR temp      : PBull;
    next_Bull : PBull;
    tmpA      : PAlien;
    nxtA      : PAlien;
    done      : boolean;
    i,j,k     : byte;
    dtx,dty   : byte;
    checkdone : boolean;
    chk1,chk2 : boolean;
BEGIN
 AnimateArray(BulletSprite,BulletIA);

 temp:=FirstBull;
 while temp<>Nil do begin
       with temp^ do begin
            done:=false;
            next_Bull:=temp^.next;
            inc(xposition,XSPeeD);
            inc(yposition,YSPeeD);
            if (yposition-mapy<-16) or (yposition-mapy>199) or (xposition-mapx>320) or (xposition-mapx<-16)
               or (mapPos(xposition shr tileshiftfactor,yposition shr tileShiftFactor,mapBitflag)=1)
               then begin
                  if yposition>-20 then
                    for i:=1 to 3 do
                     AddLight( xposition-random(3),yposition-random(3),xposition+random(3)+2,yposition+random(3)+2,
                               16+random(7),true,4);
                  Erase_Bull(temp);
            end else begin
               dtx:=mem[seg(bulletsprite[c_frame].data^):ofs(bulletsprite[c_frame].data^)];
               dty:=mem[seg(bulletsprite[c_frame].data^):ofs(bulletsprite[c_frame].data^)+1];
               CASE AI of
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
PLAYERAI :
BEGIN
  TmpA:=FirstAlien;
  while TmpA<>NIL do begin
             nxtA:=tmpA^.next;
             if tmpA^.kill=true then
             if collision(tmpA^.xposition,tmpA^.yposition,16,16,
                          xposition,yposition,dtx,dty) then begin
                          dec(tmpA^.energy,energy);
                          Done:=true;
                          if tmpA^.energy>200 then begin
                            for i:=1 to 3 do
                             AddLight( xposition-random(12),yposition-random(12),xposition+random(12)+8,yposition+random(12)+8,
                                       16+random(7),true,4);
                            Erase_Alien(tmpA);
                            Player.AddScore(25);
                          end;
                          Erase_Bull(temp);
                          
             end;
             tmpA:=nxtA;
  end;

END;
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
ALIENAI:
BEGIN
   if collision(player.xposition,184,16,10,
               xposition,yposition,dtx,dty) then begin
                  addFX(player.xposition,184,2);
                  done:=true;
                  addFX(player.xposition,160,1);
                  erase_bull(temp);
  end;
END;
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
               END; { end AI case }

            if not DONE then AddImage( xposition-mapx,yposition-mapy,
                                       bulletsprite[c_frame].data,
                                       false,false);
            end;
            temp:=next_Bull;
       end;
  end;
END;

{}
{
        Initialise the Player variables, and the map-position

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE TPlayerPlatform.Init;
BEGIN
    Xposition:=PlayerStartX shl TileShiftFactor;
    Yposition:=PlayerStartY shl TileShiftFactor;
    MapYPosition:=Yposition;
    Flipped:=false;
    FireCount:=0;

    score:=000000000;
    ScoreTXT:='000000000';
    Energy:=125;
    Xspeed:=0; Yspeed:=0; Xadd:=0; Yadd:=0;
    CurrentImg:=0;
    time:=400;
    timeTXT:='400';
    time2:=70;
    ASM
       mov ax,player.Xposition
       sub ax,160
       mov mapx,ax
       mov bx,player.MapYposition
       sub bx,100
       mov mapY,bx
       Call Map_Calculate
    end;
END;
{}
{
        SUB init for a new level

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE TPlayerPlatform.SubInit;
BEGIN
    Xposition:=PlayerStartX shl TileShiftFactor;
    Yposition:=PlayerStartY shl TileShiftFactor;
    MapYPosition:=Yposition;
    Flipped:=false;
    FireCount:=0;

    Energy:=125;
    Xspeed:=0; Yspeed:=0; Xadd:=0; Yadd:=0;
    CurrentImg:=0;
    time:=400;
    timeTXT:='400';
    time2:=70;
    ASM
       mov ax,player.Xposition
       sub ax,160
       mov mapx,ax
       mov bx,player.MapYposition
       sub bx,100
       mov mapY,bx
       Call Map_Calculate
    end;
END;

{}
{
        Add points to the score (score value, and scoreTEXT will be updated)

        Expects: Amount of points to increase the score with
        Returns: Nothing
}
PROCEDURE TPlayerPlatform.AddScore(points:word);
BEGIN
 inc(score,points);                     { increase score counter             }
 str(score,scoreTXT);                   { set it into a string only once     }
 while length(ScoreTXT)<9 do scoreTXT:='0'+scoreTXT;
END;
{}
{
        Do detection on the player hitting background objects

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE TplayerPlatform.Detection;
VAR ty2,ty3,tx2,tx3   : word;
    x,y               : word;
    ctop              : boolean;
    cbot              : boolean;
    cbehind           : boolean;
    cright            : boolean;
    cleft             : boolean;
    wi,hi             : byte;
    xt,yt,
    mapt              : integer;
    BitFlag           : byte;
    f_frame           : byte;

BEGIN
 ASM
  mov ax,player.yposition
  shr ax,TileshiftFactor
  cmp ax,0
  jng @nodecreaseY
  dec ax
 @nodecreaseY:
  mov ty2,ax
  add ax,2
  mov ty3,ax
  mov ax,player.xposition
  shr ax,TileShiftFactor
  cmp ax,0
  jng @nodecreaseX
  dec ax
 @nodecreaseX:
  mov tx2,ax
  add ax,2
  mov tx3,ax

  mov ctop,false
  mov cbot,false
  mov cleft,false
  mov cright,false
  mov cleft,false
  mov cbehind,false
 END;

 { Get width and height of player image }
 wi:=mem[seg(PlayerImages[currentIMG].data^):ofs(PlayerImages[currentIMG].data^)];
 hi:=mem[seg(PlayerImages[currentIMG].data^):ofs(PlayerImages[currentIMG].data^)+1];

 FOR x:=tx2 to tx3 do begin
   xt:=x shl TileShiftFactor; { calculate X shl 5 only onces per vertical Row! }
   FOR y:=ty2 to ty3 do begin
   {==========================================================================
        Now get the blocks above,below,left and on the right side of the
        player
   ==========================================================================}

       BitFlag:=MapPos(x,y,mapBitFlag);
       f_frame:=MapPos(x,y,mapF_Frame);
        yt:=y shl TileShiftFactor;
        {=====================================================================
            See if this block is not just empty-air
        =====================================================================}
        { Some testing now... }
        IF BITFLAG<>0 THEN BEGIN
           {==================================================================
              See Top of player
           ==================================================================}
           IF NOT CBEHIND then
           if (collision( xt+5,yt+5,xt+25,yt+25,
                          xposition,yposition,wi,hi))
                          then begin
                             CASE BITFLAG of
                             { *****************
                                 Massive Block
                             ******************}
                               9 : begin
                                      LevelDone:=true;
                                      CBehind:=true;
                               end;
                             end;
           end;
           {==================================================================
              See Top of player
           ==================================================================}
           IF NOT CTOP then
           if (collision( xt+5,
                          yt+mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1]-5,
                          mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)]-10,5,
                          xposition,yposition,wi,10))
                          then begin
                             CASE BITFLAG of
                             { *****************
                                 Massive Block
                             ******************}
                                  1 : begin
                                         yposition:=1+yt+mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1];
                                         if Yspeed<0 then Yspeed:=-Yspeed;
                                         ctop:=true;
                                      end;
                             end; { case blocktype }
           end;
           {==================================================================
              See Bottom of player
           ==================================================================}
           IF NOT cbot then
           if (yspeed>0.0) and  (collision( xt+5,yt-1,mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)]-10,7,
                           xposition,yposition+hi-5,wi,5))
                           then begin
                             CASE BITFLAG of
                             { **************
                                 Walk able
                             ****************}
                                  1  : begin
                                          yposition:=yt-hi;
                                          if Yspeed>0 then Yspeed:=-Yspeed;
                                          cbot:=true;
                                       end;
                             end; { case blocktype }
           end;
           {==================================================================
              See Right Side of the player
           ==================================================================}
           if not cright then
           if (xspeed>0) and (collision(xt,yt+5,5,mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1]-10,
                         xposition+wi,yposition,1,hi)) then begin
              CASE BITFLAG of
              {*******************
                   Massive Block
              ********************}
                1 : begin
                     xposition:=xt-wi;
                     if Xspeed>0 then Xspeed:=-Xspeed;
                     cright:=true;
                    end;
              end; { case blocktype }
           end;
           {==================================================================
              See Left Side of the player
           ==================================================================}
           if not cleft then
           if (xspeed<0) and
              (collision(xt,yt+5,mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)],
                         mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1]-10,
                         xposition,yposition,1,hi)) then begin
              CASE BITFLAG of
              {*******************
                  Massive Block
              ********************}
                1 : begin
                     xposition:=xt+mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)];
                     if Xspeed<0 then Xspeed:=-Xspeed;
                     cleft:=true;
                    end;
              end; { case blocktype }
           end; { end left side }
    { --------------------------------------------------------------------- }
    END; { end collision_detection }
   END; { Y counter }
 END; { X counter }
END;
{}
{
        Do the player movements

        Expects: Nothing
        Returns: Nothing
}

PROCEDURE TPlayerPlatform.Movement;
BEGIN
   Detection;

   WITH PLAYER DO BEGIN
        IF Tleft then begin
                 if not Flipped then Flipped:=true;
                 if xspeed>-7 then xspeed:=xspeed-0.2;
        end else IF Tright then begin
                 if FLIPPED then Flipped:=false;
                 if xspeed<7 then xspeed:=xspeed+0.2;
        end else begin
                 if xspeed>0.0 then xspeed:=xspeed-0.1
                 else
                   if xspeed<0.0 then xspeed:=xspeed+0.1
                 else xspeed:=0;
        end;

        IF Tup then begin
                if yspeed>-7 then yspeed:=yspeed-0.2;
        end else if TDown then begin
                 if yspeed<7 then yspeed:=yspeed+0.2;
        end else begin
                 if yspeed>0.0 then yspeed:=yspeed-0.1
                 else
                   if yspeed<0.0 then yspeed:=yspeed+0.1
                 else yspeed:=0;
        end;

        if Firecount>0 then dec(firecount) else begin
           if TFire then begin
              FireCount:=10;
              Add_Bull(Xposition+8,Yposition-8,0,-6,1,1,1,3);
           end;
        end;

        Xposition:=Xposition+round(Xspeed);
        if (xposition-mapx)>294 then begin
           if xspeed<0 then xposition:=0 else xposition:=294+mapx;
           xspeed:=-xspeed;
        end;
        if (Yspeed<0) and (yposition-mapy<140) then MapYPosition:=MapYPosition+round(Yspeed);

        Yposition:=Yposition+round(Yspeed);
        if (Yposition-mapy)>184 then begin
           if yspeed<0 then yposition:=0 else yposition:=184+mapy;
           yspeed:=-yspeed;
        end;
        asm
         mov ax,player.Xposition
         sub ax,155
         mov mapx,ax
         mov bx,player.Yposition
         sub bx,95
         mov mapY,bx
         Call Map_Calculate
        end;
        AddIMAGE( Player.Xposition-MAPX,Player.Yposition-MAPY,
                  PlayerImages[CurrentImg].data,Flipped,false);

        if time2>0 then dec(time2) else begin
           dec(time);
           time2:=70;
           str(time,timeTXT);                   { set it into a string only once     }
           while length(timeTXT)<3 do timeTXT:='0'+timeTXT;
        end;
   END;
END;
{
                         ALIEN CODE STARTS HERE
}
{}
{
        Add a Alien to the linked list

        Expects: X and Y position, X and Y speeds,
                 Sprite_Number, AI type, Bullet Type (who shot it?),
                 energy of bullet (power of bullet) and the time before
                 it is gone.
        Returns: True if succesfully added the bullet
}
FUNCTION Add_Alien(  Xpos2,Ypos2    :  integer;
                     F_Frame2,ai2,energy2  :  byte):boolean;
VAR  Temp     : PAlien;
     i        : word;
     add      : word;
     done     : boolean;
     idone    : boolean;
     x,y      : word;
BEGIN

 ADD_Alien:=true;
 new(Temp);
 IF Temp=NIL then begin
    add_Alien:=false;
    exit;
 END;

 IF FirstAlien=NIL  then begin
    LastAlien:=Temp;
    FirstAlien:=Temp;
    with FirstAlien^ do begin
         next:=NIL;
         prev:=Nil;
    end;
 END ELSE BEGIN
     LastAlien^.next:=temp;
     Temp^.prev:=LastAlien;
     LastAlien:=Temp;
     Temp^.next:=NIL;
 END;

 { Check if we have to put a SMASH ME sign }
 for x:=mapx to mapx+10 do begin
     for y:=mapy to mapy+10 do begin
         if MapPos(x,y,mapBitflag)=4 then begin
            temp^.AI:=7;
            SetMapPos(x,y,mapBitflag,0);
         end;
     end;
 end;

 WITH TEMP^ do begin
  xposition:=mapx+random(319);  yposition:=mapy+random(312)-64;
  i:=0; done:=false;
  while ((mapPos(xposition shr tileshiftfactor, yposition shr tileshiftfactor,mapBitflag)=1)
        or (abs(xposition-player.xposition)<92)
        or (abs(yposition-player.yposition)<92))
        and (i<10) do begin
        xposition:=mapx+random(319);  yposition:=mapy+random(312)-64;
        inc(i);
  end;
 if i=10 then done:=true;

 xspeed:=0; yspeed:=0;
 while (xspeed=0) and (yspeed=0) do begin
  xspeed:=random(3)-1;
  yspeed:=random(3)-1;
 end;
 AI:=AI2;
 kill:=true;

 { Check if we have to put a SMASH ME sign }
 if not done then begin
   x:=mapx shr TileShiftFactor;
   idone:=false;
   repeat
     y:=mapy shr tileshiftfactor;
     repeat
         i:=mapPos(x,y,mapBitflag);
         if i=4 then begin
               AI:=7;
               SetMapPos(x,y,mapBitflag,0);
               Xposition:=(x shl TileShiftFactor)+4;
               Yposition:=(y shl TileShiftFactor)+4;
               f_frame2:=7;
               xspeed:=0;
               yspeed:=0;
               kill:=false;
               dec(AlienOs);
               idone:=true;
         end;
         inc(y);
     until (y=(mapy shr TileShiftFactor)+6) or (idone);
     inc(x);
   until (x=(mapx shr TileShiftFactor)+10) or (idone);
 end;

 energy:=energy2;
  {=-=-=-=-=-=-=  Get correct frame for bullet =-=-=-=-=-=-=}

  i:=1;
  add:=low(AlienSprite);
  while i<>f_frame2 do begin
        if Aliensprite[add].a_Frame<>0 then add:=add+Aliensprite[add].a_Frame else inc(Add);
        inc(i);
  end;
  {=-=-=-=-=-=-=  Now set animation variables  =-=-=-=-=-=-=-=-=-}
  c_Frame :=add;
  if not done then AddFx(xposition,yposition,1);
 END;
 inc(AlienOS);

 if done then Erase_Alien(temp);

END;
{}
{

        Erase a Alien object from the linked-list

        Expects: pointer to Alien object  that needs to be ERASED!

        Returns: True if succesfull

}
FUNCTION Erase_Alien(Temp:PAlien):boolean;
VAR  next_Alien,
     prev_Alien  : PAlien;
     i        : integer;
     msize    : word;
BEGIN
  erase_Alien:=true;
  if Temp=NIL then begin
     halt_error:='unable to deallocate alien';
     erase_Alien:=false;
     halt;
  end;

  prev_Alien:=Temp^.prev;
  next_Alien:=Temp^.next;

  if prev_Alien=NIL then begin
     FirstAlien:=next_Alien;
  end else Prev_Alien^.next:=next_Alien;

  if next_Alien=NIL then begin
     LastAlien:=prev_Alien;
  end else Next_Alien^.prev:=prev_Alien;

  dispose(Temp);
  dec(AlienOS);
END;

{}
{
        Do detection for an alien against background

        Expects: pointer to the alien
        Returns: Nothing
}
PROCEDURE AlienDetection(Temp:PAlien);
VAR ty2,ty3,tx2,tx3   : word;
    x,y               : word;
    ctop              : boolean;
    cbot              : boolean;
    cright            : boolean;
    cleft             : boolean;
    wi,hi             : byte;
    xt,yt,
    mapt              : integer;
    xpos,ypos         : integer;
    bitflag,f_Frame   : byte;
BEGIN
 xpos:=temp^.xposition; ypos:=temp^.yposition;
 ASM
  mov ax,ypos
  shr ax,TileshiftFactor
  cmp ax,0
  jng @nodecreaseY
  dec ax
 @nodecreaseY:
  mov ty2,ax
  add ax,2
  mov ty3,ax
  mov ax,xpos
  shr ax,TileShiftFactor
  cmp ax,0
  jng @nodecreaseX
  dec ax
 @nodecreaseX:
  mov tx2,ax
  add ax,2
  mov tx3,ax

  mov ctop,false
  mov cbot,false
  mov cleft,false
  mov cright,false
  mov cleft,false
 END;

WITH TEMP^ Do begin
 { Get width and height of player image }
 wi:=mem[seg(AlienSprite[c_frame].data^):ofs(AlienSprite[c_Frame].data^)];
 hi:=mem[seg(AlienSprite[c_frame].data^):ofs(AlienSprite[c_frame].data^)+1];

 FOR x:=tx2 to tx3 do begin
   xt:=x shl TileShiftFactor; { calculate X shl 5 only onces per vertical Row! }
   FOR y:=ty2 to ty3 do begin
   {==========================================================================
        Now get the blocks above,below,left and on the right side of the
        alien
   ==========================================================================}
       BitFlag:=Mappos(x,y,mapBitFlag);
       F_Frame:=mapPos(x,y,mapF_frame);
        yt:=y shl TileShiftFactor;
        {=====================================================================
            See if this block is not just empty-air
        =====================================================================}
        { Some testing now... }
        IF BITFLAG<>0 THEN BEGIN
           {==================================================================
              See Top of player
           ==================================================================}
           IF NOT CTOP then
           if (collision( xt+5,
                          yt+mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1]-5,
                          mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)]-10,5,
                          xposition,yposition,wi,10))
                          then begin
                             CASE BITFLAG of
                             { *****************
                                 Massive Block
                             ******************}
                                  1 : begin
                                         yposition:=1+yt+mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1];
                                         if Yspeed<0 then Yspeed:=-Yspeed;
                                         ctop:=true;
                                      end;
                             end; { case blocktype }
           end;
           {==================================================================
              See Bottom of player
           ==================================================================}
           IF NOT cbot then
           if (yspeed>0.0) and  (collision( xt+5,yt-1,mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)]-10,7,
                           xposition,yposition+hi-5,wi,5))
                           then begin
                             CASE BITFLAG of
                             { **************
                                 Walk able
                             ****************}
                                  1  : begin
                                          yposition:=yt-hi;
                                          if Yspeed>0 then Yspeed:=-Yspeed;
                                          cbot:=true;
                                       end;
                             end; { case blocktype }
           end;
           {==================================================================
              See Right Side of the player
           ==================================================================}
           if not cright then
           if (xspeed>0) and (collision(xt,yt+5,5,mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1]-10,
                         xposition+wi,yposition,1,hi)) then begin
              CASE BITFLAG of
              {*******************
                   Massive Block
              ********************}
                1 : begin
                     xposition:=xt-wi;
                     if Xspeed>0 then Xspeed:=-Xspeed;
                     cright:=true;
                    end;
              end; { case blocktype }
           end;
           {==================================================================
              See Left Side of the player
           ==================================================================}
           if not cleft then
           if (xspeed<0) and
              (collision(xt,yt+5,mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)],
                         mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1]-10,
                         xposition,yposition,1,hi)) then begin
              CASE BITFLAG of
              {*******************
                  Massive Block
              ********************}
                1 : begin
                     xposition:=xt+mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)];
                     if Xspeed<0 then Xspeed:=-Xspeed;
                     cleft:=true;
                    end;
              end; { case blocktype }
           end; { end left side }
    { --------------------------------------------------------------------- }
    END; { end collision_detection }
  END; { Y counter }
 END; { X counter }
 END;
END;

{}
{
        Handle the Alien- linked list

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE do_Alien;
VAR temp      : PAlien;
    next_Alien : PAlien;
    done      : boolean;
    i,j,k     : byte;
    dtx,dty   : byte;
    checkdone : boolean;
    chk1,chk2 : boolean;
BEGIN
 AnimateArray(AlienSprite,AlienIA);

 temp:=FirstAlien;
 while temp<>Nil do begin
       with temp^ do begin
            done:=false;
            next_Alien:=temp^.next;
         if LevelDone then begin
            for i:=1 to 3 do
                AddLight( xposition-random(12),yposition-random(12),
                          xposition+random(12)+8,yposition+random(12)+8,
                          16+random(7),true,4);
            erase_alien(temp);
         end else begin
            case AI of
             1..6 : BEGIN
                     inc(xposition,XSPeeD);
                     inc(yposition,YSPeeD);
                     dtx:=mem[seg(Aliensprite[c_frame].data^):ofs(Aliensprite[c_frame].data^)];
                     dty:=mem[seg(Aliensprite[c_frame].data^):ofs(Aliensprite[c_frame].data^)+1];

                     AlienDetection(temp);
                     if (Xposition+mapX<=0) then begin
                        Xspeed:=-Xspeed;
                        xposition:=1;
                     end;
                     if (Xposition+MapX>320-dtx) then begin
                        xspeed:=-xspeed;
                        xposition:=319-dtx+mapX;
                     end;
                     if (yposition-mapy<-64) or (yposition-mapy>264) then begin
                        if yposition>-20 then Erase_Alien(temp);
                     end else begin

                       if collision( player.xposition,player.yposition,16,16,
                                   xposition,yposition,dtx,dty) then begin
                                     if (xspeed>0) and (player.xspeed<0) then player.xspeed:=-player.xspeed;
                                     if (xspeed<0) and (player.xspeed>0) then player.xspeed:=-player.xspeed;
                                     if (yspeed>0) and (player.yspeed<0) then player.yspeed:=-player.yspeed;
                                     if (yspeed<0) and (player.yspeed>0) then player.yspeed:=-player.yspeed;
                                     dec(Player.Energy,energy);
                                     dec(energy);
                                     if energy=0 then begin
                                       for i:=1 to 3 do
                                        AddLight( xposition-random(12),yposition-random(12),
                                                  xposition+random(12)+8,yposition+random(12)+8,
                                                  16+random(7),true,4);
                                        erase_alien(temp);
                                        done:=true;
                                     end;
                                     if Player.Energy>2000 then begin
                                        GameOver:=true;
                                        player.energy:=0;
                                     end;
                       end;
                     end;
             end;  { END ALIEN 1..6 }
             7 : BEGIN
                     dtx:=mem[seg(Aliensprite[c_frame].data^):ofs(Aliensprite[c_frame].data^)];
                     dty:=mem[seg(Aliensprite[c_frame].data^):ofs(Aliensprite[c_frame].data^)+1];
                      if collision( player.xposition,player.yposition,16,16,
                                   xposition,yposition,dtx,dty) then begin
                                     i:=abs(round(player.yspeed));
                                     if abs(player.xspeed)>abs(player.yspeed) then i:=abs(round(player.xspeed));
                                     player.AddScore(5 shl i);
                                     player.xspeed:=-player.xspeed;
                                     player.yspeed:=-player.yspeed;
                                     inc(player.energy,3);
                                       for i:=1 to 3 do
                                        AddLight( xposition-random(12),yposition-random(12),
                                                  xposition+random(12)+8,yposition+random(12)+8,
                                                  16+random(7),true,4);
                                       erase_alien(temp);
                                       inc(AlienOs);
                                       done:=true;
                      end;

             end; { END ALIEN 7 }
            END;   { end CASE AI OF }
            if not DONE then AddImage( xposition-mapx,yposition-mapy,
                                       Aliensprite[AlienSprite[c_frame].c_frame].data,
                                       false,false);
            end;
         end;
         temp:=next_Alien;
       end;
END;
{}
{
      Load the configuration ( using the SETUP program wich came with the
      SuperFX Engine)

      Expects: Nothing
      Returns: Nothing
}
PROCEDURE LoadCFG;
VAR f  :  file;
    SoundCardV : byte;          { we just use these for "fun" }
    PortV      : byte;
    IRQV       : byte;
    DMAV       : byte;
    SAMPLEV    : byte;
BEGIN
  assign(f,CFGFile);
  {$I-}
    reset(f,1);
  {$I+}
   if ioresult<>0 then exit;
      if not eof(f) then blockread(f,controlType,1);
      if not eof(f) then blockread(f,SoundCardV,1);
      if not eof(f) then blockread(f,PortV,1);
      if not eof(f) then blockread(f,IRQV,1);
      if not eof(f) then blockread(f,DMAV,1);
      if not eof(f) then blockread(f,SAMPLEV,1);

      {
        These values are directly read into the KEY array, so you can
        program using the "keys" LEFT,RIGHT,UP,DOWN, and the configuration
        will simple change these constants to the correct key-value
      }
      if not eof(f) then blockread(f,LEFT,1);
      if not eof(f) then blockread(f,RIGHT,1);
      if not eof(f) then blockread(f,UP,1);
      if not eof(f) then blockread(f,DOWN,1);
      if not eof(f) then blockread(f,CTRL,1);

      if not eof(f) then blockread(f,JoyLeft,1);
      if not eof(f) then blockread(f,JoyRight,1);
      if not eof(f) then blockread(f,JoyUp,1);
      if not eof(f) then blockread(f,JoyDown,1);
      if not eof(f) then blockread(f,JoyFire,1);
  close(f);
END;
{}
VAR i,j  : word;      { some variables to use with the zoom, and in-bounce }
{}
{
        This procedure will take care of the startup of IBall

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE StartUpProcedure;
VAR freemem : longint;
BEGIN
 write  ('       IBall');
 writeln            (' (Engine version ',GameVersion div 256,'.',GameVersion and $ff,')');
 writeln('');
 writeln('       This is our beta version, for testing purposes only                  ');
 writeln('       For more info look at: http://people.zeelandnet.nl/rpb/pindex.html   ');
 writeln('');
 writeln('       Copyright 1996,1997 by Just4Fun Productions                          ');
 writeln('');
 freemem:=0;
 asm
  mov ah,$48
  mov bx,$ffff
  int $21
  mov word ptr freemem,bx
 end;
 freemem:=freemem shl 4;
 writeln('Data memory block allocated (',freemem,' bytes)');
 writeln('Mounting library');
{=====================[         Mount DFP library    ]=======================}
   IF not UseFile('IBALL.DFP') then begin
      halt_Error:='unable to open file iball.dfp';   { oops, not found!   }
      halt;                                            { just halt          }
   end;
{=====================[        Load configuration    ]=======================}
   LoadCFG;
{=====================[           Load artwork       ]=======================}
   write('Loading charset:');
   if not LoadCharset(true,'charset.chr') then begin
      Halt_Error:='unable to open file charset.chr';
      halt;
   end else writeln('.ok');
   write('Loading images:');
   if GetXas(true,'ball.xas',PlayerImages)=0 then begin
      Halt_Error:='unable to spawn ball.xas';
      halt;
   end else write('.');
   AlienIA:=GetXas(true,'alien.xas',AlienSprite);
   if AlienIA=0 then begin
      Halt_Error:='unable to spawn alien.xas';
      halt;
   end else write('.');
   BulletIA:=GetXas(true,'bull.xas',bulletsprite);
   if BulletIA=0 then begin
      Halt_Error:='unable to spawn bull.xas';
      halt;
   end else write('.');
   if GetXas(true,'fx.xas',fxS)=0 then begin
      Halt_Error:='unable to spawn fx.xas';
      halt;
   end else writeln('.ok');

   write('Loading tiles:');
   if GetXas(true,'stage1.xas',tiles)=0 then begin
      Halt_Error:='unable to spawn stage1.xas';
      halt;
   end else write('.');
{=====================[           Set variables      ]=======================}
  write('V_Init:');
   AlienOS:=0;  write('.');
   setTeXTSegment(vpage_seg); write('.');
  writeln('ok');
{***************************************************************************}
 writeln;
 freemem:=0;
 asm
  mov ah,$48
  mov bx,$ffff
  int $21
  mov word ptr freemem,bx
 end;
 freemem:=freemem shl 4;
 writeln('Memory left ',freemem,' bytes');


 writeln('[ hit a key ]');
 repeat until anypressed;
 FadeOut(0,255);
END;
{}
{
        Display an ending screen

        Expects: Nohting
        Returns: Nothing
}
PROCEDURE EndingProcedure;
BEGIN
 SetTXTmode;
 TextColor(7); TextBackground(0); clrscr;
 port[$03c8]:=0; Port[$03c9]:=16; Port[$03c9]:=5;  Port[$03c9]:=17;
 port[$03c8]:=7; Port[$03c9]:=36; Port[$03c9]:=30; Port[$03c9]:=37;
 port[$03c8]:=5; port[$03c9]:=58; Port[$03c9]:=52; Port[$03c9]:=15;

 TextColor(5);
 write  ('       IBall'); TextColor(7);
 writeln            (' (Engine version ',GameVersion div 256,'.',GameVersion and $ff,')');
 writeln('');
 writeln('       This is our beta version, for testing purposes only                  ');
 writeln('       For more info look at: http://people.zeelandnet.nl/rpb/pindex.html   ');
 writeln('');
 writeln('       Copyright 1996,1997 by Just4Fun Productions                          ');
 writeln('');
 writeln;
 writeln('       CREDITS:                                                             ');
 writeln;
 write  ('       Programming:');    TextColor(5);
 writeln                   (' P.Bestebroer'); TextColor(7);
 write  ('       Graphics   :');    TextColor(5);
 writeln                   (' P.Bestebroer'); TextColor(7);
 writeln;
 writeln('');
 writeln('       This game was created using the FREEWARE SuperFX Engine... for more  ');
 writeln('       information on the engine, look at the above mentioned URL           ');
 writeln('');
 writeln('                        --[ Press a Key ]-                         ');
 writeln;
 writeln('Your Score was:'+player.scoreTXT);
 ShowInfo:=false;
 repeat until anypressed;
 FadeOut(0,255);
END;
{}

{}
BEGIN
 StartUpProcedure;

 LoadColorMap(true,'color.map');

 FadeOut(0,255);                          { fade out the screen              }
 InitVGAmode;                             { Initialise VGA mode              }
 LoadPal(true,'palette.col');             { load the palette                 }
 BlackPal;
 {
    The next part will "swirl-calibrate" the joystick, if used...
 }
 if ControlTYPE=2 then begin { Calibrate the joystick                   }
    GETXAS(true,'joystick.xas',joypic);  { read joystick images         }
    asm
     call setpal                { set the palette we loaded             }
     mov ax,127                 { X position of image                   }
     mov bx,67                  { Y position of image                   }
     mov si,offset joypic       { first image                           }
     les di,[ds:si]             { get pointer to data                   }
     call SPRITENOMASK          { draw the sprite, no masking           }
     call ShowBitmap            { show the bitmap (image)               }
    end;
    FadeIn(0,255);
    REPEAT SAMPLE; UNTIL JoystickA or JoystickB or JoystickC or JoystickD;
    asm
     mov ax,127                 { X position of image                   }
     mov bx,67                  { Y position of image                   }
     mov si,offset joypic       { get image offset                      }
     add si,10                  { and get data of second image          }
     les di,[ds:si]             { get pointer to data                   }
     call SPRITENOMASK          { draw the sprite, no masking           }
     call ShowBitmap            { show the bitmap (image)               }
    end;
    SwirlCalibrate;             { Do the "swirl" thing                  }
    DeAllocXAS(joypic);         { get rid of joystick images            }
    FadeOut(0,255);
 end;

 Player.Init;          { initialise the player                          }

 REPEAT { MAIN GAME LOOP, until GAMEOVER }
  LevelDone:=false;
  if not EraseLightAll then halt;
  if not LoadMap(true,'stage1.map') then begin { load a MAP file               }
     setTXTmode;                           { couldn't find a map              }
     halt;                                 { HALT the program!                }
  end;
  Player.SubInit;          { initialise the player                          }
  AddLight(0,0,319,30,12,false,0); { add status-bar dark-light        }

    UpdateMap;
    Do_Alien;
    Do_Bull;
    DoLights;
    TEXT(4,2,'SCORE:');TEXT(150,2,'TIME:');TEXT(250,2,'ENERGY:');
    TEXT(4,12,Player.scoreTXT);    { simply put the score on screen }
    TEXT(150,12,Player.timeTXT);
    Hline(250,12,250+(player.energy shr 1),46);
    Hline(250,13,250+(player.energy shr 1),50);
  ShowBitmap;
  FadeIn(0,255);

  REPEAT { MAIN LEVEL LOOP, until LEVELDONE }

    CASE ControlTYPE of
     1 : Player.Movement(key[left],key[right],key[up],key[down],key[ctrl]);
     2 : BEGIN
            GetJoy;
            Player.Movement(JoystickLeft,joystickright,joystickUp,joystickdown,JoystickA);
     end;
    END;

    if AlienOS<5 then begin
       i:=random(6)+1;
       Add_Alien(0,0,i,i,5);
    end;

    UpdateMap;
    Do_Alien;
    Do_Bull;
    DoLights;
    TEXT(4,2,'SCORE:');TEXT(150,2,'TIME:');TEXT(250,2,'ENERGY:');
    TEXT(4,12,Player.scoreTXT);    { simply put the score on screen }
    TEXT(150,12,Player.timeTXT);
    Hline(250,12,250+(player.energy shr 1),46);
    Hline(250,13,250+(player.energy shr 1),50);


    Retrace;

    ShowBitmap;
    if key[esckey] then gameover:=true;

  UNTIL (GameOver) or (LevelDone);
  if LevelDone then begin
      done:=false;
      timer:=255;
      FadeToGrey(0,255);
      repeat
          AddIMAGE( Player.Xposition-MAPX,Player.Yposition-MAPY,
                    PlayerImages[player.CurrentImg].data,player.Flipped,false);
          UpdateMap;
          Do_Alien;
          Do_Bull;
          DoLights;

          Text(100,105,'LEVEL COMPLETED');
          Text(80,115,'  TIME BONUS:'+player.timeTXT);
          str(player.energy,zin);
          while length(zin)<3 do zin:='0'+zin;
          Text(80,125,'ENERGY BONUS:'+zin);
          str(player.totBonus,zin);
          while length(zin)<9 do zin:='0'+zin;
          Text(80,140,'       TOTAL:'+zin);

          if player.time>0 then begin
             dec(player.time);
             player.AddScore(5);
             inc(player.totbonus,5);
             str(player.time,player.timeTXT);                   { set it into a string only once     }
             while length(player.timeTXT)<3 do player.timeTXT:='0'+player.timeTXT;
          end;
          if player.energy>0 then begin
             dec(player.energy);
             player.AddScore(5);
             inc(player.totbonus,5);
          end;
          if (player.energy=0) and (player.time=0) and (Timer=255) then Timer:=250;
          if (Timer>0) and (timer<>255) then dec(Timer)
             else if timer=0 then done:=true;

          TEXT(4,2,'SCORE:');TEXT(150,2,'TIME:');TEXT(250,2,'ENERGY:');
          TEXT(4,12,Player.scoreTXT);    { simply put the score on screen }
          TEXT(150,12,Player.timeTXT);   { put the time on screen }
          Hline(250,12,250+(player.energy shr 2),46); { show energy bar }
          Hline(250,13,250+(player.energy shr 2),50);

          retrace;
          ShowBitmap;
      until (Done) or ( (timeR<255) and (anypressed) );
  end;
  FadeOut(0,255);

 UNTIL (key[esckey]) or (GameOver);
 {---- make sure you leave no traces! ----}
 DeAllocXAS(PlayerImages);
 DeAllocXas(AlienSprite);
 DeAllocXas(BulletSprite);

 {---- Go back into TEXT mode ----}
 EndingProcedure;
 setTXTMode;
END.

