PROGRAM ColMap;
{
        Color Mapper  v0.2
        programming P.Bestebroer
        copyright 1997 by Just4Fun Productions

        This little program will create a colormap wich contains 32 shades
        of all colors, 0..15 are dark versions 16=normal color 17..31 are
        brighter colors

}
USES CRT;

TYPE PalType = record
      r,g,b  : byte;
     end;

CONST Bright  : byte = 0;
      Dark    : byte = 0;

      InFile  : string = 'palette.col';

VAR ColorMap  : array[0..255,0..31] of byte;
    Palette   : array[0..255] of PalType;

    i,r,g,b   : byte;
    r2,g2,b2  : byte;
    rd,gd,bd  : word;

    l1,l2     : real;

    x,y       : word;

    f         : file;

    TotDif    : word;
    bestDif   : word;
    bestCol   : word;

    CurCol    : byte;
    CurShade  : byte;

{}
PROCEDURE LoadPal;
BEGIN
 assign(f,InFile);
 {I-}
   reset(f,1);
 {I+}
  if IOresult<>0 then begin
     writeln('File not found: ',infile);
     halt;
  end;
 for i:=0 to 255 do begin
    blockread(f,Palette[i].r,1);
    blockread(f,Palette[i].g,1);
    blockread(f,Palette[i].b,1);
 end;

 palette[0].r:=0;
 palette[0].g:=0;
 palette[0].b:=0;

 l2:=round( (palette[0].r*0.3)+ (palette[0].g*0.59)+ (palette[0].b*0.11) );
 bright:=0;

 for i:=0 to 255 do begin
     l1:=round( (palette[i].r*0.3)+ (palette[i].g*0.59)+ (palette[i].b*0.11) );
     if l1>l2 then begin
        bright:=i;
        l2:=l1;
     end;
 end;

 l2:=round( (palette[0].r*0.3)+ (palette[0].g*0.59)+ (palette[0].b*0.11) );
 dark:=0;

 for i:=0 to 255 do begin
     l1:=round( (palette[i].r*0.3)+ (palette[i].g*0.59)+ (palette[i].b*0.11) );
     if l1<l2 then begin
        dark:=i;
        l2:=l1;
     end;
 end;


 close(f);
END;
{}
BEGIN
 if paramstr(1)<>'' then InFile:=paramstr(1);
 LoadPal;

 { CALCULATE LIGHT-VERSION }
 for curcol:=0 to 255 do begin
     ColorMap[curcol,16]:=curcol;
     for curshade:=17 to 31 do begin
          r:=Palette[ColorMap[CurCol,CurShade-1]].r;
          g:=Palette[ColorMap[CurCol,CurShade-1]].g;
          b:=Palette[ColorMap[CurCol,CurShade-1]].b;

       BestCol:=bright;
       BestDif:=65500;

       for i:=0 to 255 do begin
         if i<>ColorMap[CurCol,CurShade-2] then begin
           r2:=Palette[i].r;
           g2:=Palette[i].g;
           b2:=Palette[i].b;

           if r2>r then rd:=r2-r else rd:=r-r2;
           if g2>g then gd:=g2-g else gd:=g-g2;
           if b2>b then bd:=b2-b else bd:=b-b2;

           l1:=(r*0.3)+ (g*0.59)+ (b*0.11);
           l2:=(r2*0.3)+ (g2*0.59)+ (b2*0.11);

           TotDif:=(rd*rd)+(gd*gd)+(bd*bd);

           if (TotDif<BestDif) and (TotDif>1) and (l1<l2) then begin
              BestCol:=i;
              BestDif:=TotDif;
           end;
         end;
       end;
       ColorMap[CurCol,CurShade]:=BestCol;

     end;
 end;

 { CALCULATE DARK-VERSION }
 for curcol:=0 to 255 do begin
     ColorMap[curcol,0]:=curcol;
     for curshade:=15 downto 0 do begin
          r:=Palette[ColorMap[CurCol,CurShade+1]].r;
          g:=Palette[ColorMap[CurCol,CurShade+1]].g;
          b:=Palette[ColorMap[CurCol,CurShade+1]].b;

       BestCol:=dark;
       BestDif:=65500;

       for i:=0 to 255 do begin
         if i<>ColorMap[CurCol,CurShade+2] then begin
           r2:=Palette[i].r;
           g2:=Palette[i].g;
           b2:=Palette[i].b;

           if r2>r then rd:=r2-r else rd:=r-r2;
           if g2>g then gd:=g2-g else gd:=g-g2;
           if b2>b then bd:=b2-b else bd:=b-b2;

           l1:=(r*0.3)+ (g*0.59)+ (b*0.11);
           l2:=(r2*0.3)+ (g2*0.59)+ (b2*0.11);

           TotDif:=(rd*rd)+(gd*gd)+(bd*bd);

           if (TotDif<BestDif) and (TotDif>1) and (l1>l2) then begin
              BestCol:=i;
              BestDif:=TotDif;
           end;
         end;
       end;
       ColorMap[CurCol,CurShade]:=BestCol;

     end;
 end;

 asm
  mov ax,$13
  int 10h
 end;
 for i:=0 to 255 do begin
     port[$03c8]:=i;
     port[$03c9]:=Palette[i].r;
     port[$03c9]:=Palette[i].g;
     port[$03c9]:=Palette[i].b;
 end;

 for x:=0 to 255 do begin
     for y:=0 to 31 do begin
       mem[sega000:((190-(y shl 1))*320)+(x)]:=colormap[x,y];
       mem[sega000:((189-(y shl 1))*320)+(x)]:=colormap[x,y];
     end;
 end;

 assign(f,'color.map'); rewrite(f,1);
     blockwrite(f,colormap,sizeof(colormap));
 close(f);

 repeat until keypressed;

 asm
  mov ax,$03
  int 10h
 end;

END.