PROGRAM PCX2XAS;
{
             Sprite convert v3.0 (FREEWARE)
             Programming by P.Bestebroer
             Converts PCX files to XAS objects
             This version is included with the SUPERFX engine.

}
{}
USES Crt, Dos;
{}
CONST version = 'v3.0';                  { Program VERSION }
{}
const blocksize = 40000;                 { Used with copying }
      ID        : string ='XASv3';         { ID of XAS file format }
      GFX_Error  : string = '';          { contains errors of PCX decoding }
{
                    Type of the sprites in this program
}
Type SpriteTyp=Record
       Adr:Pointer;
       dtx,dty    : word;
     End;
{
                            Main variables
}
VAR sprite      : SpriteTyp;
    mask        : string;
    filename    : string;
    f1,f2,temp  : file;
    files       : array[0..500] of string[12];

    take1,                                 {used in the copy parts}
    take2      : longint;                  {...see above...}
    bcopy1     : array[1..BLOCKSIZE] of byte;  {and again...}

{}
{
        See if a file exists

        Expects: Name of the file
        Returns: TRUE if file exists
}
FUNCTION seefile(name:string):boolean;
VAR f : file;
BEGIN
 seefile:=false;
 assign(f,name);
 {$I-}
  reset(f);
  close(f);
  if ioresult=0 then seefile:=true;
 {$I+}
END;
{}
{
        Write Text

        Expects: X,Y position of the text, and the text-string
                 and the forground+background color
        Returns: Nothing
}
PROCEDURE TWRITE(x,y:word;text:string;col1,col2:byte);
BEGIN
 ASM
   dec x
   dec y
   lea di,text
   mov bx,di

   mov es,segb800       { get screen segment }
   mov di,y             { get Y position }
   mov ax,di
   shl di,7             { multiply with 7... }
   shl ax,5             { and with 32        }
   add di,ax            { add together= Y*160}
   mov ax,x             { get X position }
   shl ax,1             { multiply with 2 }
   add di,ax            { add to screen offset }

   mov ah,col2          { get background color }
   shl ah,4             { multiply with 16     }
   add ah,col1          { add forground color  }

   mov DX,DS            { remember DX          }

   mov cx,ss
   mov ds,cx
   mov si,bx

   lodsb                { read length of string }
   xor ch,ch
   mov cl,al            { set length into CL    }
   cmp cl,0
   je @NoSet            { if no text, skip writing }

  @TLoop:
   LODSB                { load character }
   STOSW                { store character+color }
   dec cl               { decrease length counter }
   jnz @TLoop
  @NoSet:
   mov DS,DX            { get DX back }
 END;
END;
{}
{
        Read from screen coordinates

        Expects: X+Y position to read from
        Returns: Character at the specified position
}
FUNCTION TRead(x,y:word):char; Assembler;
ASM
  dec x
  dec y
  mov ax,y      { get Y positions...                                         }
  mov bx,ax     { ...in AX and BX                                            }
  shl ax,7      { multiply Y with 128...                                     }
  shl bx,5      { ... and with 32                                            }
  add ax,bx     { add together = Y*160                                       }
  mov bx,x      { get X position                                             }
  shl bx,1      { multiply with 2                                            }
  add ax,bx     { add to offset                                              }

  mov es,segb800{ get screen segment                                         }
  mov di,ax     { get screen offset in si                                    }

  mov es:[di],al{ load character                                             }
END;
{}
{
        Center text between 2 X values

        Expects: right,left positions, and the text to be centered
        Returns: The left-starting position to start writing
}
FUNCTION CENTER(x2,x1:integer;zin : string):integer;
BEGIN
 center:=x1+((x2-x1) shr 1)-(length(zin) shr 1)+1;
END;
{}
{
        Draw a menu box

        Expects: Corner positions, title of box, forground+background color
        Returns: Nothing
}
PROCEDURE do_mnu(x1,y1,x2,y2:integer;title,title2:string;c1,c2:integer);
VAR x3,y3          : integer;
    zin            : string[80];
    frontcol       : byte;
BEGIN
 zin:='';
 for x3:=1 to x2-x1+1 do zin:=zin+' ';
 for y3:=y1 to y2 do Twrite(x1,y3,zin,c1,c2);

 for x3:=x1 to x2 do begin
  Twrite(x3,y1,'',c1,c2);
  Twrite(x3,y2,'',c1,c2);
 end;
 for y3:=y1 to y2 do begin
   Twrite(x1,y3,'',c1,c2);
   Twrite(x2,y3,'',c1,c2);
 end;
 Twrite(x2,y1,'',c1,c2);
 Twrite(x2,y2,'',c1,c2);
 Twrite(x1,y1,'',c1,c2);
 Twrite(x1,y2,'',c1,c2);
 if x2+1<81 then begin
   for y3:=y1+1 to y2+1 do if y3<26 then twrite(x2+1,y3,tread(x2+1,y3),8,0);
 end;
 if y2+1<26 then begin
   for x3:=x1+1 to x2+1 do if x3<81 then twrite(x3,y2+1,tread(x3,y2+1),8,0);
 end;

 IF Title<>'' then begin
    for x3:=x1+1 to x2-1 do Twrite(x3,y1+2,'',c1,c2);
    Twrite(x1,y1+2,'',c1,c2);
    Twrite(x2,y1+2,'',c1,c2);
    Twrite( x1+1,y1+1,copy(zin,1,length(zin)-2),c1,c2);
    Twrite( center(x1+1,x2-1,title) ,y1+1,title,c1,c2);
 end;

 IF Title2<>'' then begin
    for x3:=x1+1 to x2-1 do Twrite(x3,y2-2,'',c1,c2);
    Twrite(x1,y2-2,'',c1,c2);
    Twrite(x2,y2-2,'',c1,c2);
    twrite(center(x1+1,x2-1,title2), y2-1,title2,c1,c2);
 end;
END;
{

        Decode a PCX file

        Expects: Filename of the PCX image
        Returns: a VAR of spriteTYPE

}
FUNCTION decode(filename:string;var spt:SpriteTyp):boolean;
TYPE PCX_Header = record
       manu     : byte; { creator }
       version  : byte; { Version }
       encoding : byte;
       b_p_pix  : byte;
       xmin     : word;
       ymin     : word;
       xmax     : word;
       ymax     : word;
       hres     : word;
       vres     : word;
       colormap : array[1..48] of byte;
       reserve  : byte;
       nplanes  : byte;
       bpline   : word;
       palinfo  : word;
       filler   : array[1..58] of byte;
    end;

var  x,y         : word;
     msize       : word;         { to allocate memory }
     Xsize,Ysize : word;         { Size of image }
     Xscrn,Yscrn : word;         { Screen positions }
     plotdata    : byte;         { Byte-Color-Pixel to plot }
     readbyte    : byte;         { Byte to read from file }
     count       : integer;         { Count of continuous bytes }
     count2      : integer;         { Count from 1 to 'COUNT'   }
     Header      : PCX_Header;
     code        : integer;
     lib_file    : file;
BEGIN
  decode:=true;
  assign(lib_file,filename); reset(lib_file,1);

  blockread(lib_file,header,sizeof(header));      { Read header first}

 { Check for correct PCX format }
 if header.encoding<>1 then gfx_error:='Weird encoding used.';
 if header.b_p_pix<>8 then gfx_error:='To many bits per pixel.';
 if header.nplanes<>1 then gfx_error:='To many color-planes used.';
 if gfx_error<>'' then begin
    close(lib_file);         { Close the file }
    decode:=false;
    exit;                    { And exit this procedure }
 end;

  { Init some values }
  Xsize:=header.xmax-header.xmin+1;             { Get actual X-Size of image }
  Ysize:=header.ymax-header.ymin+1;             { Get actual Y-Size of image }
  Xscrn:=0;                                     { Screen positions }
  Yscrn:=0;                                     { Screen positions }
  spt.dtx:=xsize;
  spt.dty:=ysize;

  { get memory for sprite }
  msize:=(xsize*ysize)+2;
  if (msize mod 16)<>0 then msize:=msize+16;
  msize:=16*(msize div 16);

  getmem(spt.adr,msize);
  mem[seg(spt.adr^):ofs(spt.adr^)]:=byte(xsize);
  mem[seg(spt.adr^):ofs(spt.adr^)+1]:=byte(ysize);

  if spt.adr=nil then begin
     gfx_error:='Not enough memory for sprite.';
     decode:=false;
     exit;
  end;

   REPEAT
       blockread(lib_file,readbyte,1);            { Read in next byte }
       if (readbyte and 192)=192 then begin     { Are Top 2 bits set? }
           count:=readbyte and 63;              { Yes, so it's a packed }
           blockread(lib_file,plotdata,1);        { sequence. Read in color }
       end else begin
           count:=1;                            { Not packed, so 1 byte to set}
           plotdata:=readbyte;                  { Set the color to plot }
       end;
       if count>0 then begin
           fillchar( mem[seg(spt.adr^):ofs(spt.adr^)+2
                     +(Yscrn*xsize)+Xscrn],count,plotdata);
       end;
       inc(xscrn,count);
       if xscrn>=xsize then begin             { Hit the image-width? }
          xscrn:=0;                           { Yes, so restart at 0 }
          inc(yscrn);                         { And go 1 line down on screen}
       end;
  UNTIL (yscrn=ysize);                           { Repeat until complete image}
  close(lib_file);                                 { Close image file }
END;

{
{
        Compare two strings (using DOS wildcards)

        Expects: String to search in, and the string to search WITH
        Returns: True if a match is found
}
function WildComp(NameStr,SearchStr: String): Boolean; assembler;
{
 Compare SearchStr with NameStr, and allow wildcards in SearchStr.
 The following wildcards are allowed:
 *ABC*        matches everything which contains ABC
 [A-C]*       matches everything that starts with either A,B or C
 [ADEF-JW-Z]  matches A,D,E,F,G,H,I,J,W,V,X,Y or Z
 ABC?         matches ABC, ABC1, ABC2, ABCA, ABCB etc.
 ABC[?]       matches ABC1, ABC2, ABCA, ABCB etc. (but not ABC)
 ABC*         matches everything starting with ABC
 (for using with DOS filenames like DOS (and 4DOS), you must split the
  filename in the extention and the filename, and compare them seperately)
}
var
  LastW: word;
asm
  cld
  push ds
  lds si,SearchStr
  les di,NameStr
  xor ah,ah
  lodsb
  mov cx,ax
  mov al,es:[di]
  inc di
  mov bx,ax
  or cx,cx
  jnz @ChkChr
  or bx,bx
  jz @ChrAOk
  jmp @ChrNOk
  xor dh,dh
 @ChkChr:
  lodsb
  cmp al,'*'
  jne @ChkQues
  dec cx
  jz @ChrAOk
  mov dh,1
  mov LastW,cx
  jmp @ChkChr
 @ChkQues:
  cmp al,'?'
  jnz @NormChr
  inc di
  or bx,bx
  je @ChrOk
  dec bx
  jmp @ChrOk
 @NormChr:
  or bx,bx
  je @ChrNOk
 {From here to @No4DosChr is used for [0-9]/[?]/[!0-9] 4DOS wildcards...}
  cmp al,'['
  jne @No4DosChr
  cmp word ptr [si],']?'
  je @SkipRange
  mov ah,byte ptr es:[di]
  xor dl,dl
  cmp byte ptr [si],'!'
  jnz @ChkRange
  inc si
  dec cx
  jz @ChrNOk
  inc dx
 @ChkRange:
  lodsb
  dec cx
  jz @ChrNOk
  cmp al,']'
  je @NChrNOk
  cmp ah,al
  je @NChrOk
  cmp byte ptr [si],'-'
  jne @ChkRange
  inc si
  dec cx
  jz @ChrNOk
  cmp ah,al
  jae @ChkR2
  inc si              {Throw a-Z < away}
  dec cx
  jz @ChrNOk
  jmp @ChkRange
 @ChkR2:
  lodsb
  dec cx
  jz @ChrNOk
  cmp ah,al
  ja @ChkRange        {= jbe @NChrOk; jmp @ChkRange}
 @NChrOk:
  or dl,dl
  jnz @ChrNOk
  inc dx
 @NChrNOk:
  or dl,dl
  jz @ChrNOk
 @NNChrOk:
  cmp al,']'
  je @NNNChrOk
 @SkipRange:
  lodsb
  cmp al,']'
  loopne @SkipRange
  jne @ChrNOk
 @NNNChrOk:
  dec bx
  inc di
  jmp @ChrOk
 @No4DosChr:
  cmp es:[di],al
  jne @ChrNOk
  inc di
  dec bx
 @ChrOk:
  xor dh,dh
  dec cx
  jnz @ChkChr        { Can't use loop, distance >128 bytes }
  or bx,bx
  jnz @ChrNOk
 @ChrAOk:
  mov al,1
  jmp @EndR
 @ChrNOk:
  or dh,dh
  jz @IChrNOk
  jcxz @IChrNOk
  or bx,bx
  jz @IChrNOk
  inc di
  dec bx
  jz @IChrNOk
  mov ax,[LastW]
  sub ax,cx
  add cx,ax
  sub si,ax
  dec si
  jmp @ChkChr
 @IChrNOk:
  mov al,0
 @EndR:
  pop ds
end;
{}
{
        Sort the list of files

        Expects: The first, and the last number in the list
        Returns: Nothing
}
PROCEDURE sort_it(first,last:byte);
VAR temp      : string[12];
    zin1,zin2 : string;
    x,i,j     : byte;
BEGIN
     for i:=first to last do begin
         for j:=first to last-1 do begin
             x:=pos('.',files[j+1]);
             if x<>0 then zin1:=copy(files[j+1],1,x-1) else zin1:=files[j+1];
             x:=pos('.',files[j]);
             if x<>0 then zin2:=copy(files[j],1,x-1) else zin2:=files[j];
           if zin1<zin2 then begin
              temp:=files[j];
              files[j]:=files[j+1];
              files[j+1]:=temp;
           end;
         end;
     end;
END;
{}
{
        Get the files from DOS, that match the MASK to search for

        Expects: an empty VAR wich will be filled with the amount of files
        Returns: see last line!
}
PROCEDURE get_files(var amfile:integer);
VAR i,k      : integer;
    dirinfo  : searchrec;
BEGIN
   i:=0;
   k:=i;
   findfirst(mask, $3f, dirinfo);
   while doserror=0 do begin
         inc(i);
         files[i]:=dirinfo.name;
         findnext(dirinfo);
   end;
   amfile:=i+1;
   {
     Now let's sort the list alphabetical!
   }
   sort_it(k,amfile-1);
END;
{}
{
      Add file's found to the .XAS file

      Expects: Nothing
      Returns: Nothing
}
PROCEDURE GO_ADD;
VAR  NUMREAD,NUMWRITTEN : word;
     x,y                : word;
     entries            : word;
     datamem            : longint;
     tid                : string[6];
     msize,
     size               : longint;
     path               : string;
     DirInfo            : searchrec;
     search1,search2    : string;
     k,
     amfile             : integer;
     i,
     errors             : byte;
     skip               : boolean;      {if a key allready exists}

   {}
   {
       Get the name only (so loose the extension)

       Expects: full filename string (name.ext)
       Returns: the name only (name, and loose the .EXT)
   }
   FUNCTION Nonly(name:string):string;  {only the name of a file}
   VAR x : integer;
   BEGIN
      x:=pos('.',name);
      if x=0 then name:=copy(name,1,length(name))
         else name:=copy(name,1,x-1);
      x:=length(Name);
      while (name[x]<>'\') and (x>0) do dec(x);
      nonly:=copy(name,x+1,length(name));
   END;
   {}
   {
      Get the extension only (so loose the name)

      Expects: full filename string (name.ext)
      Returns: the extension only (.EXT, and loose the NAME)
   }
   FUNCTION Eonly(name:string):string;  {only the extension of a file}
   VAR x : integer;
   BEGIN
      x:=pos('.',name);
      if x=0 then Eonly:=''
         else Eonly:=copy(name,x+1,length(name)-x);
   END;

   {}
   {
       Begin the GO_ADD procedure

   }
   {}
BEGIN
  {

    See if file exists

  }
  DataMem:=0;
  write('Searching for file :');
  if not seefile(filename) then begin
     writeln('Not Found');
     write('creating new file:');
     entries:=0;
     assign(f1,filename); rewrite(f1,1);        write('.');
     blockwrite(f1,id[1],5);                    write('.');
     blockwrite(f1,entries,sizeof(entries));    write('.');
     blockwrite(f1,datamem,sizeof(datamem));    write('.');
     close(f1);                                 write('.');
     writeln('ok');
  end else writeln('ok');

  write('reading entries:');
  assign(f1,filename); reset(f1,1);             write('.');
  blockread(f1,entries,sizeof(entries));        write('.');
  blockread(f1,datamem,sizeof(datamem));        write('.');
  writeln('ok');

  {

    Put MASK into UPPER case only

  }
  for x:=0 to length(mask) do mask[x]:=upcase(mask[x]);
  {

    Find mask files

  }
  write('Searching for infile(s) :');
  get_files(amfile);                                            write('.');
  path:=mask;                                                   write('.');
  x:=length(path);                                              write('.');
  while (path[x]<>'\') and (x>0) do dec(x);                     write('.');
  path:=copy(path,1,x);                                         write('.');
  k:=1;                                                         write('.');
  writeln('ok');

  repeat
     dirinfo.name:=files[k];
     for x:=0 to length(dirinfo.name) do dirinfo.name[x]:=upcase(dirinfo.name[x]);

     search1:=Nonly(mask); { get name }
     search2:=Eonly(mask); { get extension }
     if (wildcomp(Nonly(dirinfo.name),Nonly(mask))) and { check with filemask }
        (wildcomp(Eonly(dirinfo.name),Eonly(mask))) then begin { ok! }

        write('Reading PCX :');
        if not decode(path+files[k],sprite) then begin
           write('*** error occured ***');
           writeln(gfx_error);
           exit;
        end else write('.');
        writeln('ok');
        write('Processing file :'+files[k]);

        if (dirinfo.attr<>$10) and (files[k]<>filename) and (files[k]<>'tmplib.$00') then begin
           assign(f1 , filename); reset(f1,1);                     write('.');
           assign(TEMP, 'tmplib.$00'); rewrite(TEMP,1);            write('.');
           blockread(f1 ,tid[1],5);                                write('.');
                 tid[0]:=#5;                                       write('.');
                 if tid<>id then begin
                    writeln('*** error occured ***');
                    writeln('Not a XASv3 file');
                    exit;
                 end;
                 {

                  Now we get the old values of the file

                 }
                 blockread(f1 ,entries, sizeof(entries));          write('.');
                 inc(entries); { increase amount of images in file}write('.');
                 blockread(f1 ,datamem, sizeof(datamem));          write('.');
                 inc(Datamem,(sprite.dtx*sprite.dty)+1);           write('.');
                 {
                   Write the ID to the TEMP file
                 }
                 blockwrite(temp,id[1],5);                         write('.');
                 {
                   And write the new amount of entires
                 }
                 blockwrite(temp,entries, sizeof(entries));        write('.');
                 blockwrite(temp,datamem, sizeof(datamem));        write('.');
                 {
                   Copy old data
                 }
                 if entries<>1 then begin
                    repeat
                       blockread(f1, bcopy1,  sizeof(bcopy1),numread);
                       blockwrite(temp,    bcopy1,  numread       ,numwritten)
                    until (numread=0) or (numwritten <> numread);
                 end;
                 x:=0;
                 i:=0;
                 blockwrite(temp,sprite.dtx,2);                    write('.');
                 blockwrite(temp,sprite.dty,2);                    write('.');
                 blockwrite(temp,i,1); { fraMES amount }           write('.');
                 blockwrite(temp,i,1); { Animation speed }         write('.');
                 blockwrite(temp,i,1); { Animation cycle }         write('.');
                 blockwrite(temp,mem[seg(sprite.adr^):ofs(sprite.adr^)+2],sprite.dtx*sprite.dty); write('.');

                 close(temp);          { close temporary file }
                 close(f1);            { close library-file   }

                 {
                   COPY TEMP TO LIB
                 }
                 erase(f1);                                        write('.');
                 rename(temp,filename);                            write('.');
                 writeln('ok');
         freemem(sprite.adr,(sprite.dtx*sprite.dty)+2);
    end;
   end;
   inc(k);
  until k>amfile;

  writeln;
  writeln('File information for ',filename);
  writeln('---------------------------------------');
  writeln('Entries    : ',entries);
  writeln('DataMemory : ',datamem);
  exit;
END;
{}
BEGIN

 filename:='';
 mask:='*.pcx';

 if paramcount<2 then begin
    writeln('USAGE:  PCX2XAS <outfilename> <infile>');
    writeln('   SYNTAX: ');
    writeln('       outfilename       the name of the XAS file');
    writeln('       infile            files to include, wildcards allowed');
    writeln('                          for example: block*.pcx');
    writeln;
    halt;
 end;

 port[$03c8]:=0; Port[$03c9]:=0; Port[$03c9]:=0;  Port[$03c9]:=0;
 port[$03c8]:=7; Port[$03c9]:=36; Port[$03c9]:=30; Port[$03c9]:=37;
 port[$03c8]:=5; port[$03c9]:=16; Port[$03c9]:=5; Port[$03c9]:=17;
 textcolor(7); textbackground(0); clrscr;
 Do_Mnu(1,1,80,25,'SpriteConverter '+version+' program by P.Bestebroer','',7,5);
 window(2,4,79,24);
 TextColor(7); TextBackground(5);

 filename:=paramstr(1);
 mask:=paramstr(2);

 if filename='' then begin
    writeln('No outfile selected');
    halt(1);
 end;
 if mask='' then begin
    writeln('No infile selected');
    halt(1);
 end;

 writeln('OutFile (XAS) : ',filename);
 writeln('InFile  (PCX) : ',mask);
 writeln;

 Go_Add;
 writeln;

 while keypressed do readkey;
 writeln('*** press a key ***');

 repeat until keypressed;

 asm
  mov ax,$03
  int 10h
 end;
 window(1,1,80,25);
 textcolor(7); textbackground(0); clrscr;

END.
