PROGRAM SETUP;

{
                Setup program
                programming by P.Bestebroer
                Can be used with the SuperFX Engine

                Simple setup program, modelled after the DOOM II setup
                from ID software.

                How it works:

                Each menu is made out from a list of items...
                You call the GETMENUINFO with this list. GETMENUINFO will
                then return the value of the item choosen..

                EXAMPLE:  you got a list containing: 'keyboard'
                                                     'joystick'
                                                     'mouse'
                Now the user select KEYBOARD, so getmenuinfo will return
                the value of '1'.
                Now you'r program should read in these values, and since you
                know the order of the list, you know witch input device should
                be used...simple huh!

}

USES CRT,DOS;

{

                    These are the configuration settings

}
CONST ControlType : string = 'Keyboard';
      MusicCard   : string = 'None';
      SoundCard   : string = 'None';

      CFGFile     : string = 'default.cfg'; { File name of config file       }

      ControlTV   : byte   = 1;             { control type                   }
      SoundCardV  : byte   = 1;             { Soundcard Value                }
      PortV       : byte   = 1;             { PORT of soundcard              }
      IRQV        : byte   = 1;             { IRQ of soundcard               }
      DMAV        : byte   = 1;             { DMA of soundcard               }
      SampleV     : byte   = 1;             { sample rate                    }
      {  Key configuration }
      LeftV       : byte   = 75;            { key for left-movement          }
      RightV      : byte   = 77;            { key for right-movement         }
      UpV         : byte   = 29;            { key for up-movement            }
      DownV       : byte   = 80;            { key for down-movement          }
      {  Joystick Configuration }
      JoyLeft     : byte   = 1;             { value of joystick for left     }
      JoyRight    : byte   = 2;             { value of joystick for right    }
      JoyDown     : byte   = 3;             { value of joystick for down     }
      JoyUp       : byte   = 5;             { value of joystick for up       }
{

                       The options for the menu

}
TYPE   PMenuItem = ^TMenuItem;
       TMenuItem = record
           Item      : string;    { name of item, as shown in the menu       }
           Describe  : string;    { description of item, for bottom line     }
           next      : PMenuItem; { pointer to next item in list             }
       end;

CONST  MIDX            : byte = 40;
       MIDY            : byte = 16;
       MainOptions     : PMenuItem = NIL;       { main menu                  }
       MainOptionsNR   : byte = 0;
       MusicOptions    : PMenuItem = NIL;       { music-card selecting       }
       MusicOptionsNR  : byte = 0;
       PortOptions     : PMenuItem = NIL;       { music-card ports           }
       PortOptionsNR   : byte = 0;
       IRQOptions      : PMenuItem = NIL;       { music-card IRQ's           }
       IRQOptionsNR    : byte = 0;
       DMAOptions      : PMenuItem = NIL;       { music-card DMA's           }
       DMAOptionsNR    : byte = 0;
       ControlOptions  : PMenuItem = NIL;       { control device selecting   }
       ControlOptionsNR: byte = 0;
       SampleOptions   : PMenuItem = NIL;       { sample-rate selecting      }
       SampleOptionsNR : byte = 0;
       SaveOptions     : PMenuItem = NIL;       { save config yes/no         }
       SaveOptionsNR   : byte = 0;
       ConfigOptions   : PMenuItem = NIL;       { controls configure setting }
       ConfigOptionsNR : byte = 0;
       KeysOptions     : PMenuItem = NIL;       { keyboard configuration     }
       KeysOptionsNR   : byte = 0;
       JoyOptions      : PMenuItem = NIL;       { joystick configuration     }
       JoyOptionsNR    : byte = 0;
       DirOptions      : PMenuItem = NIL;       { direction list for joystick}
       DirOptionsNR    : byte = 0;
{}
FUNCTION GetItem(First:PMenuItem;nr:byte):string; FORWARD;
FUNCTION ChangeItem(First:PMenuItem;nr:byte;newtext:string):string; FORWARD;
{}
CONST Version = $001;
      Title   = ' Setup version 0.1                                   (c)Copyright 1996 Just4Fun ';
      Quit    : boolean = FALSE;  { quit the setup program?                  }
      DoSave  : boolean = FALSE;  { still need to save the config?           }
{

                  These variables are used for the menu selecting

}
VAR i,remember      : byte;     { some handy values                          }
    mainlast        : byte;     { last option chosen in main menu            }
    LastNumber      : byte;     { last number gotten from the GETMENUINFO    }
    OLDSCREEN       : array[1..85,1..100] of word; { save old-screen image   }
{

                            Keyboard variables

}
Const  EscKey = 1;      { these are just some constants... }
       Down   = 80;     { the most important keys in games }
       Up     = 72;     { are the arrow keys, and the }
       Left   = 75;     { control+alt keys... }
       Right  = 77;
       CTRL   = 29;
       ALT    = 56;
       RETURN = 28;

       key_p  = 25;

       key_0  = 11;
       key_1  = 1;
       key_2  = 2;
       key_3  = 3;
       key_4  = 4;
       key_5  = 76;
       key_6  = 7;
       key_7  = 8;
       key_8  = 9;
       key_9  = 10;

       KeyName : array[1..83] of string[10] = (
           'Esc','1','2','3','4','','6','7','8','9','0','_','=','BckSpace',
           'Tab','Q','W','E','R','T','Y','U','I','O','P','[',']','Return',
           'Ctrl','A','S','D','F','','H','J','K','L',';','"','`','Left Shift',
           '\','Z','X','C','V','B','N','M',',','.','/','Right Shift','*',
           'AlT','Space','Caps Lock','F1','F2','F3','F4','F5','F6','F7','F8',
           'F9','F10','Num Lock','Scroll Lock','Home','Up','Pg Up','-','Left',
           '5','Right','+','End','Down','Pg Down','Ins','Del');

VAR   key             : array[1..127] of boolean; { to store the key-presses }
      ExitSave        : pointer;        { pointer to switch between INTs    }
      anypressed      : boolean;        { see if any key was pressed        }
      OldInt09        : pointer;        { old keyboard interupt             }
      KeyDelay        : word;
{}
{
       Restore the old keyboard interupt

       Expects: Nothing
       Returns: Nothing
}
PROCEDURE RestoreInt09 ;
BEGIN
  ExitProc := ExitSave ;
  SetIntVec( $09, OldInt09 ) ;
  exitsave:=NIL;
END;
{}
{
       Put in the new keyboard interrupt

       Expects: Nothing
       Returns: Nothing
}
PROCEDURE NewInt09; INTERRUPT; ASSEMBLER;
ASM
  STI

  xor ch,ch             { set CH to 0, we're using bytes here! }

  mov dx,$60            { set DX to port $60 (keyboard port) }
  in al,dx              { get byte from keyboard }
  mov cl,al             { put it in CL for usage }
  and cl,$7f            { and CL with 127 (MOD 128) }

  mov bx,offset key     { get offset of the KEY array of booleans }
  dec bx
  add bx,cx             { add keyfound to BX }
  mov si,bx             { put calculated offset in DS:[SI] }

  shr al,7              { divide AL with 128 }
  xor al,1
  mov [si],al           { put TRUE or FALSE in array position of keyfound }
  mov anypressed,al     { set ANYPRESSED to TRUE or FALSE }
  mov dx,$61
  in al,dx              { get byte from the port }
  mov cl,al
  or al,$80
  out dx,al
  mov al,cl
  out dx,al
  cli

  mov ax,$20
  mov dx,$20
  out dx,ax
END;
{}
{
       Initialise the keyboard interupt

       Expects: Nothing
       Returns: Nothing
}
PROCEDURE InitInt09;
VAR n : byte;
BEGIN
  if exitsave<>NIL then exit;   { allready installed }
  ExitSave := ExitProc ;
  ExitProc := addr( RestoreInt09 ) ;
  GetIntVec( $09, OldInt09 ) ;
  SetIntVec( $09, addr( NewInt09 ) ) ;
  For N := 1 to 127 do Key[ N ] := False ;
END;
{

                            Save the Configuration

}
{
      Save the configuration

      Expects: Nothing
      Returns: Nothing
}
PROCEDURE SaveCFG;
VAR f  :  file;
BEGIN
  assign(f,CFGFile); rewrite(f,1);
      blockwrite(f,controlTV,1);
      blockwrite(f,SoundCardV,1);
      blockwrite(f,PortV,1);
      blockwrite(f,IRQV,1);
      blockwrite(f,DMAV,1);
      blockwrite(f,SAMPLEV,1);
      blockwrite(f,leftV,1);
      blockwrite(f,rightV,1);
      blockwrite(f,downV,1);
      blockwrite(f,UpV,1);
      blockwrite(f,Joyleft,1);
      blockwrite(f,Joyright,1);
      blockwrite(f,Joydown,1);
      blockwrite(f,Joyup,1);
  close(f);
END;
{}
{
      Load the configuration

      Expects: Nothing
      Returns: Nothing
}
PROCEDURE LoadCFG;
VAR f  :  file;
BEGIN
  assign(f,CFGFile);
  {$I-}
    reset(f,1);
  {$I+}
   if ioresult<>0 then exit;
      if not eof(f) then blockread(f,controlTV,1);
      if not eof(f) then blockread(f,SoundCardV,1);
      if not eof(f) then blockread(f,PortV,1);
      if not eof(f) then blockread(f,IRQV,1);
      if not eof(f) then blockread(f,DMAV,1);
      if not eof(f) then blockread(f,SAMPLEV,1);
      if not eof(f) then blockread(f,leftV,1);
      if not eof(f) then blockread(f,rightV,1);
      if not eof(f) then blockread(f,downV,1);
      if not eof(f) then blockread(f,UpV,1);

      if not eof(f) then blockread(f,JoyLeft,1);
      if not eof(f) then blockread(f,JoyRight,1);
      if not eof(f) then blockread(f,JoyDown,1);
      if not eof(f) then blockread(f,JoyUp,1);
  close(f);

  { Set the correct string }
  ControlType:=GetItem(ControlOptions,ControlTV);
  SoundCard:=GetItem(MUSICOptions,SoundCardv);
  ChangeItem(KeysOptions,1,'Left   : '+KeyName[leftV]);
  ChangeItem(KeysOptions,2,'Right  : '+KeyName[rightV]);
  ChangeItem(KeysOptions,3,'Down   : '+KeyName[DownV]);
  ChangeItem(KeysOptions,4,'Up     : '+KeyName[upV]);
  ChangeItem(JoyOptions,1,'Left   : '+GetItem(DirOptions,Joyleft));
  ChangeItem(JoyOptions,2,'Right  : '+GetItem(DirOptions,JoyRight));
  ChangeItem(JoyOptions,3,'Down   : '+GetItem(DirOptions,JoyDown));
  ChangeItem(JoyOptions,4,'Up     : '+GetItem(DirOptions,JoyUp));
END;

{}
{
        Create a menu linked-list

        Expects: name of item in menu, description of item, and pointer
                 to next in list
        Returns: pointer to first in list
}
FUNCTION AddItem(itemS,DescribeS:string;ANext:PMenuItem):PMenuItem;
VAR temp : PMenuItem;
BEGIN
  temp:=new(PMenuItem);
  AddItem:=Temp;
  with Temp^ do begin
       Item:=ItemS;
       Describe:=DescribeS;
       Next:=ANext;
  end;
END;
{}
{
        Get the description of an item in the linked list

        Expects: Pointer to first of list, and number you wish to update
        Returns: the text of the item
}
FUNCTION GetItem(First:PMenuItem;nr:byte):string;
VAR temp : PMenuItem;
    i    : byte;
    done : boolean;
BEGIN
  temp:=First;
  done:=false;
  i:=1;
  while (Temp<>NIL) and (not done) do begin
       if i=nr then begin
          GetItem:=temp^.item;
          done:=true;
       end else inc(i);
       temp:=temp^.next;
  end;
END;
{}
{
        Update the description of an item in the linked list

        Expects: Pointer to first of list, number of item you wish to change
                 and the text to change it to.
        Returns: the text of the item
}
FUNCTION ChangeItem(First:PMenuItem;nr:byte;newtext:string):string;
VAR temp : PMenuItem;
    i    : byte;
    done : boolean;
BEGIN
  temp:=First;
  done:=false;
  i:=1;
  while (Temp<>NIL) and (not done) do begin
       if i=nr then begin
          while length(newtext)<length(temp^.item) do newtext:=newtext+' ';
          Temp^.item:=newtext;
          done:=true;
       end else inc(i);
       temp:=temp^.next;
  end;
END;

{}
{
        Wait for a vertical retrace of the vga/monitor

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE Retrace; Assembler;
ASM
    MOV DX,$3DA
 @WaitEnd:
    IN AL,DX
    TEST AL,8
    JNZ @WaitEnd
 @WaitStart:
    IN AL,DX
    TEST AL,8
    JZ @WaitStart
END;


{}
{
        Hide the cursor

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE HideCursor;  ASSEMBLER;
ASM
  mov ax,$0100
  mov cx,$2607
  int 10h
END;
{}
{
        Show the cursor

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE SHOWCURSOR; ASSEMBLER;
ASM
  mov ax,$0100
  mov cx,$0506
  int 10h
END;
{}
{
        Write Text

        Expects: X,Y position of the text, and the text-string
                 and the forground+background color
        Returns: Nothing
}
PROCEDURE TWRITE(x,y:word;text:string;col1,col2:byte);
BEGIN
 ASM
   dec x
   dec y
   lea di,text
   mov bx,di

   mov es,segb800       { get screen segment }
   mov di,y             { get Y position }
   mov ax,di
   shl di,7             { multiply with 7... }
   shl ax,5             { and with 32        }
   add di,ax            { add together= Y*160}
   mov ax,x             { get X position }
   shl ax,1             { multiply with 2 }
   add di,ax            { add to screen offset }

   mov ah,col2          { get background color }
   shl ah,4             { multiply with 16     }
   add ah,col1          { add forground color  }

   mov DX,DS            { remember DX          }

   mov cx,ss
   mov ds,cx
   mov si,bx

   lodsb                { read length of string }
   xor ch,ch
   mov cl,al            { set length into CL    }
   cmp cl,0
   je @NoSet            { if no text, skip writing }

  @TLoop:
   LODSB                { load character }
   STOSW                { store character+color }
   dec cl               { decrease length counter }
   jnz @TLoop
  @NoSet:
   mov DS,DX            { get DX back }
 END;
END;
{}
{
        Read from screen coordinates

        Expects: X+Y position to read from
        Returns: Character at the specified position
}
FUNCTION TRead(x,y:word):char; Assembler;
ASM
  dec x
  dec y
  mov ax,y      { get Y positions...                                         }
  mov bx,ax     { ...in AX and BX                                            }
  shl ax,7      { multiply Y with 128...                                     }
  shl bx,5      { ... and with 32                                            }
  add ax,bx     { add together = Y*160                                       }
  mov bx,x      { get X position                                             }
  shl bx,1      { multiply with 2                                            }
  add ax,bx     { add to offset                                              }

  mov DX,DS     { remember DS                                                }
  mov ds,segb800{ get screen segment                                         }
  mov si,ax     { get screen offset in si                                    }

  lodsb         { load character                                             }
  mov DS,DX     { get DS back                                                }
END;
{}
{
        Center text between 2 X values

        Expects: right,left positions, and the text to be centered
        Returns: The left-starting position to start writing
}
FUNCTION CENTER(x2,x1:integer;zin : string):integer;
BEGIN
 center:=x1+((x2-x1) shr 1)-(length(zin) shr 1)+1;
END;
{}
{
        Center some lines between 2 Y values

        Expects: number of lines,
                 top, bottom positions
        Returns: The Top-starting position to start writing
}
FUNCTION CENTER_Y(n,y1,y2:integer):integer;
BEGIN
 center_Y:=y1+((y2-y1) shr 1)-(n shr 1);
END;
{}
{
        Draw a menu box

        Expects: Corner positions, title of box, forground+background color
        Returns: Nothing
}
PROCEDURE do_mnu(x1,y1,x2,y2:integer;title,title2:string;c1,c2:integer);
VAR x3,y3          : integer;
    zin            : string[80];
    frontcol       : byte;
BEGIN
 zin:='';
 for x3:=1 to x2-x1+1 do zin:=zin+' ';
 for y3:=y1 to y2 do Twrite(x1,y3,zin,c1,c2);

 for x3:=x1 to x2 do begin
  Twrite(x3,y1,'',c1,c2);
  Twrite(x3,y2,'',c1,c2);
 end;
 for y3:=y1 to y2 do begin
   Twrite(x1,y3,'',c1,c2);
   Twrite(x2,y3,'',c1,c2);
 end;
 Twrite(x2,y1,'',c1,c2);
 Twrite(x2,y2,'',c1,c2);
 Twrite(x1,y1,'',c1,c2);
 Twrite(x1,y2,'',c1,c2);
 if x2+1<81 then begin
   for y3:=y1+1 to y2+1 do if y3<26 then twrite(x2+1,y3,tread(x2+1,y3),8,0);
 end;
 if y2+1<26 then begin
   for x3:=x1+1 to x2+1 do if x3<81 then twrite(x3,y2+1,tread(x3,y2+1),8,0);
 end;

 IF Title<>'' then begin
    for x3:=x1+1 to x2-1 do Twrite(x3,y1+2,'',c1,c2);
    Twrite(x1,y1+2,'',c1,c2);
    Twrite(x2,y1+2,'',c1,c2);
    Twrite( x1+1,y1+1,copy(zin,1,length(zin)-2),c2,7);
    Twrite( center(x1+1,x2-1,title) ,y1+1,title,c2,7);
 end;

 IF Title2<>'' then begin
    for x3:=x1+1 to x2-1 do Twrite(x3,y2-2,'',c1,c2);
    Twrite(x1,y2-2,'',c1,c2);
    Twrite(x2,y2-2,'',c1,c2);

    frontcol:=10;
    for x3:=1 to length(title2) do begin
        Twrite(center(x1+1,x2-1,title2)+x3-1 ,y2-1,copy(title2,x3,1),FrontCol,c2);
        if copy(title2,x3,1)='=' then frontcol:=15;
        if copy(title2,x3,1)=' ' then frontcol:=10;
    end;
 end;
END;
{}
{
        "Pop-up" a menu box

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE OpenMenu(x1,y1,x2,y2:integer;c1,c2:Byte);
VAR  xx1,xx2,yy1,yy2 : word;
BEGIN
  xx1:=x1+((x2-x1) shr 1);
  yy1:=y1+((y2-y1) shr 1);
  xx2:=x1+((x2-x1) shr 1);
  yy2:=y1+((y2-y1) shr 1);
  repeat
    Retrace;
    Do_Mnu(xx1,yy1,xx2,yy2,' ',' ',c1,c2);
    if xx1>x1 then dec(xx1) else xx1:=x1;
    if yy1>y1 then dec(yy1) else yy1:=y1;
    if xx2<x2 then inc(xx2) else xx2:=x2;
    if yy2<Y2 then inc(yy2) else yy2:=y2;
  until (xx1=x1) and (xx2=x2) and (yy1=y1) and (yy2=y2);
END;
{}
{
        Initialise the new palette

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE InitPal;
BEGIN
  port[$03c8]:=1; port[$03c9]:=04; port[$03c9]:=03; port[$03c9]:=19;
END;
{}
{
        This will draw the background screen

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE FillScreen; Assembler;
ASM
   mov es,segb800
   xor di,di
   
   mov ah,120
   mov al,177
   mov cx,ax
   DB $66
   shl ax,16
   mov ax,cx

   mov cx,1000
   DB $66
   REP STOSW
END;
{}
{
        Type the top bar

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE DrawTop;
VAR zin : string[82];
BEGIN
 zin:='';
 fillchar(zin,81,' ');
 zin[0]:=#80;
 Twrite(1,1,zin,0,7);
 Twrite(1,1,Title,0,7);
 Twrite(1,25,zin,0,7);
END;
{}
{
        This will show the current config selections

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE UpdateCurrentConfig;
BEGIN
  Do_Mnu(19,3,61,8,'A','',8,7);
  Twrite(20,4,'Current Configuration:',8,7);
  Twrite(20,6,'Control Type :'+ControlType,8,7);
  Twrite(20,7,'Sound Card   :'+SoundCard,8,7);
END;
{}
PROCEDURE save_old_scrn(x1,y1,x2,y2:longint);
VAR x3,y3 : word;
    i,
    x4    : byte;
begin
 inc(x2); inc(y2);
 i:=0;
 for y3:=y1-1 to y2 do begin
   move(mem[$b800:y3*160+((x1-1) shl 1)],oldscreen[x1,(y1+i)*160],((x2-x1+1) shl 1));
   inc(i);
 end;
END;
{}
PROCEDURE restore_old_scrn(x1,y1,x2,y2:longint);
VAR x3,y3,x4,i : word;
BEGIN
 inc(x2); inc(y2);
 i:=0;
 for y3:=y1-1 to y2 do begin
  move(oldscreen[x1,(y1+i)*160],mem[$b800:y3*160+(x1-1)*2],(x2-x1+1)*2);
  inc(i);
 end;
END;
{}
{
        This will: pop-up a menu, wait until the player selects
                   something, and then return the value of the option.

        Expects: Title of the menu, title of the bottom line in the
                 menu ,List of options, and the amount of options in the list.
                 Also a number of the current choice to start with
                 and ERASE specifies if it should be erased after calling.
        Returns: Number of selection (0 = escape)
}
FUNCTION GetMenuInfo( Title1,title2:string;
                      OptionsList:PMenuItem;
                      Options:byte;
                      cc:byte;
                      remember,erase,POPWINDOW,NoWait:Boolean):byte;
VAR CurrentChoice : byte;
    done          : boolean;
    add           : byte;
    zin           : string;
    fulline       : string;
    temp          : PMenuItem;
    MenuX1,MenuX2 : byte;     { Xposition of current menu }
    MenuY1,MenuY2 : byte;

{==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
     PROCEDURE UpdateMenu;
     VAR i    :   byte;
     BEGIN
        Twrite(1,25,fulline,0,7);
        temp:=OptionsList;
        i:=0;
        while temp<>nil do begin
            if i=CurrentChoice-1 then begin
                  Twrite(MenuX1+2,MenuY1+3+i,zin,1,7);
                  Twrite(MenuX1+2,MenuY1+3+i,temp^.item,0,7);
                  Twrite(2,25,temp^.Describe,8,7);
            end else begin
               Twrite(MenuX1+2,MenuY1+3+i,zin,15,1);
               Twrite(MenuX1+2,MenuY1+3+i,temp^.item,15,1);
            end;
            inc(i);
            temp:=temp^.next;
        end;
     END;
{==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}

BEGIN
 fulline:='';
 fillchar(fulline,81,32);
 fulline[0]:=#80;
 {

   Define and Show the Menu

 }
 MenuX1:=length(title1)+2;
 if length(title2)+2>menuX1 then menuX1:=length(title2)+2;
 temp:=OptionsList;
 i:=0;
 while temp<>NIL do begin
     if length(temp^.item)>MenuX1 then MenuX1:=length(temp^.item);
     temp:=temp^.next;
     inc(i);
 end;
 inc(MenuX1,4);
 MenuX2:=MIDX+(menuX1 shr 1);
 MenuX1:=MIDX-(menuX1 shr 1);
 if title2<>'' then add:=5 else add:=3;
 MenuY1:=MIDY-((Options+add) shr 1);
 MenuY2:=MIDY+((Options+add) shr 1);
 if menuY2-menuY1-add<Options then inc(MenuY2);

 zin:='';
 while length(zin)<menux2-menux1-3 do zin:=zin+' ';

 if remember then save_old_scrn(menux1,menuy1,menux2,menuy2);
 if POPWINDOW then OpenMenu(menuX1,menuY1,menuX2,menuY2,11,1);
 Do_Mnu(MenuX1,MenuY1,MenuX2,MenuY2,title1,title2,11,1);
 {

   Update Options list

 }
 CurrentChoice:=cc;
 UpdateMenu;
 done:=false;

 if NOT NoWait then begin
   REPEAT
     Retrace;
     if KeyDelay>0 then Dec(KeyDelay) else begin
        if key[79] then begin
           KeyDelay:=10;
           CurrentChoice:=options;
           UpdateMenu;
        end;
        if key[71] then begin
           KeyDelay:=10;
           CurrentChoice:=1;
           UpdateMenu;
        end;
        if key[down] then begin
           KeyDelay:=10;
           inc(CurrentChoice);
           if getitem(OptionsList,CurrentChoice)='' then begin
              if CurrentChoice<Options then inc(CurrentChoice) else Dec(CurrentChoice);
           end;
           if CurrentChoice>Options then CurrentChoice:=Options;
           UpdateMenu;
        end;
        if key[up] then begin
           KeyDelay:=10;
           dec(CurrentChoice);
           if getitem(OptionsList,CurrentChoice)='' then begin
              if currentchoice>1 then dec(CurrentChoice) else inc(CurrentChoice);
           end;
           if CurrentChoice=0 then CurrentChoice:=1;
           UpdateMenu;
        end;
        if key[return] then begin
           KeyDelay:=10;
           Done:=true;
           GetMenuInfo:=CurrentChoice;
           LastNumber:=CurrentChoice;
        end;
        if key[esckey] then begin
           KeyDelay:=10;
           Done:=true;
           GetMenuInfo:=0;
           LastNumber:=0;
        end;
     end;
   UNTIL Done;
 end;
 if erase then restore_old_scrn(menux1,menuy1,menux2,menuy2);
END;
{}
{
        Ask for a KEY from the user

        Expects: Nothing
        Returns: Value of key pressed
}
FUNCTION AskKey(Question:String):byte;
VAR i : byte;
BEGIN
  while anypressed do;
  save_old_scrn(35-(length(Question) shr 1),17,45+(length(Question) shr 1),19);

  Do_Mnu(35-(length(Question) shr 1),17,45+(length(Question) shr 1),19,'','',8,7);
  Twrite(40-(length(question) shr 1),18,Question,1,7);
  repeat until anypressed;
  askkey:=port[$60];
  for i:= 1 to 82 do begin
      if key[i] then begin
         AskKey:=i;
      end;
  end;

  restore_old_scrn(35-(length(Question) shr 1),17,45+(length(Question) shr 1),19);
END;
{}
BEGIN
 MainOptions:=AddItem('Select Sound Card','Select the sound card for music and soundFX',
              AddItem('Select Controller type','Select the controller type ( JOYSTICK/KEYBOARD )',
              AddItem('Controller Config','Configurate the controlls ( JOYSTICK/KEYBOARD )',
              AddItem('Set sound quality','Set the sound quality of the digital music',
              AddItem('','',
              AddItem('Save Settings and exit','Save current settings, and exit back to DOS',
              NIL))))));
 MainOptionsNR:=6;

 MusicOptions:=AddItem('None','Select for No sound music',
               AddItem('SoundBlaster1.0','Select for SoundBlaster MONO 1.0',
               AddItem('SoundBlaster2.0','Select for SoundBlaster MONO 2.0',
               AddItem('SoundBlaster Pro','Select for SoundBlaster PRO',
               AddItem('SoundBlaster 16/AWE 32','Select for SoundBlaster 16 or AWE 32',
               AddItem('Pro Audio Spectrum','Select for the Pro Audio Spectrum',
               AddItem('Gravis Ultrasound','Select for Gravis Ultrasound',
               NIL)))))));
 MusicOptionsNR:=7;
 PortOptions:=AddItem('210','Use PORT at 210',
              AddItem('220','Use PORT at 220',
              AddItem('230','Use PORT at 230',
              AddItem('240','Use PORT at 240',
              AddItem('250','Use PORT at 250',
              AddItem('260','Use PORT at 260',
              AddItem('270','Use PORT at 270',
              AddItem('280','Use PORT at 280',
              AddItem('Autodetect','Autodetect for the port at startup',
              NIL)))))))));
 PortOptionsNR:=9;

 IRQOptions:=AddItem('2','Use IRQ 2',
             AddItem('5','Use IRQ 5',
             AddItem('7','Use IRQ 7',
             AddItem('Autodetect','Autodetect for the IRQ at startup',
             NIL))));
 IRQOptionsNR:=4;
 DMAOptions:=AddItem('0','Use DMA 0',
             AddItem('1','Use DMA 1',
             Additem('2','Use DMA 2',
             Additem('3','Use DMA 3',
             Additem('4','Use DMA 4',
             Additem('5','Use DMA 5',
             Additem('6','Use DMA 6',
             Additem('7','Use DMA 7',
             Additem('Autodetect','Autodetect for the DMA at startup',
             NIL)))))))));
 DMAOptionsNR:=9;
 ControlOptions:=AddItem('Keyboard','Use the keyboard',
                 AddItem('Gamepad/Joystick','Use a Gamepad or a Joystick',
                 NIL));
 ControlOptionsNR:=2;
 SampleOptions:=AddItem('Low quality','Lowest sample rate ( 11025 )',
                AddItem('Medium quality','Medium sample rate ( 22050 )',
                AddItem('High quality','Highest sample rate ( 44100 )',
                NIL)));
 SampleOptionsNR:=3;
 ConfigOptions:=AddItem('Keyboard','Configure the keyboard keys',
                AddItem('Joystick/Gamepad','Configure the joystick/gamepad',
                NIL));
 ConfigOptionsNR:=2;
 KeysOptions:=AddItem('Left   : Left       ','Key for moving left',
              AddItem('Right  : Right      ','Key for moving right',
              AddItem('Down   : Down       ','Key for moving down',
              AddItem('Up     : Up         ','Key for moving up',
              NIL))));
 KeysOptionsNR:=4;
 JoyOptions:=AddItem('Left   : Joystick Left','Button/Direction for moving left',
             AddItem('Right  : Joystick Right','Button/Direction for moving right',
             AddItem('Down   : Joystick Down','Button/Direction for moving down',
             AddItem('Up     : Joystick Up','Button/Direction for moving up',
             NIL))));
 JoyOptionsNR:=4;
 DirOptions:=AddItem('Joystick Left','When Joystick is pressed left',
             AddItem('Joystick Right','When Joystick is pressed right',
             AddItem('Joystick Down','When Joystick is pressed down',
             AddItem('Joystick Up','When Joystick is pressed up',
             AddItem('Joystick Button 1','When Joystick Button 1 is pressed',
             AddItem('Joystick Button 2','When Joystick Button 2 is pressed',
             AddItem('Joystick Button 3','When Joystick Button 3 is pressed',
             AddItem('Joystick Button 4','When Joystick Button 4 is pressed',
             NIL))))))));
 DirOptionsNR:=8;

 SaveOptions:=AddItem('Yes','Save current configuration',
              AddItem('No','Don''t save changes, just exit',
              NIL));
 SaveOptionsNR:=2;

 InitInt09;
 InitPal;
 FillScreen;
 DrawTop;
 HideCursor;
 {

   Show setup info

 }
 OpenMenu(19,3,61,8,8,7);
 Do_Mnu(19,3,61,8,'A','',8,7);
 Twrite(20,4,'Current Configuration:',8,7);
 LoadCFG;
 UpdateCurrentConfig;
 KeyDelay:=0;

 MainLast:=1;
 DoSave:=false;
 GetMenuInfo('Main Setup Menu','Esc=Exit',MainOptions,MainOptionsNR,MainLast,false,false,true,true);

 REPEAT
   MIDX:=40; MIDY:=16;
   GetMenuInfo('Main Setup Menu','Esc=Exit',MainOptions,MainOptionsNR,MainLast,false,false,false,false);
   MainLast:=LastNumber;
   MIDY:=10;
   case LastNumber of
      0  : Quit:=true;
           1  : BEGIN      { Sound Card Setup }
                    GetMenuInfo('Sound Card Setup','Esc=Exit',MusicOptions,MusicOptionsNR,1,true,true,true,false);
                    if lastNumber<>0 then begin
                       SoundCard:=GetItem(Musicoptions,lastnumber);
                       SoundCardV:=LastNumber;
                       UpdateCurrentConfig;
                       DoSave:=true;
                       if LastNumber>1 then begin
                          GetMenuInfo('Available Ports','Esc=Exit',PortOptions,PortOptionsNR,PORTV,true,true,true,false);
                          if lastnumber<>0 then PortV:=LastNumber;
                          if LastNumber<>0 then begin
                             GetMenuInfo('Available IRQ''s','Esc=Exit',IRQOptions,IRQOptionsNR,IRQV,true,true,true,false);
                             if lastnumber<>0 then IRQV:=LastNumber;
                             if LastNumber<>0 then begin
                                GetMenuInfo('Available DMA''s','Esc=Exit',DMAOptions,DMAOptionsNR,DMAV,true,true,true,false);
                                if lastnumber<>0 then DMAV:=LastNumber;
                             end;
                          end;
                       end;
                    end;
           END;
           2  : BEGIN      { Controller Setup }
                    GetMenuInfo('Controller Setup','Esc=Exit',ControlOptions,ControlOptionsNR,1,true,true,true,false);
                    if lastnumber<>0 then begin
                       ControlType:=GetItem(ControlOptions,LastNumber);
                       ControlTV:=Lastnumber;
                       UpdateCurrentConfig;
                       DoSave:=true;
                    end;
           END;
           3  : BEGIN      { select controller to config }
                    GetMenuInfo('Controller config','Esc=Exit',ConfigOptions,ConfigOptionsNR,1,true,true,true,false);
                    if lastnumber<>0 then begin
                       case LastNumber of
                         1 : BEGIN
                              Save_old_scrn(5,5,75,20);
                              GetMenuInfo( 'Configure Keyboard','Esc=Accept Return=select',
                                           KeysOptions,KeysOptionsNR,LastNumber,false,false,true,true);

                              lastnumber:=1;
                              DoSave:=true;
                               while lastnumber<>0 do begin
                                  case GetMenuInfo( 'Configure Keyboard','Esc=Accept Return=select',
                                                     KeysOptions,KeysOptionsNR,LastNumber,false,false,false,false) of
                                      1 : BEGIN
                                              i:=AskKey('Press key for LEFT');
                                              ChangeItem(KeysOptions,1,'Left   : '+KeyName[i]);
                                              LeftV:=i;
                                      END;
                                      2 : BEGIN
                                              i:=AskKey('Press key for RIGHT');
                                              ChangeItem(KeysOptions,2,'Right  : '+KeyName[i]);
                                              rightV:=i;
                                      END;
                                      3 : BEGIN
                                              i:=AskKey('Press key for DOWN');
                                              ChangeItem(KeysOptions,3,'Down   : '+KeyName[i]);
                                              DownV:=i;
                                      END;
                                      4 : BEGIN
                                              i:=AskKey('Press key for UP');
                                              ChangeItem(KeysOptions,4,'Up     : '+KeyName[i]);
                                              upV:=i;
                                      END;
                                  end; { END CASE GETMENUINFO }
                               end;
                              Restore_old_scrn(5,5,75,20);
                          END;
                         2 : BEGIN
                              Save_old_scrn(5,5,75,20);
                              GetMenuInfo( 'Configure Joystick','Esc=Accept Return=select',
                                           JoyOptions,JoyOptionsNR,LastNumber,false,false,true,true);

                              lastnumber:=1;
                              DoSave:=true;
                              while lastnumber<>0 do begin
                                  GetMenuInfo( 'Configure Joystick','Esc=Accept Return=select',
                                                     JoyOptions,JoyOptionsNR,Lastnumber,false,false,false,false);
                                  remember:=lastnumber;
                                  MIDY:=16;
                                  case LASTNUMBER of
                                      1 : BEGIN
                                              remember:=lastnumber;
                                              i:=JoyLeft;
                                              GetMenuInfo( 'Joystick Directions','Esc=Accept',
                                                           DirOptions,DirOptionsNR,i,true,true,true,false);
                                               if LastNumber>0 then begin
                                                 ChangeItem(JoyOptions,1,'Left   : '+GetItem(DirOptions,Lastnumber));
                                               end;
                                              JoyLeft:=Lastnumber;
                                      END;
                                      2 : BEGIN
                                              remember:=lastnumber;
                                              i:=JoyRight;
                                              GetMenuInfo( 'Joystick Directions','Esc=Accept',
                                                           DirOptions,DirOptionsNR,i,true,true,true,false);
                                               if LastNumber>0 then begin
                                                 ChangeItem(JoyOptions,2,'Right  : '+GetItem(DirOptions,Lastnumber));
                                               end;
                                              JoyRight:=Lastnumber;
                                      END;
                                      3 : BEGIN
                                              remember:=lastnumber;
                                              i:=JoyDown;
                                              GetMenuInfo( 'Joystick Directions','Esc=Accept',
                                                           DirOptions,DirOptionsNR,i,true,true,true,false);
                                               if LastNumber>0 then begin
                                                 ChangeItem(JoyOptions,3,'Down   : '+GetItem(DirOptions,Lastnumber));
                                               end;                                              JoyDown:=Lastnumber;
                                      END;
                                      4 : BEGIN
                                              remember:=lastnumber;
                                              i:=JoyUp;
                                              GetMenuInfo( 'Joystick Directions','Esc=Accept',
                                                           DirOptions,DirOptionsNR,i,true,true,true,false);
                                               if LastNumber>0 then begin
                                                 ChangeItem(JoyOptions,4,'Up     : '+GetItem(DirOptions,Lastnumber));
                                               end;                                              JoyUp:=Lastnumber;
                                      END;
                                  end; { END CASE GETMENUINFO }
                                  LastNumber:=Remember;
                                  MIDY:=10;
                               end;
                              Restore_old_scrn(5,5,75,20);
                          END;

                       END; { end CASE LASTNUMBER }
                 end;
           END;
           4  : BEGIN      { Select sample rate }
                    GetMenuInfo('Sound Quality','Esc=Exit',SampleOptions,SampleOptionsNR,SampleV,true,true,true,false);
                    if Lastnumber<>0 then begin
                       SampleV:=LastNumber;
                    end;
                    DoSave:=true;
           END;
           6  : BEGIN      { Save config? }
                    GetMenuInfo('Save Settings?','Esc=Exit',SaveOptions,SaveOptionsNR,1,true,true,true,false);
                    if Lastnumber=1 then SaveCFG;
                    DoSave:=False;
                    quit:=true;
           END;
   end;
 UNTIL Quit;
 if DoSave then begin
    GetMenuInfo('Save Settings?','Esc=Exit',SaveOptions,SaveOptionsNR,1,true,true,true,false);
    if Lastnumber=1 then SaveCFG;
 end;

 ShowCursor;            { show the cursor again!                             }
 RestoreInt09;          { get old keyboard interrupt back                    }
 TextMode(co80);        { This will also make sure the palette is correct    }
END.