PROGRAM XAS2NEW;
{
             This will make new version of you'r old XAS files

             Programming by P.Bestebroer
             This version is included with the SUPERFX engine.

}
{}
USES Crt, Dos;
{}
CONST version = 'v1.0';                  { Program VERSION }
{}
const blocksize = 40000;                 { Used with copying }
      ID        : string ='XASv3';         { ID of XAS file format }
      GFX_Error  : string = '';          { contains errors of PCX decoding }
{
                    Type of the sprites in this program
}
Type SpriteTyp=Record
       Adr:Pointer;
       dtx,dty    : word;
     End;
{
                            Main variables
}
VAR sprite      : SpriteTyp;
    filename    : string;
    f1,f2,temp  : file;
    files       : array[0..500] of string[12];

    take1,                                 {used in the copy parts}
    take2      : longint;                  {...see above...}
    bcopy1     : array[1..BLOCKSIZE] of byte;  {and again...}

{}
{
        See if a file exists

        Expects: Name of the file
        Returns: TRUE if file exists
}
FUNCTION seefile(name:string):boolean;
VAR f : file;
BEGIN
 seefile:=false;
 assign(f,name);
 {$I-}
  reset(f);
  close(f);
  if ioresult=0 then seefile:=true;
 {$I+}
END;
{}
{
        Write Text

        Expects: X,Y position of the text, and the text-string
                 and the forground+background color
        Returns: Nothing
}
PROCEDURE TWRITE(x,y:word;text:string;col1,col2:byte);
BEGIN
 ASM
   dec x
   dec y
   lea di,text
   mov bx,di

   mov es,segb800       { get screen segment }
   mov di,y             { get Y position }
   mov ax,di
   shl di,7             { multiply with 7... }
   shl ax,5             { and with 32        }
   add di,ax            { add together= Y*160}
   mov ax,x             { get X position }
   shl ax,1             { multiply with 2 }
   add di,ax            { add to screen offset }

   mov ah,col2          { get background color }
   shl ah,4             { multiply with 16     }
   add ah,col1          { add forground color  }

   mov DX,DS            { remember DX          }

   mov cx,ss
   mov ds,cx
   mov si,bx

   lodsb                { read length of string }
   xor ch,ch
   mov cl,al            { set length into CL    }
   cmp cl,0
   je @NoSet            { if no text, skip writing }

  @TLoop:
   LODSB                { load character }
   STOSW                { store character+color }
   dec cl               { decrease length counter }
   jnz @TLoop
  @NoSet:
   mov DS,DX            { get DX back }
 END;
END;
{}
{
        Read from screen coordinates

        Expects: X+Y position to read from
        Returns: Character at the specified position
}
FUNCTION TRead(x,y:word):char; Assembler;
ASM
  dec x
  dec y
  mov ax,y      { get Y positions...                                         }
  mov bx,ax     { ...in AX and BX                                            }
  shl ax,7      { multiply Y with 128...                                     }
  shl bx,5      { ... and with 32                                            }
  add ax,bx     { add together = Y*160                                       }
  mov bx,x      { get X position                                             }
  shl bx,1      { multiply with 2                                            }
  add ax,bx     { add to offset                                              }

  mov es,segb800{ get screen segment                                         }
  mov di,ax     { get screen offset in si                                    }

  mov es:[di],al{ load character                                             }
END;
{}
{
        Center text between 2 X values

        Expects: right,left positions, and the text to be centered
        Returns: The left-starting position to start writing
}
FUNCTION CENTER(x2,x1:integer;zin : string):integer;
BEGIN
 center:=x1+((x2-x1) shr 1)-(length(zin) shr 1)+1;
END;
{}
{
        Draw a menu box

        Expects: Corner positions, title of box, forground+background color
        Returns: Nothing
}
PROCEDURE do_mnu(x1,y1,x2,y2:integer;title,title2:string;c1,c2:integer);
VAR x3,y3          : integer;
    zin            : string[80];
    frontcol       : byte;
BEGIN
 zin:='';
 for x3:=1 to x2-x1+1 do zin:=zin+' ';
 for y3:=y1 to y2 do Twrite(x1,y3,zin,c1,c2);

 for x3:=x1 to x2 do begin
  Twrite(x3,y1,'',c1,c2);
  Twrite(x3,y2,'',c1,c2);
 end;
 for y3:=y1 to y2 do begin
   Twrite(x1,y3,'',c1,c2);
   Twrite(x2,y3,'',c1,c2);
 end;
 Twrite(x2,y1,'',c1,c2);
 Twrite(x2,y2,'',c1,c2);
 Twrite(x1,y1,'',c1,c2);
 Twrite(x1,y2,'',c1,c2);
 if x2+1<81 then begin
   for y3:=y1+1 to y2+1 do if y3<26 then twrite(x2+1,y3,tread(x2+1,y3),8,0);
 end;
 if y2+1<26 then begin
   for x3:=x1+1 to x2+1 do if x3<81 then twrite(x3,y2+1,tread(x3,y2+1),8,0);
 end;

 IF Title<>'' then begin
    for x3:=x1+1 to x2-1 do Twrite(x3,y1+2,'',c1,c2);
    Twrite(x1,y1+2,'',c1,c2);
    Twrite(x2,y1+2,'',c1,c2);
    Twrite( x1+1,y1+1,copy(zin,1,length(zin)-2),c1,c2);
    Twrite( center(x1+1,x2-1,title) ,y1+1,title,c1,c2);
 end;

 IF Title2<>'' then begin
    for x3:=x1+1 to x2-1 do Twrite(x3,y2-2,'',c1,c2);
    Twrite(x1,y2-2,'',c1,c2);
    Twrite(x2,y2-2,'',c1,c2);
    twrite(center(x1+1,x2-1,title2), y2-1,title2,c1,c2);
 end;
END;
{
{
      Add file's found to the .XAS file

      Expects: Nothing
      Returns: Nothing
}
PROCEDURE GO_Update;
VAR  NUMREAD,NUMWRITTEN : word;
     x,y                : word;
     entries            : word;
     datamem            : longint;
     tid                : string[6];
     msize,
     size               : longint;
     path               : string;
     DirInfo            : searchrec;
     search1,search2    : string;
     k,
     amfile             : integer;
     i,
     errors             : byte;
     skip               : boolean;      {if a key allready exists}

   {}
BEGIN
  {
    See if file exists
  }
  DataMem:=0;
  write('Searching for file :');
  if not seefile(filename) then begin
     writeln('Not Found');
     exit;
  end else writeln('ok');

  write('reading entries:');
   assign(f1,filename); reset(f1,1);             write('.');
   blockread(f1 ,tid[1],3);                      write('.');
   tid[0]:=#3;                                   write('.');
   if tid<>'XAS' then begin
                    writeln('*** error occured ***');
                    writeln('Not a XAS file');
                    exit;
   end;

  blockread(f1,entries,sizeof(entries));        write('.');
  writeln('ok');

  datamem:=0;

  write('Reading data amount :');
    for k:=1 to entries do begin
        blockread(f1,x,2);
        blockread(f1,y,2);
        blockread(f1,i,1);
        blockread(f1,i,1);
        blockread(f1,i,1);
        inc(datamem,(x*y)+2);
        blockread(f1,mem[sega000:0],(x*y));
        write('.');
    end;
  writeln('ok');
  close(f1);

  write('Saving new format :');

   assign(f1 , filename); reset(f1,1);                     write('.');
   assign(TEMP, 'tmplib.$00'); rewrite(TEMP,1);            write('.');
   blockread(f1 ,tid[1],3);                                write('.');
   {  Now we get the old values of the file                 }
   blockread(f1 ,entries, sizeof(entries));          write('.');
   {  Write the ID to the TEMP file                         }
   blockwrite(temp,id[1],5);                         write('.');
   {  And write the new amount of entires                   }
   blockwrite(temp,entries, sizeof(entries));        write('.');
   blockwrite(temp,datamem, sizeof(datamem));        write('.');
   {  Copy old data                                         }
   repeat
     blockread(f1, bcopy1,  sizeof(bcopy1),numread);
     blockwrite(temp,    bcopy1,  numread       ,numwritten)
   until (numread=0) or (numwritten <> numread);
   close(temp);          { close temporary file }
   close(f1);            { close library-file   }
   {
                   COPY TEMP TO LIB
   }
   erase(f1);                                        write('.');
   rename(temp,filename);                            write('.');
   writeln('ok');

  writeln;
  writeln('File information for ',filename);
  writeln('---------------------------------------');
  writeln('Entries    : ',entries);
  writeln('DataMemory : ',datamem);
  exit;
END;
{}
BEGIN

 filename:='';

 if paramcount<1 then begin
    writeln('USAGE:  XAS2NEW <filename>');
    writeln('   SYNTAX: ');
    writeln('       filename          the name of the XAS file to be converted');
    writeln;
    halt;
 end;

 port[$03c8]:=0; Port[$03c9]:=0; Port[$03c9]:=0;  Port[$03c9]:=0;
 port[$03c8]:=7; Port[$03c9]:=36; Port[$03c9]:=30; Port[$03c9]:=37;
 port[$03c8]:=5; port[$03c9]:=16; Port[$03c9]:=5; Port[$03c9]:=17;
 textcolor(7); textbackground(0); clrscr;
 Do_Mnu(1,1,80,25,'SpriteConverter '+version+' program by P.Bestebroer','',7,5);
 window(2,4,79,24);
 TextColor(7); TextBackground(5);

 filename:=paramstr(1);

 if filename='' then begin
    writeln('No file selected');
    halt(1);
 end;

 writeln('Filename : ',filename);
 writeln;

 Go_Update;
 writeln;

 while keypressed do readkey;
 writeln('*** press a key ***');

 repeat until keypressed;

 asm
  mov ax,$03
  int 10h
 end;
 window(1,1,80,25);
 textcolor(7); textbackground(0); clrscr;

END.
