PROGRAM XAS_EDIT;

{
        XAS editor (FREEWARE)
        Programmed by P.Bestebroer
        This will edit the XAS file values, for animation purposes.
        It won't load any palette, but uses the standard VGA colors...

        The CHARSET.OBJ file should be included, else you won't see much
        text.

}

USES Crt,Dos;

{}
CONST version = 'V3.0';
      filename : string = '';
      id       : string = 'XASv3';
      quit     : boolean = false;
{}
TYPE Tblock = record
       f_Frame : byte;
       C_FRame : byte;
       a_Frame : byte;
       s_frame : byte;
       t_frame : byte;
       n_frame : shortint;
       cycle   : boolean;
     end;

     SpriteTyp = record
       ADR     : pointer;
       dtx,dty : word;
       f_Frame : byte;
       c_Frame : byte;
       a_frame : byte;
       s_frame : byte;
       N_frame : byte;
       cycle   : boolean;
     end;
{}
VAR  f1        : file;
     block     : array[1..500] of spritetyp;
     Bobject   : array[1..500] of Tblock;
     charset1  : array[0..65] of Pointer;    { a multi-colored font }
     amount    : word;
     datamem   : longint;
     current   : word;
     tempobj   : Tblock;
     ch        : char;
     dataptr   : pointer;
     width     : word;
     Height    : word;

PROCEDURE Charset; External; {$l charset.obj}
{}
{
   Get the amount of entries in the file

   Expects: Nothing
   Returns: The amount of images found
}
FUNCTION entries:word;
VAR TID  : string [6];
    ent  : word;
BEGIN
  assign(f1,filename); reset(f1,1);
   blockread(f1,tid[1],5);
   tid[0]:=#5;
   if tid<>id then begin
      writeln('Not a valid XASv3 file.');
      halt(1);
   end;
   blockread(f1,ent,sizeof(ent));
   entries:=ent;
   close(f1);
END;
{}
{
        Read the images (sprites)

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE read_images;
VAR TID  : string [6];
    ent  : word;
    k    : integer;
    msize : word;
BEGIN
  assign(f1,filename); reset(f1,1);
   blockread(f1,tid[1],5);
   tid[0]:=#5;
   if tid<>id then begin
      writeln('Not a valid XASv3 file.');
      halt(1);
   end;
   blockread(f1,ent,sizeof(ent));
   blockread(f1,datamem,sizeof(datamem));
   k:=1;
   repeat
    blockread(f1,block[k].dtx,2);
    blockread(f1,block[k].dty,2);
    blockread(f1,Bobject[k].a_frame,1);
    blockread(f1,Bobject[k].s_frame,1);
    blockread(f1,Bobject[k].cycle,1);
    bobject[k].f_Frame:=k;
    bobject[k].c_Frame:=bobject[k].f_Frame;
    bobject[k].t_Frame:=bobject[k].s_frame;
    bobject[k].n_Frame:=1;

    msize:=(block[k].dtx*block[k].dty)+2;
    if (msize mod 16)<>0 then msize:=msize+16;
    msize:=16*(msize div 16);
    getmem(block[k].adr,msize);
    mem[seg(block[k].adr^):ofs(block[k].adr^)]:=byte(block[k].dtx);
    mem[seg(block[k].adr^):ofs(block[k].adr^)+1]:=byte(block[k].dty);

    blockread(f1,mem[seg(block[k].adr^):ofs(block[k].adr^)+2],block[k].dtx*block[k].dty);
    inc(k);
   until k>ent;
   close(f1);
END;
{}
{
        Save the new edited values

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE save_images;
VAR TID  : string [6];
    ent  : word;
    k    : integer;
    msize : word;
BEGIN
  assign(f1,filename); rewrite(f1,1);
   blockwrite(f1,id[1],5);
   blockwrite(f1,amount,sizeof(ent));
   blockwrite(F1,datamem,sizeof(datamem));

   for k:=1 to amount do begin
    blockwrite(f1,block[k].dtx,2);
    blockwrite(f1,block[k].dty,2);
    blockwrite(f1,Bobject[k].a_frame,1);
    blockwrite(f1,Bobject[k].s_frame,1);
    blockwrite(f1,Bobject[k].cycle,1);
    blockwrite(f1,mem[seg(block[k].adr^):ofs(block[k].adr^)+2],block[k].dtx*block[k].dty);

  end;
  close(f1);
END;
{}
{
        Create an array of pointers to all characters in the CHARSET.OBJ file

        Expects: Nothing
        Returns: Nothing
}
FUNCTION LoadCharset:boolean;
VAR k      : integer;
    ent    : word;
    charptr  : pointer;
    charint  : longint absolute charptr;
BEGIN
   charptr:=@Charset;
   ent:=mem[seg(charptr^):ofs(charptr^)+3];

   inc(charint,5);
   for k:=0 to ent do begin
       charset1[k]:=pointer(charint);
       inc(charint,64);
   end;
END;
{}
{
        Write text on screen using the graphics charset

        Expects: X+Y position on screen, and the text
        Returns: Nothing

        NOTE: No clipping is performed on the screen edges!!!
}
PROCEDURE Text(Xpos,Ypos:Word;text:String);
VAR i      : word;
    nx     : word;
    dataptr : pointer;
BEGIN
 nx:=xpos;                                      { start value of X }
 for i:=1 to length(Text) do                    { go thru every character }
     if ord(text[i])-32<>0 then begin
     dataptr:=charset1[ord(text[i])-32];     { get pointer to char-data }
     ASM
      xor bx,bx         { Y counter per character }

     @Vloop:
      mov es,sega000    { segment of screen }
      mov ax,bx         { get current Y value }
      add ax,ypos       { add Y start value }
      mov di,ax         { get Y value in CX }
      shl di,6          { multiply with 64... }
      shl ax,8          { ...and with 128 }
      add ax,nx         { add drawing start X position }
      add di,ax         { and move calculate offset to DI }

      mov dx,ds         { remember DS! }

      LDS si,dataptr    { get memory location of the data }
      mov ax,bx         { get current Y value }
      shl ax,3          { multiply with 8 }
      add si,ax         { add the calculated offset to the offset of the data }

      mov cx,8          { copy 8 bytes (we use a double word) }
     @HLoop:
      lodsb             { get word }
      cmp al,0          { see if AL is 0 }
      je @NoSet         { yes, so don't draw it }
      mov es:[di],al    { else draw it }
     @NoSet:
      inc di
      loop @Hloop       { loop until CX =0 }

      mov ds,dx         { get DS back }

      inc bx            { increase the Y scanline }
      cmp bx,8          { are we at the bottom of the character? }
      jl @Vloop         { no, so draw next line }
      add nx,9          { next X position on screen for the new character }
    end;
 end else inc(nx,9);    { go to next character position }
END;

{}
{
        Show information of the image

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE show_info;
VAR zin1,zin2 : string[10];
BEGIN
 with tempobj do begin
   text(1,130,'INFO:');
   str(current,zin1);
   str(amount,zin2);
   text(1,140,'PICTURE         '+zin1+'/'+zin2);
   str(a_frame,zin1);
   text(1,150,'FRAMES          '+zin1);
   str(s_frame,zin1);
   text(1,160,'ANIMATION SPEED:'+zin1);
   if cycle then zin1:='CYCLE' else zin1:='ONEWAY';
   text(1,170,'ANIMATION TYPE :'+zin1);
 end;
END;
{}
{
        Animate the current viewed block

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE animate;
BEGIN
 with tempobj do begin
   if t_frame>0 then dec(t_Frame) else begin
      t_Frame:=s_Frame;
      inc(c_frame,n_frame);
      if cycle then if (c_Frame>=f_Frame+a_frame-1) or (c_Frame=f_Frame) then n_frame:=-n_Frame;
      if not cycle then if c_Frame>=f_FRame+a_Frame then c_Frame:=f_Frame;
   end;
 end;
END;
{}
{
        Put a sprite on screen console style (clipping, and masking)
        Original procedure by Scott Tunstall.
        simple modifications done by P.Bestebroer, it now includes the
        CLIPCALCULATIONS and OFFSETCALCULATION inside the procedure, so no
        jump is needed, and a few command could be taken out...everything for
        speed!!

        Expects: AX to be X position
                 BX to be Y position
                 and ES:[DI] pointing at image data
        Returns: Nothing
}
PROCEDURE Sprite; ASSEMBLER;
VAR TempREG       : word;
ASM
{-=-=-=-=-=-=-=-=- Do clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   cmp bx,199              { Y > 199 ? }
   jg @ExitSprite          { JG is for SIGNED integers. If Y pos is
                             > 199 then no blit }
   cmp ax,319              { X > 319 ? }
   jg @ExitSprite          { Yes, Do not do any blits at all }

   mov si,di
   add si,2                { Make SI point to actual sprite data }

   xor ch,ch
   mov cl,[es:di]          { CL holds Clipwidth }

   cmp ah,$80              { Quick test if X position is negative }
   jb @XNotNegative        { If not then check if image is off right hand
                             of screen }
   neg ax                  { Make X position positive }

   cmp ax,cx               { If Abs(X) >= Image Width Then Don't Draw }
   ja @ExitSprite

   sub cx,ax               { Dec(ClipWidth, Abs(X)) }
   add si,ax               { Inc(DataStart, Abs(X)) }
   xor ax,ax               { Set X to 0 }
   jmp @NowDoY             { Do Y portion of data now. }

 @XNotNegative:
   mov dx,cx               { Set DX to clipwidth }
   add dx,ax               { If X + ClipWidth < 320 Then }
   cmp dx,320
   jb @NowDoY              { Do Y part (No need to clip width) }
   mov cx,320
   sub cx,ax               { ClipWidth = 320 - X }

{  At this point:

      AX is the X position of the Shape
      BX is the Y position of the Shape
      CL is the clipped width of the Shape.

      Now it is time to do the height part and set the result in CH.
}

 @NowDoY:
   xor dh,dh               { Make DX the height of image }
   mov dl,[es:di+1]
   mov ch,dl               { Set CH also to height for main blit routine }

   cmp bh,$80              { Quick test if Y position is negative }
   jb @YNotNegative

   neg bx                  { Make Y a positive number }

   cmp bx,dx               { If Y > ClipHeight }
   ja @NoDraw
   sub dx,bx               { Dec(ClipHeight, Abs(Y) ) }
   mov ch,dl               { As an image can only be 255 bytes high
                             this works fine.. }
   mov TEMPREG,AX          { Save X Coord on stack }
   xor ah,ah
   mov al,[es:di]          { AX = Width }
   mul bx                  { Calculate Y * Width }
   add si,ax               { Inc(DataStart, Abs(Y) * Width ) }
   mov AX,TEMPREG
   xor bx,bx               { Set Y to 0 }
   jmp @NowDoBlit          { NOW do the blit work. Whew! }

 @YNotNegative:
   add dx,bx               { If Y + ClipHeight > 199 Then }
   cmp dx,200
   jb @NowDoBlit
   mov dx,200
   sub dx,bx               { ClipHeight = 200 - Y }
   mov ch,dl

{
        At this point AX is the X position
                      BX is the Y position
                      CL is the ClipWidth and
                      CH is the ClipHeight.

        As the width/height of an Shape can only be an 8 bit
        quantity (i.e. < 256) I can discard the H portions of
        the registers. Whew!

        Now follows some weird code.. I'm going to make :

        DX = Modulo for datastart (which is the width in bytes of Shape.
        And yes, I do know that Width could be held in DL but adding extra
        code just to satisfy you optimisation junkies is v. boring.)

        DS:SI already points to data
        ES:DI points to active (source) Bitmap

}
  @NowDoBlit:
    cmp ch,0
    je @ExitSprite
    cmp cl,0
    je @ExitSprite
    mov TEMPREG,CX        { Save ClipWidth & ClipHeight on stack }

{=-=-=-=-=-=-=-=-=-=-=-= Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
     cmp ax,319         { Is X> 319 ? }
     ja @OutOfBounds    { Yes }
     cmp bx,199         { Is Y> 199 ?. Do not use BL instead as this is
                          when problems will occur.}
     ja @OutOfBounds    { Yes }

     xor ch,ch                  { CX = Y }
     mov cl,bl
     shl cx,6                   { Y * 64 }
     mov bh,bl                  { BX = Y * 256 }
     xor bl,bl
     add bx,cx                  { BX = BX + CX, which gives Y * 320 }
     add bx,ax                  { Add the X position to offset in BX }

     jmp @EndCalcOffset         { And exit. }

@OutOfBounds:
     jmp @ExitSprite             { coordinates are not within screen limites,
                                   so exit blitting }
@EndCalcOffset:

{=-=-=-=-=-=-=-=-=-=-=-= End Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
    mov CX,TEMPREG              { Restore ClipWidth and ClipHeight }

    xor dh,dh
    mov dl,[es:di]              { DX = Modulo }
    mov di,bx                   { Ahhh. Now DI points to the screen offset }
    jmp @EndClipCalc
  @NoDraw:
    jmp @ExitSprite             { no blit is possible }
  @EndClipCalc:
{-=-=-=-=-=-=-=-=- End clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   PUSH DS
   PUSH BP

   MOV AX,sega000
   MOV BX,ES
   MOV DS,BX                   { Now DS: SI points to correct space }
   MOV ES,AX

   MOV BX,SI                   { BX to be used to reload SI }
   MOV BP,DI                   { And the screen modulo }

   MOV AH,CL                   { AH = Width }
   CLD                         { Make sure LODSB works OK }

@Outer:
   MOV CL,AH                   { Re-load CL }
   MOV SI,BX                   { And SI with address of next sprite row }
   MOV DI,BP                   { And DI with address of next scan line }


@WriteByte:
   LODSB                       { Read byte from DS:SI }
   OR AL,AL                    { Is byte 0 (transparent) ? }
   JZ @NoBlit                  { yes, so don't blit }
   MOV [ES:DI],AL              { Otherwise store byte }

@NoBlit:
   INC DI                       { Move DI to next pos. on screen }
   DEC CL                       { Reduce shape width count }
   JNZ @WriteByte               { If not zero, end of shape not reached }

   ADD BX,DX                    { BX = BX + Modulo, so BX now points
                                  to first byte of next sprite line
                                  to blit }
   ADD BP,320                   { Make BP point to next line. Note :
                                  If you are going to add some extra
                                  stuff here make sure you're not
                                  accessing local variables! }


   DEC CH
   JNZ @Outer

   POP BP
   POP DS

 @ExitSprite:
END;

{}
{
        The start of the program
}
BEGIN
 filename:=paramstr(1);
 LoadCharset;

 amount:=entries;
 if amount=0 then begin
    writeln('No pictures found.');
    halt(1);
 end;


 read_images;

 asm
  mov ax,$13
  int 10h
 end;

 current:=1;
 tempobj   := Bobject[current];
 repeat
   asm
    mov es,sega000
    xor di,di
    DB $66
    xor ax,ax

    mov cx,16000

    db $66
    rep STOSW
   end;
   show_info;
   text(1,190,'XAS EDITOR '+version+' BY P.BESTEBROER');

   animate;

   dataptr:=block[tempobj.c_Frame].adr;
   width:=block[tempobj.c_Frame].dtx;
   height:=block[tempobj.c_Frame].dty;

   asm
    mov ax,161
    mov bx,100
    sub ax,width
    sub bx,height
    les di,dataptr
    call Sprite
   end;
   ASM
       MOV DX,$3DA
    @WaitEnd:
       IN AL,DX
       TEST AL,8
       JNZ @WaitEnd
    @WaitStart:
       IN AL,DX
       TEST AL,8
       JZ @WaitStart
   END;

   if keypressed then ch:=readkey else ch:=char(255);
   if ch=char(0) then begin
      ch:=readkey;
       if ch=char(77) then begin
          inc(current);
          if current>amount then current:=amount;
          tempobj   := Bobject[current];
       end;
       if ch=char(75) then begin
          if current>1 then dec(current) else current:=1;
          tempobj   := Bobject[current];
       end;
   end else begin
       if ch=char(27) then quit:=true;
       if (ch='a') or (ch='A') then begin
          with tempobj do begin
               if s_Frame<255 then inc(s_frame);
               t_Frame:=s_Frame;
          end;
          Bobject[current]:=tempobj;
       end;
       if (ch='z') or (ch='Z') then begin
          with tempobj do begin
               if s_Frame>0 then dec(s_frame);
               t_Frame:=s_Frame;
          end;
          Bobject[current]:=tempobj;
       end;
       if (ch='c') or (ch='C') then begin
          with tempobj do begin
               cycle:=not cycle;
               n_frame:=1;
               c_Frame:=f_Frame;
          end;
          Bobject[current]:=tempobj;
       end;
       if (ch='s') or (ch='S') then begin
          save_images;
       end;
       if (ch='+') then begin
          with tempobj do begin
               inc(a_frame);
               if f_frame+a_frame-1>amount then dec(a_frame);
          end;
          Bobject[current]:=tempobj;
       end;
       if (ch='-') then begin
          with tempobj do begin
               if a_frame>0 then dec(a_frame);
          end;
          Bobject[current]:=tempobj;
       end;
   end;
 until quit;
 textmode(co80);

END.
