UNIT SuperFX;
{
        SuperFX (pentium only)
        REAL mode version

        Coding by P.Bestebroer
        Copyright 1996,1997 by Just4Fun productions

        See the SUPERFX.DOC file for more information.

        If you got some money you want to spend on this, please do, I've got
        to make a living...  for contacting me :

        E-Mail   : just4fun@zeelandnet.nl
        Internet : http://people.zeelandnet.nl/rpb/pindex.html

        Mail     : Just4Fun Productions
                   A.Edenlaan 28
                   4463 JC GOES
                   Holland
}

{$R-} {No range checking}
{$S-} {No stack overflow checking}
{$I-} {No IO checking}
{$Q-} {No overflow checking}
{$G+} {Enable 286 instructions}

{*****************************************************************************
   NOTE: Include the next few lines in you're own program aswell, and they
         MUST be the same (so either use DOS, or PASCAL memory!)
*****************************************************************************}

{$DEFINE USEDOSMEM }      { Use DOS to allocate memory }

{$IFDEF USEDOSMEM}
   {$M 16384,0,5000}      { now use MEMALLOC/DALLOC instead of GETMEM/FREEMEM}
{$ELSE}
   {$M 65520,0,655360}    { just use GETMEM/FREEMEM }
{$ENDIF}

{*****************************************************************************
                                 Now the INTERFACE!!!
*****************************************************************************}
INTERFACE

USES CRT,DOS,SFX_VARS;

CONST FXVersion = $106;            { unit version }
{

                     Some variables to define the map

}
{=-=-=-=-=-=-=- Computer Calculated Values -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
CONST XtilesAmount    : word = 0;  { will be calculated by LOADMAP }
      YtilesAmount    : word = 0;  { will be calcualted by LOADMAP }
      MapWidth        : word = 0;  { located in MAP file }
      MapHeight       : word = 0;  { located in MAP file }
      PlayerStartX    : word = 0;  { located in MAP file }
      PlayerStartY    : word = 0;  { located in MAP file }
      MapX            : integer = 0;  { Depends on player X position }
      MapY            : integer = 0;  { Depends on player Y position }
      MapTitle        : string[32] = '?';
      Animated        : boolean = false;{ any animated tiles in map? }

VAR   LeftX           : word;      { Left block when drawing map   }
      TopY            : word;      { top block when drawing map    }
      RightX          : word;      { right block when drawing map  }
      BotY            : word;      { bottom block when drawing map }

{=-=-=-=-=-=-=- Constant Values    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
CONST MapId           = 'SUPERFX'; { MAP file ID }
{

        The type of the map blocks

        - F_Frame is the first frame of the block
        - BitFlag specifies things like: block player, block bullets, etc...

}
TYPE MapType       = record
          F_Frame : byte;
          BitFlag : byte;       { Standard numbers of BITFLAG are:
                                           0 - NOTHING (thin air)
                                           1 - Solid rock (wall,ground...)
                                           2 - Only landable on
                                           3 - Infront of sprites
                                }
     END;
CONST mapF_Frame = 0;
      mapBitFlag = 1;

VAR  Map                 : Pointer;                    { pointer to map-memory}

{

                            Screen Wave Variables

}
TYPE TLineData = record
        YDest      : word;   { destination screen Y position }
        LineLength : word;   { length of line to be drawn }
        YSource    : word;   { source screen Y position }
     END;

VAR  LineData    : array[0..180] of TLineData; { for the sinus-wave effect }

{=-=-=-=-=-=-=-=-=- WAVE values to use from you're program -=-=-=-=-=-=-=-=-=}
    FXWave          : boolean;               { TRUE if FX is done }

{=-=-=-=-=-=-=-=-=-=-= WAVE values not change-able -=-=-=-=-=-=-=-=-=-=-=-=-=}
    FXSinusPosition : word;                  { pointer in the sinus-table }
    FXLoop          : byte;                  { amount of times to loop }
    FXOutCount      : byte;                  { Counting down the wave }
    FXStart         : boolean;               { Starting FX? if yes, this will
                                               clean the screen first }
    WaveXLines      : word;                  { Counter used in WAVEFX }
    WaveSinStart    : word;                  { Counter used in WAVEFX }

VAR FLIPtable  : array[0..199] of word;
{

                               Copper values

}
CONST  UseCopper       : boolean = true;        { TRUE if you want to use it  }
       CopperTop       : byte = 1;              { top color for the copper FX }
       CopperBottom    : byte = 17;             { bottom color                }
       CopperHight     : word = 0;              { hight of color-bars         }
       BytesPerBar     : word = 0;
       ForceHight      : boolean = false;       { force hight yourself        }
       CopperRevers    : boolean = true;        { if TRUE copperskyDOWN will be
                                                  used }
{

                              Parallax layer variables

}
CONST  UseLayer        : boolean = true;        { Use a parallax layer?      }
       FullLayer       : boolean = false;       { Complete back-ground layer }
       MultipleSpeeds  : boolean = false;       { use 4 speeds in layer      }
       LayerCopper     : boolean = false;
{

                              Checkerd Board variables

}
CONST ViewerDist = 200;   { Distance Of Viewer From Screen                   }
      BoardSpeed = 1;
VAR   Tile    : array[0..7,0..7] of byte; { Checkered tile                   }
      Board_Ptr : pointer;
      Board_Seg : word;
      Board_Ofs : word;
      Board_Time: byte;
{

                                 Sprite Variables

}
Type SpriteTyp=Record                   { for all the shapes to be put in }
       data       : pointer;            { pointer to graphic data }
       C_frame    : byte;               { Current frame }
       T_Frame    : byte;               { Frame changing countdown }
       S_Frame    : byte;               { Frame changing speed }
       A_Frame    : byte;               { amount of frames to cycle thru }
       N_FRame    : shortint;           { Animation ADD direction (-1 or +1) }
       BitFlags   : byte;               { Bit        Flags
                                           0       - Cyclic animation
                                           1       - Needs MASKING color 0
                                        }
     End;
Type ImageTyp=Record                    { for all the shapes to be put in }
       data       : pointer;            { pointer to graphic data }
       BitFlags   : byte;               { Bit        Flags
                                           0       - Cyclic animation
                                           1       - Needs MASKING color 0
                                        }
     End;

     PActive       = ^TActiveSprite;    { the active images in the screenFRAME}
     TActiveSprite = record
        IMG        : pointer;           { Pointer to image-data   }
        Xpos,Ypos  : integer;           { X+Y position on SCREEN  }
        Flipped    : boolean;           { flipped in X direction? }
        Blink      : boolean;           { draw in one color?      }
        prev       : PActive;           { pointer to previous in list }
        next       : PActive;           { pointer to next in list }
     end;

VAR  FirstActive : PActive;             { pointer to first visible-sprite }
     LastActive  : PActive;             { pointer to last visible-sprite  }
{

                            Keyboard variables

}
Const  EscKey = 1;      { these are just some constants... }
       Down   :Byte = 80;     { the most important keys in games }
       Up     :Byte = 72;     { are the arrow keys, and the }
       Left   :Byte = 75;     { control+alt keys... }
       Right  :Byte = 77;
       CTRL   :Byte = 29;
       ALT    :Byte = 56;

       key_0  = 11;
       key_1  = 2;
       key_2  = 3;
       key_3  = 4;
       key_4  = 5;
       key_5  = 6;
       key_6  = 7;
       key_7  = 8;
       key_8  = 9;
       key_9  = 10;
       PausePressed    : boolean = FALSE;
{

                        Joystick/Gamepad variables

}
VAR JOYinstalled  : boolean;    { true if joystick 0 present at unit startup }

VAR X,Y           : word;       { stick position                             }
    JoystickLeft  : boolean;    { if left pushed                             }
    JoystickRight : Boolean;    { if right pushed                            }
    JoystickUp    : Boolean;    { ...                                        }
    JoystickDown  : Boolean;    { ..                                         }
    JoystickA     : Boolean;    { button 1 pressed                           }
    JoystickB     : Boolean;    { button 2 pressed                           }
    JoystickC     : Boolean;    { button 3 pressed                           }
    JoystickD     : Boolean;    { button 4 pressed                           }

    JoyThings     : array[1..8] of boolean;

CONST JoyLeft   : byte = 1;     { these are set by the setup..               }
      JoyRight  : byte = 2;     { they specify wich of the 8 directions/     }
      JoyDown   : byte = 3;     { buttons, does what.                        }
      JoyUp     : byte = 4;     { it then set's the buttons,directions TRUE  }
      JoyFire   : byte = 5;     { or FALSE                                   }


CONST Cal_L:word=$FFFF;         { contains calibration extent of 'center'    }
      Cal_T:word=$FFFF;
      Cal_R:word=0;
      Cal_B:word=0;
{

                Standard Graphic variables for the map, and parallax

}
CONST TEXTSEG           : word = $a000;     { segment for drawing text on    }

VAR tiles               : array[0..255] of SpriteTyp; { ground tiles         }
    layertile           : array[1..5] of Pointer;     { LayerImage           }
    LayerNR             : byte;
    TilesInFile         : byte;                       { amount of background
                                                        tiles in total       }
    Charset             : array[32..95] of Pointer;    { a multi-colored font}
    ShowInfo            : boolean;
{

                               Virtual screen variables

}
VAR Vpage_seg         : word;      { segment of virtual page }
    Vpage_Ofs         : word;      { offset of virtual page  }
    Vpage_Ptr         : pointer;   { pointer to virtual page }
    
{

                               FLI variables

}
CONST  Clock_Scale  = 14608 DIV 70;
       BufSize      = 65528;

TYPE PFliPlayer = ^TFliPlayer;
     TFliPlayer = OBJECT
       CONSTRUCTOR Init;
       DESTRUCTOR  Done;                      VIRTUAL;
       PROCEDURE   Play(UseLIB:boolean;Filename : String);   VIRTUAL;
       PRIVATE
          Buffer   : Pointer;
     END;
TYPE MainHeaderRec = RECORD
          FileSize : LongInt;              { file size of FLI }
          ID       : Word;                 { ID of fli file }
          Frames   : Word;                 { amount of frames }
          width    : word;                 { screen width of FLI }
          height   : word;                 { screen height of FLI }
          depth    : word;                 { depth of a pixel }
          flags    : word;                 { must be 0 }
          Speed    : Word;
          next     : word;
          frit     : word;
          extra    : ARRAY[1..106] OF Char;{for new versions}
     END;

     FrameHeaderRec = RECORD
          Size     : LongInt;
          ID       : Word;     { always $F1FA }
          Chunks   : Word;
          extra    : ARRAY[1..8] OF Char; {for new versions}
     END;
VAR  FLIHEIGHT   : word;
{

                           Color/LIGHT variables

}
VAR  Pal : array[0..255] of record  { This is to store the palette }
         RedLevel   : byte;         { the RED value of the current color }
         GreenLevel : byte;         { the GREEN value of the current color }
         BlueLevel  : byte;         { and the BLUE value of the current color}
     END;

TYPE PLIGHT = ^TLight;
     TLight = record
        x1,y1,
        x2,y2     : integer;        { define the box-positions               }
        lightFLAG : byte;           { define light - type
                                      0 = just light, no change in brightness
                                      1 = random flickering light
                                      2 = bright-pulsating, continously
                                      3 = dark-pulsating, continously
                                      4 = bright-pulsating, once
                                      5 = dark-pulsating, once

        }
        startBright: word;          { start value of light                   }
        SubMap    : boolean;        { Substract MAPX and MAPY positions?     }

        curBright : word;           { current brightness of light            }
        BrAdd     : shortint;       { Bright -adding counter (-1, 0 or 1)    }
        prev,next : PLight;         { pointer to previous/next light in list }
     end;

VAR  ColorMap  : array[0..255,0..31] of byte;{ for the light-sourcing        }
     firstLight     : PLight;
     lastLight      : PLight;
     LSourceA       : word;  { Amount of lights in map }

{

                      Important EXIT and KEYBOARD variables

}
CONST Halt_Error   : string  = '';      { on exit, display an error message  }
      KeyName : array[1..83] of string[10] = (
           'Esc','1','2','3','4','5','6','7','8','9','0','_','=','BckSpace',
           'Tab','Q','W','E','R','T','Y','U','I','O','P','[',']','Return',
           'Ctrl','A','S','D','F','G','H','J','K','L',';','"','`','Left Shift',
           '\','Z','X','C','V','B','N','M',',','.','/','Right Shift','*',
           'AlT','Space','Caps Lock','F1','F2','F3','F4','F5','F6','F7','F8',
           'F9','F10','Num Lock','Scroll Lock','Home','Up','Pg Up','-','Left',
           '5','Right','+','End','Down','Pg Down','Ins','Del');


VAR   key             : array[1..127] of boolean; { to store the key-presses }
      ExitSave        : pointer;        { pointer to switch between INTs     }
      anypressed      : boolean;        { see if any key was pressed         }
      OldInt09        : pointer;        { old keyboard interupt              }

      oldexit         : pointer;        { pointer to old exit procedure      }

CONST {Vertival Retrace Timer setup...
	 Set timeout to 0 to auto-sync to vblank
	 Another value will make n interrupts per frame. Use TIMESLACK to
	 give interrupt some time to process. Eg. TIMEOUT=1, TIMESLACE=-300}
	TIMEOUT : word = 4;		 { number of interrupts pr frame     }
	TIMESLACK : integer = -800;      { interrupt timer slack}
	EXECBIOSTIMER : boolean = TRUE;  {still execute bios timer interrupt?}

VAR     TimerCount  : integer;
        TimeSet     : word;
	retraces    : word;              { vertical retrace counter }
	total_retraces : word;           { total of retraces }
	timerproc : procedure;           { pointer to user interrupt }
	Int08Save : procedure;           { store old interrupt-pointers }
        bioscount : word;
        TimerInstalled : boolean;        { is the timer installed? }
{

                        DFP library file using variables

}
CONST LIB_NAME  : string  ='';                  { name of LIBRARY file       }
      NEW_ID    : string  ='DFPv2';             { ID of library              }
      BLOCKSIZE = 60000;                        { blocksize to copy          }
      KEY_START : longint = 0;                  { start of current "FILE"    }
      KEY_SIZE  : longint = 0;                  { size of current "FILE"     }

VAR   LIB_FILE  : file;                         { The library file           }
{}
{ FX variables                                                               }
TYPE PFx       = ^TFx;
     TFx       = record
        xpos,ypos : integer;
        f_Frame,                         { First frame of the animation      }
        a_Frame,                         { amount of frames in the anim      }
        c_frame,                         { current frame in the anim         }
        t_frame,                         { time before frame-changing        }
        s_Frame     : byte;              { standard time before changing     }
        n_frame     : shortint;          { new_Frame is add+1 or add-1       }
        bitflag     : byte;              { cyclic animation?                 }
        prev        : Pfx;               { previous frame in linked list     }
        next        : Pfx;               { next frame in linked list         }
     end;

VAR  FirstFX        : Pfx;               { pointer to first FX in list       }
     LastFX         : Pfx;               { pointer to last FX in list        }
     FXS            : array[1..50] of SpriteTyp; { FX sprites                }
{

              And now, for the procedures and functions....:

}

{*****************************************************************************
   SuperFX Initialise procedures
*****************************************************************************}
PROCEDURE InitVGAmode;                { initialise VGA mode }
PROCEDURE SetTXTmode;                 { go back into TEXT mode }
PROCEDURE RestoreTimerInterrupt;      { automaticly called thru SHUTSUPERFX  }

{*****************************************************************************
  Joystick Procedures
*****************************************************************************}
PROCEDURE SwirlCalibrate;    { Swirl calibrate                           }
PROCEDURE CenterCalibrate;   { center calibrate, no user interaction     }
PROCEDURE GetJoy;            { set JOYSTICK booleans                     }
PROCEDURE SAMPLE;            { sample joystick things                    }
{*****************************************************************************
   Shut Down Procedure
*****************************************************************************}
PROCEDURE ShutSuperFX;                { erase tiles,map,virtual screen,etc   }
PROCEDURE DeAllocXAS(var storing:Array of SpriteTyp); { DEALLOCATE images    }

{*****************************************************************************
    Library procedures
*****************************************************************************}
FUNCTION USEFILE(name:String):boolean; {Set name of LIBRARY file}
FUNCTION LIB_RESET(name: string):byte; {reset Library file to specified "KEY"}

{*****************************************************************************
    Map procedures
*****************************************************************************}
FUNCTION LoadMap(lib:boolean;filename:String):boolean; { Load in a MAP file }
PROCEDURE map_calculate;               { Calculate Map boundaries    }
PROCEDURE SetmapXY;                    { Set MAPX and MAPY variables }
PROCEDURE UpdateMap;                   { Update the map on screen    }
FUNCTION MapPos(x,y:integer;mapval:word):byte; { check on map position    }
PROCEDURE SetMapPos(x,y:integer;mapval:word;value:byte);
PROCEDURE DeAllocMap;                  { deallocates the map                 }
PROCEDURE NewMap;                      { creates a new map                   }

{*****************************************************************************
   Image procedures (ie.: all images on screen in current frame)
*****************************************************************************}
FUNCTION AddIMAGE( Xpos2,Ypos2     : integer;    { Add image to ACTIVE list  }
                   IMGPOINT        : pointer;
                   Flipped2,Blink2 : boolean):boolean;
PROCEDURE DoImages;           { draw all images in the ACTIVE list           }
PROCEDURE AnimateArray(var Asprites:array of spritetyp;nr:byte);
FUNCTION LoadPCXHigh(lib:boolean;filename:String):boolean;

{*****************************************************************************
    Virtual screen procedures
*****************************************************************************}
PROCEDURE ShowBitmap;         { normal show of the virtual page              }
PROCEDURE FlipScreenY;        { flipped view in Y direction                  }
PROCEDURE MirrorSplit;        { top lines are mirrored, the rest is normal   }
PROCEDURE ClearScreen;        { clear the virtual page                       }
PROCEDURE ClearVisible;       { clear the actual screen                      }
PROCEDURE Displace;           { put screen on other coordinates              }
PROCEDURE Zoom(MidX,MidY,size:word); { zoom in on the screen                 }
PROCEDURE Flip(value:integer); { for screen flipping/scaling                 }
{*****************************************************************************
    FLI showing procedures
*****************************************************************************}
PROCEDURE AAPlay(UseLib:boolean;Filename : String); { Play a FLI file once }
{*****************************************************************************
    LIGHT Shading procedures
*****************************************************************************}
FUNCTION LoadColorMap(lib:boolean;filename:String):boolean;
PROCEDURE DrawLight(x1,y1,x2,y2:integer;bright:word;SubMap:boolean);
FUNCTION AddLight(  xx1,yy1,xx2,yy2 : integer;
                    bright  : word;
                    SubMap2 : boolean;
                    LType   : byte): boolean;
FUNCTION EraseLight(Temp:PLight):boolean;
FUNCTION EraseLightALL:boolean;
PROCEDURE DoLights;


{*****************************************************************************
    Screen Wave procedures
*****************************************************************************}
PROCEDURE InitWave(WaveAmount:Byte);  { Initialise the WAVE effect           }
PROCEDURE StopWAVE;                   { Stop the current WAVE                }
PROCEDURE WaveFX;                     { Draw in a WAVE (replaces SHOWBITMAP) }
{*****************************************************************************
   Checker Board procedures
*****************************************************************************}
FUNCTION InitBoard(cr1,cg1,cb1,cr2,cg2,cb2:byte):boolean;
Procedure UpdateBoard;                { This makes the checkerd board        }
{*****************************************************************************
   Sky copper effect + parallax layer
*****************************************************************************}
PROCEDURE InitCopper;                 { Initialise the Copper Bars           }
PROCEDURE CopperSkyUp;                { Draw Copper sky "incrementing" colors}
PROCEDURE CopperSkyDown;              { Draw Copper sky "decrementing" colors}

{*****************************************************************************
   Animation effects handling. (explosions, smoke, etc...)
*****************************************************************************}
FUNCTION AddFX(Xpos2,Ypos2:integer;F_Frame2:byte):boolean; { ADD FX to linkedlist }
PROCEDURE DoFX;                       { do the FX (called by UPDATEMAP)      }

{*****************************************************************************
   FAST! game-sprite putting...
*****************************************************************************}
PROCEDURE Sprite;                     { Draw masking and clipped sprited }

PROCEDURE SpriteNoMask;               { Draw clipped sprite }
PROCEDURE SpriteBLINK;                { Draw Highlighted,masked,clipped sprite}
PROCEDURE XFlipSprite;                { Flip sprite in X (masking+clipping) }
PROCEDURE XFlipSpriteBLINK;           { SpriteBlink&XFlipSprite at once }
Procedure ScaleShape(var DataPtr; x1:word;y1:byte;x2:word;y2:byte);

FUNCTION GetXAS(lib:boolean; filename:string; var storing:array of spritetyp):Byte;
FUNCTION GetImages(lib:boolean; filename:String; var storing:Array of Imagetyp):byte;
FUNCTION LoadLayerImage(lib:boolean; filename:string; image:byte):boolean;

{*****************************************************************************
    Square detection procedure, between 2 (square) positions
*****************************************************************************}
FUNCTION collision(x1,y1,w1,h1, x2,y2,w2,h2 :integer):boolean;

{*****************************************************************************
    Charset procedures
*****************************************************************************}
FUNCTION LoadCharset(lib:boolean;filename:string):boolean;
PROCEDURE SetTextSegment(newseg:word);
PROCEDURE Text(Xpos,Ypos:Word;text:String); { write text with loaded charset }

{*****************************************************************************
    Do some palette stuff
*****************************************************************************}
FUNCTION Loadpal(lib:boolean;name:string):boolean; { load the palette }
PROCEDURE SetPal;                                      { Set the palette  }
PROCEDURE FadeOut(col1,col2:byte);                     { Fade out to black }
PROCEDURE FadeIn(col1,col2:Byte);                      { Fade the palette in }
PROCEDURE GreyPal(col1,col2:byte);                     { Set palette to GREY }
PROCEDURE FadetoGrey(col1,col2:Byte);                  { Fade the palette in }
PROCEDURE BlackPal;                                    { Make palette black }

{*****************************************************************************
  Miscellaneous procedures
*****************************************************************************}
PROCEDURE RetraceOLD;           { Wait for vertical-retrace (old-way) }
PROCEDURE TestCPULine;          { Same as retrace, but show point of entry }
procedure Retrace;              { Wait for vertical-retrace (using interrupt)}


{*****************************************************************************
  Memory procedures
*****************************************************************************}
FUNCTION MemAlloc(VAR Ptr; Size : Word) : Word;
FUNCTION Dalloc(VAR Ptr) : Word;

{

              .... well, here it comes... the actual code ....

}

IMPLEMENTATION

{

  Don't erase any of the LOGO part, I've worked hard on this unit, and this
  is the sign of my work... so please leave it in!

}
PROCEDURE LOGO;         EXTERNAL; {$l logo.obj}
CONST     LogoPTR     : pointer = @Logo;
{}
{
       Allocate memory using DOS
       (I've got this from the SWAG files, but I forget who made it...)

       Expects: Same values as the PASCAL GETMEM procedure.
       Returns: 0 if no error occured, else the normal DOS memory errors
}
FUNCTION MemAlloc(VAR Ptr; Size : Word) : Word;
BEGIN
    INLINE(
      $8B / $46 / <Size /         {            mov         ax,[bp+<Size]}
      $B9 / $04 / $00 /           {            mov         cx,4}
      $D3 / $E8 /                 {            shr         ax,cl}
      $40 /                       {            inc         ax}
      $89 / $C3 /                 {            mov         bx,ax}
      $B4 / $48 /                 {            mov         ah,$48}
      $CD / $21 /                 {            int         $21             ;Allocate memory}
      $72 / $07 /                 {            jc          AllocErr        ;If any errors ....}
      $C7 / $46 / $FE / $00 / $00 / {NoErrors:   mov word    [bp-2],0        ;Return 0 for successful allocation}
      $EB / $05 /                 {            jmp short   Exit}
      $89 / $46 / $FE /           {AllocErr:   mov         [bp-2],ax       ;Return error code}
      $31 / $C0 /                 {            xor         ax,ax           ;Store a NIL value into the ptr}
      $C4 / $7E / <Ptr /          {Exit:       les         di,[bp+<Ptr]    ;Address of pointer into es:di}
      $50 /                       {            push        ax              ;Save the Segment part}
      $31 / $C0 /                 {            xor         ax,ax           ;Offset is always 0}
      $FC /                       {            cld                         ;Make sure direction is upward}
      $AB /                       {            stosw                       ;Store offset of memory block}
      $58 /                       {            pop         ax              ;Get back segment part}
      $AB);                       {            stosw                       ;Store segment of memory block}
END;
{}
{
       Deallocate memory allocated with MEMALLOC
       (also from the SWAG, and surprise,surprise, made by the same person)

       Expects: Same values as the PASCAL GETMEM procedure.
       Returns: 0 if no error occured, else the normal DOS memory errors
}
FUNCTION Dalloc(VAR Ptr) : Word;
BEGIN
  IF Pointer(Ptr) <> NIL THEN BEGIN
      INLINE(
        $B4 / $49 /               {            mov         ah,$49}
        $C4 / $7E / <Ptr /        {            les         di,[bp+<Ptr]}
        $26 / $C4 / $3D /         {        es: les         di,[di]}
        $CD / $21 /               {            int         $21}
        $72 / $02 /               {            jc          Exit}
        $31 / $C0 /               {NoError:    xor         ax,ax}
        $89 / $46 / $FE);         {Exit:       mov         [bp-2],ax}
      Pointer(Ptr) := NIL;
    END;
END;
{}
{
        Show the SUPERFX logo, private to unit, please don't erase it from
        calling to...this gives me some credit...much needed credit!

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE ShowLogo;
VAR  TEMPDS : word;
BEGIN
 ASM
   mov es,sega000       { get screen segment }

   mov tempds,DS        { remember DS }
   lds si,LogoPTR       { get offset of image }
   xor bh,bh            { set BH to 0 }
   lodsw                { load 2 bytes }
   mov bl,ah            { put HIGHT in BL }
   xor ah,ah            { set AH to 0 }

   mov di,200           { set screen offset to line 200 }
   sub di,bx            { substract the hight of the image }
   mov dx,di            { put offset in DX }
   shl di,8             { calculate with 128... }
   shl dx,6             { ...and with 64, }
   add di,dx            { add them together, and we just multiplied with 320 }

 @NextLine:
   mov cl,al            { get WIDTH in CL }
   cmp cl,4             { see if 4 bytes }
   jl @NoDouble         { no, so no double words }
   shr cl,2             { else, divide with 4 }
   DB $66; rep MOVSW    { and draw double words }
   mov cl,al            { get original WIDTH back }
   and cl,3             { MOD with 4 }
   or cl,cl             { see if any bytes left }
   jz @NoBytesLeft      { no bytes left... }

 @NoDouble:
   cmp cl,2             { see if there are 2 bytes left }
   jl @NoWord           { no, so no WORD put }
   MOVSW                { else put WORD }
 @NoWord:
   test cl,1            { still one byte left? }
   jz @NoBytesLeft      { no, so we're done }
   MOVSB                { else draw last byte }
 @NoBytesLeft:
   add di,320           { go to next line }
   sub di,ax            { wich is 320 - width of image }
   dec bl               { decrease Y counter }
   jnz @NextLine

   mov DS,TEMPDS        { get DS back }

   {

      blackout PAL array

   }
   mov cl,255           { 255 color to do }
   mov di,offset PAL    { get start of PALETTE array }
   mov ax,ds            { get DS }
   mov es,ax            { and put it in ES }
   xor ax,ax            { fill palette with black }
  @BlackLoop:
   stosw                { store word }
   stosb                { and byte, PAL =record is 3 bytes long }
   loop @BlackLoop      { loop until CL=0, so done all colors }

   mov ax,ds          { get DS }
   mov es,ax          { and put it in ES }
   mov di,offset PAL  { get start of PALETTE array }
   add di,3           { go to color 1 }
   mov al,63          { set color 1 to white }
   mov ah,63
   stosw
   stosb
   {

      second color

   }
   mov al,55          { set color 2 to light shade }
   mov ah,50
   stosw
   mov al,43
   stosb
   {

      third color

   }
   mov al,45          { set color 3 to dark shade }
   mov ah,40
   stosw
   mov al,33
   stosb
  end;

  fadein(0,255);
  fadeout(0,255);
  ClearVisible;
END;
{}
{
        Show the SUPERFX information

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE ShowInformation;
BEGIN
 TextColor(7); TextBackground(0);
 writeln;
 write  ('SuperFX (pentium only) version ');
   Write(FXVersion DIV 256,'.',FXVersion AND $FF);
   writeln('  Copyright 1996,1997 by Just4Fun Productions');
 writeln('For information on the SuperFX engine, E-Mail to: just4fun@zeelandnet.nl');
 writeln('Updates can be found at: http://people.zeelandnet.nl/rpb');
 write('');
END;
{}
{
        Initialise the VGA mode

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE InitVGAmode; Assembler;
ASM
 mov ax,$13        { set mode to VGA mode (13h) }
 int 10h           { call BIOS interrupt }
 mov ShowInfo,true
 call BlackPal     { Set palette to black }
{ call ShowLogo     { Show FX logo }
 Call ClearScreen  { Clear the screen }
END;
{}
{
        Initialise the TXT mode

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE SetTXTmode;
BEGIN
 ASM
   mov ax,$0f        { Check current video mode }
   int 10h           { call BIOS interrupt }
   cmp al,$03        { see if not yet in current mode }
   je @TxtModeSet    { allready in textmode, so skip setting it }
   mov ax,$03        { set mode to TEXT mode (3h) }
   int 10h           { call BIOS interrupt }
 @TxtModeSet:
 END;
 window(1,1,80,25);
END;

{}
{
        Initialise the bitmap

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE InitBitmap;

    PROCEDURE GetPtrData(pt:pointer; VAR Segm, Offs:word); Assembler;
    ASM
       LES DI,PT            { Point ES:DI to where PT is in memory }
       MOV AX,ES            { Set AX to hold segment }
       MOV BX,DI            { BX to hold offset }

       LES DI,Segm          { Now write directly to variable Segm }
       MOV [ES:DI],AX
       LES DI,Offs          { And variable Offs }
       MOV [ES:DI],BX
    END;


BEGIN
 {$IFDEF USEDOSMEM}
     MemAlloc(VPage_PTR,64000);
 {$ELSE}
     GetMem(VPage_PTR,64000);
 {$ENDIF}

  if VPage_PTR=NIL then begin
     Halt_Error:='Couldn''t allocate memory for virtual screen.';
     halt;
  end;

  GetPtrData(VPage_PTR,vpage_seg,vpage_ofs);
  ClearScreen;
END;
{}
{
       Restore the old keyboard interupt

       Expects: Nothing
       Returns: Nothing
}
PROCEDURE RestoreInt09 ;
BEGIN
  ExitProc := ExitSave ;
  SetIntVec( $09, OldInt09 ) ;
  exitsave:=NIL;
END;
{}
{
       Put in the new keyboard interrupt

       Expects: Nothing
       Returns: Nothing
}
PROCEDURE NewInt09; INTERRUPT; ASSEMBLER;
ASM
  STI

  xor ch,ch             { set CH to 0, we're using bytes here! }

  mov dx,$60            { set DX to port $60 (keyboard port) }
  in al,dx              { get byte from keyboard }
  mov cl,al             { put it in CL for usage }
  and cl,$7f            { and CL with 127 (MOD 128) }

  mov bx,offset key     { get offset of the KEY array of booleans }
  dec bx
  add bx,cx             { add keyfound to BX }
  mov si,bx             { put calculated offset in DS:[SI] }

  shr al,7              { divide AL with 128 }
  xor al,1
  mov [si],al           { put TRUE or FALSE in array position of keyfound }
  mov anypressed,al     { set ANYPRESSED to TRUE or FALSE }
  mov dx,$61
  in al,dx              { get byte from the port }
  mov cl,al
  or al,$80
  out dx,al
  mov al,cl
  out dx,al

  mov ax,$20
  mov dx,$20
  out dx,ax

  CLI
END;
{}
{
       Initialise the keyboard interupt

       Expects: Nothing
       Returns: Nothing
}
PROCEDURE InitInt09;
VAR n : byte;
BEGIN
  if exitsave<>NIL then exit;   { allready installed }

  ExitSave := ExitProc ;
  ExitProc := addr( RestoreInt09 ) ;

  GetIntVec( $09, OldInt09 ) ;
  SetIntVec( $09, addr( NewInt09 ) ) ;
  For N := 1 to 127 do Key[ N ] := False ;
END;

{}
{
        Reset the library file to the start of the correct "FILE DATA"

        Expects: Name of file to search for in the library
        Returns: A error code wich is :  0  : no error
                                         1  : No file name specified
                                         2  : No key specified
                                         3  : Key to long, maximum of 8 characters
                                         4  : Not a valid library file
                                         5  : "KEY" not found
}
FUNCTION LIB_RESET(name: string):byte;
VAR i          : integer;       {used as a counter}
    j          : integer;       {used as a second counter}
    match      : boolean;       {found a key ?}
    key        : string;        {Used to store the "directory" key}
    ID         : string[5];     {File ID, for checking the LIB file}
    ENTRY      : longint;       {amount of entries in the "directory"}
BEGIN
  Lib_Reset:=0;                 { no error as yet }
  if Lib_Name=''           then begin LIB_RESET:=1; end; {no library name}
  if name=''               then begin LIB_RESET:=2; end; {no key specified}
  if length(name)>12       then begin LIB_RESET:=3; end; {key to long}
  while length(name)<12 do name:=name+' ';{ make sure the key is 8 characters }
  for i:=1 to length(name) do name[i]:=upcase(name[i]);

  assign(LIB_FILE , LIB_NAME); reset(LIB_FILE,1);     {Open lib file}
  blockread(LIB_FILE , ID[1], 5);                     {Read the ID}
  id[0]:=#5;
  if id<>new_id then begin                            {Wrong ID}
       close(lib_file);                               {Close the file}
       LIB_RESET:=4;                                  {not a VALID file}
       exit;                                          {Exit this routine}
  end;
  blockread(LIB_FILE , ENTRY, sizeof(entry));         {How many entries?}
  i:=1;
  repeat
      blockread(LIB_FILE ,key[1], 12);                {Let's see if we}
      blockread(LIB_FILE, key_start, sizeof(key_start));{can find the correct}
      blockread(LIB_FILE, key_size,  sizeof(key_size)); {key...}
      key[0]:=#12;                                      {Length of the string}
      match:=true;
      if key<>name then match:=false;                  {wrong key}
      inc(i);                                          {go to next key}
    until (i>entry) or match;
    if match then begin                                {Key found!}
       seek(LIB_FILE,key_start);                       {Get positions}
    end else begin                                     {Key not found}
        close(LIB_FILE);                               {close the file}
        LIB_RESET:=5;                                  {exit with an error}
    end;
END;
{}
{
        Set the file name of the LIBRARY file to use

        Expects: name of the library file
        Returns: TRUE if file exists, else FALSE
}
FUNCTION USEFILE(name:string):boolean;
VAR f : file;
BEGIN
 assign(f,name);                { open the file }
 {$I-}                          { set IO checking off }
  reset(f,1);                   { reset it }
 {$I+}                          { get IO checking back online }
 if ioresult<>0 then begin
    Halt_Error:='unable to open file '+name; { Oops, no file found }
    USEFILE:=false;                           { UseFile is false }
 end else begin
    Usefile:=true;
    lib_name:=name;                           { set LIB_NAME correct }
    close(f);                                 { close the file }
 end;
END;
{}
{
        Load a map file, created with MAPED

        Expects: LIB=TRUE if we want to load from a DFP file,
                 and the filename to use
        Returns: TRUE if succesfull else halt_error contains the error string
}
FUNCTION LoadMap(lib:boolean;filename:String):boolean;
TYPE IMapType = record
          F_Frame : byte;
          BitFlag : byte;
     end;
VAR LoadID    : string;
    code      : byte;
    x,y       : word;
    mx,my     : word;
    temp      : TLight;
BEGIN
  if LIB then begin                     { use library? }
     code:=lib_Reset(filename);         { get the file }
     IF code<>0 then begin              { if code<>0 we got a error }

        LoadMap:=false;                 { no Map can be loaded }
        Halt_Error:='Couldn''t spawn map '+filename;
        exit;

     END;
  end else begin
       assign(lib_file,filename);
       {$I-}
            reset(lib_file,1);    { open file }
       {$I+}
       if ioresult<>0 then begin
          LoadMap:=false;
          halt_error:='Couldn''t spawn map '+filename;
          exit;
       end;
       key_start:=0;
       key_size:=filesize(lib_file);
  end;

  { First check on the ID of the file }
  blockread(lib_file,LoadID[1],length(MapID));
  LoadID[0]:=char(length(MapId));
  if LoadID<>MapID then begin

     LoadMap:=false;
     Halt_Error:='Couldn''t spawn MAP file, non valid';
     close(lib_file);
     exit;

  end;

  if map<>nil then begin
    {$IFDEF USEDOSMEM}
      DAlloc(map);
    {$ELSE}
      FreeMem(map,(mapheight*mapwidth)*sizeof(MapType));
    {$ENDIF}
  end;


  { read width+height of the map }
  blockread(lib_file,MapWidth,sizeof(MapWidth));
  blockread(lib_file,MapHeight,sizeof(mapheight));

  {$IFDEF USEDOSMEM}
     MemAlloc(map,(mapheight+1)*(mapwidth+1)*sizeof(maptype));
  {$ELSE}
     GetMem(map,(mapheight+1)*(mapwidth+1)*sizeof(maptype));
  {$ENDIF}


  if (map=NIL) then begin
     close(lib_file);
     LoadMap:=false;
     Halt_error:='out of memory';
     exit;
  end;
  { read start position(s) of player }
  blockread(lib_file,PlayerStartX,sizeof(PlayerStartX));
  blockread(lib_file,PlayerStartY,sizeof(PlayerStartY));

  { read main map data }
  mx:=0;
  for x:=0 to Mapwidth do begin
    my:=0;
    for y:=0 to Mapheight do begin
{      blockread(lib_file,map^[my,mx],sizeof(IMapType));}
      blockread(lib_file,mem[seg(map^):ofs(map^)+((my*(mapwidth+1))+mx)*sizeof(MapType)],sizeof(IMapType));
      inc(my);
    end;
    inc(mx);
  end;
  maptitle:='';
  if not eof(lib_file) then begin
     blockread(lib_file,x,1);
     if x=255 then begin
      blockread(lib_file,usecopper,sizeof(usecopper));
      blockread(lib_file,useLayer,sizeof(uselayer));
      blockread(lib_file,FullLayer,sizeof(fulllayer));
      blockread(lib_file,forcehight,sizeof(forcehight));
      blockread(lib_file,copperrevers,sizeof(copperrevers));
      blockread(lib_file,multiplespeeds,sizeof(multiplespeeds));
      blockread(lib_file,coppertop,sizeof(coppertop));
      blockread(lib_file,copperbottom,sizeof(copperbottom));
      blockread(lib_file,copperhight,sizeof(copperhight));
      blockread(lib_file,layernr,sizeof(layernr));
      blockread(lib_file,maptitle[1],30);
      maptitle[0]:=#30;
   end;
  end;
  if not eof(lib_File) then begin       { Read LIGHT-SOURCING }
     blockread(lib_file,x,1);
     if x=255 then begin
      blockread(Lib_File,LSourceA,sizeof(LSourceA));
      for x:=1 to LSourceA do begin
        Blockread(lib_file,temp.x1,sizeof(temp.x1));
        Blockread(lib_file,temp.y1,sizeof(temp.y1));
        Blockread(lib_file,temp.x2,sizeof(temp.x2));
        Blockread(lib_file,temp.y2,sizeof(temp.y2));
        Blockread(lib_file,temp.LightFlag,sizeof(temp.LightFlag));
        Blockread(lib_file,temp.StartBright,sizeof(temp.StartBright));
        Blockread(lib_file,temp.SubMap,sizeof(temp.SubMap));

         with temp do
           AddLight(x1,y1,x2,y2,startbright,submap,lightflag);
      end;
     end;
  end;
  close(lib_file);

  { init variables }
  mapx:=0;
  mapy:=0;
  Map_Calculate;

  LoadMap:=True;

  initcopper;
END;
{}
{
        Set the Map Coordinates

        Expects: AX to point to X position of player
                 BX to point to Y position of player
        Returns: Nothing

}
PROCEDURE SetmapXY; ASSEMBLER;
ASM
  sub ax,155    { substract 155 pixels (position player almost in center) }
  sub bx,95     { substract 95 pixels (position player almost in center) }
  cmp ax,0      { see if AX>=0 }
  jge @NoSweatX { Yep, so don't worry }
  xor ax,ax     { else it should be 0, map starts at (0,0) }
 @NoSweatX:
  cmp bx,0      { see if BX>=0 }
  jge @NoSweatY { Yep, so don't worry }
  xor bx,bx     { else it should be 0, map starts at (0,0) }
 @NoSweatY:
  mov mapX,ax   { set MAPX to new value }
  mov mapY,bx   { set MAPY to new value }
END;
{}
{
        Calculate the leftX,rightX, topY and botY values to draw the
        correct map tiles.

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE map_calculate; Assembler;
ASM
  mov ax,mapx                   { get map X offset }
  cmp ax,0                      { check with 0 }
  jge @NoSweatX                 { it's not lower then 0, so skip next }
  xor ax,ax                     { set it back to 0 }
  mov mapx,ax                   { and store it to MAPX }
 @NoSweatX:
  mov cx,MapWidth                  { get WIDTH of the map }
  sub cx,XTilesAmount           { substract the tiles that are on screen }
  cmp cx,0                      { see if it's still larger then 0 }
  jge @DontWorryX               { yep, so don't worry }
  xor cx,cx                     { oops, it was negative, so set it to 0 }
 @DontWorryX:
  shl cx,TileShiftFactor        { and multiply with tile-size }
  cmp ax,cx                     { see if AX is lower or equal to BX }
  jle  @NoSweatX2               { yes it is, so we're not out of bounds... }
  mov ax,cx                     { else make sure AX won't be larger then the}
  mov mapx,ax                   { map X value }
 @NoSweatX2:
  shr ax,TileShiftFactor        { divide it with block size }
  mov LeftX,ax                  { store calculated value in LEFTX }
  add ax,XtilesAmount           { add TilesAmount on screen }
  mov RightX,ax                 { and store the value in RIGHTX }

  mov bx,200                    { screen size, for speeding up the process }
  mov cx,MapHeight              { get HEIGHT of the map }
  shl cx,TileShiftFactor        { multiply with tile size }
  mov ax,cx                     { get calculated value in CX }
  sub cx,mapy                   { substract mapy }
  cmp cx,bx                     { see if difference still larger then 200 }
  jge @NoThing                  { yes it is, so we're not out of bounds }
  sub ax,bx                     { oops, mapscrolled to far }
  mov mapy,ax                   { set new value to mapy }
 @NoThing:
  mov ax,mapy                   { get map Y offset }
  cmp ax,0                      { check with 0 }
  jge @NoSweatY                 { it's not lower then 0, so skip next }
  xor ax,ax                     { set it back to 0 }
  mov mapy,ax                   { and store it to MAPY }
 @NoSweatY:
  shr ax,TileShiftFactor        { divide it with block size }

  mov TopY,ax                   { store calculated value in TOPY }
  add ax,YTilesAmount
  mov BotY,ax                   { and store the value in BOTY }
END;
{}
{
        Animates and array of sprites (XAS arrays only!)

        Expects: The array of the sprites, and the amount of images in
                 the array.
        Returns: Nothing

}
PROCEDURE AnimateArray(var Asprites:array of spritetyp;nr:byte); ASSEMBLER;
ASM
   les di,Asprites
   mov si,di             { get tiles array }
{=-=-=-=-=-=-=-=-= Sprite Loop =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
   xor cl,cl            { start at first sprite }
 @SpriteLoop:
   mov al,[si+7]        { get amount of animations }
   cmp al,2             { 2 or more? }
   jb @NoReAnim         { no, so don't animate }
   mov al,[si+5]        { get T_FRAME }         {c=4, t=5,s=6,a=7,n=8}
   cmp al,0             { check with 0 }
   je @SetNewValues     { if it's 0 then set new values }
   dec al               { else decrease it }
   mov [si+5],al        { and set it back }
   jmp @NoReAnim
 @SetNewValues:
   mov al,[si+6]        { get S_FRAME }
   mov [si+5],al        { set T_FRAME }
   mov al,[si+7]        { get A_FRAME }
   cmp al,1             { are there more then 1 frames }
   jle @NoReAnim
   mov al,[si+4]        { get C_FRAME }
   mov ah,[si+8]        { get N_FRAME }
   add al,ah            { add together }
   mov [si+4],al        { store back in C_FRAME }
   mov ah,[si+9]        { get bitflags }
   and ah,1
   jz  @NoCyclicAnimation
   mov ah,[si+7]        { get A_FRAME }
   add ah,cl            { add A_FRAME and First FRAME }
   dec ah               { add one extra }
   cmp al,ah            { see if c_Frame>=first Frame+a_Frame-1 }
   jge @DoReAnim
   cmp al,cl            { see if C_Frame=first Frame }
   jg  @NoReAnim
  @DoReAnim:
   mov ah,[si+8]        { get N_FRAME }
   neg ah               { and make it negative }
   mov [si+8],ah        { set it back }
   jmp @NoReAnim
 @NoCyclicAnimation:
   mov ah,[si+7]        { get A_FRAME }
   add ah,cl            { add A_FRAME and first FRAME }
   cmp al,ah            { see if C_FRAME >= first FRAME+A_FRAME }
   jl @NoReAnim         { if less, nothing happens }
   mov [si+4],cl        { set c_FRAME to first frame }
 @NoReAnim:
   add si,10            { go to next data }
   inc cl
   cmp cl,nr
   jl  @SpriteLoop
END;
{}
{
        Draw the map

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE UpdateMap; Assembler;
VAR   xpos,ypos : word;
      x         : word;
      count     : byte;
      tempBX    : word;
      tempREG   : word;
ASM
   and animated,1       { is there any animated block in the tiles? }
   jz @NoAnimationsNeeded { no, so leave the animation alone!      }
{=-=-=-=-=-=-=-=-=- First let's animate the tiles -=-=-=-=-=-=-=-=-=-=-=-=-=-}
   mov si,offset tiles  { get tiles array }
{=-=-=-=-=-=-=-=-= Sprite Loop =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
   xor cl,cl            { start at sprite #0 }
 @SpriteLoop:
   mov al,[si+7]        { get amount of animations }
   cmp al,2             { 2 or more? }
   jb @NoReAnim         { no, so don't animate }
   mov al,[si+5]        { get T_FRAME }         {c=4, t=5,s=6,a=7,n=8}
   cmp al,0             { check with 0 }
   je @SetNewValues     { if it's 0 then set new values }
   dec al               { else decrease it }
   mov [si+5],al        { and set it back }
   jmp @NoReAnim        { no reset of the animation }
 @SetNewValues:
   mov al,[si+6]        { get S_FRAME }
   mov [si+5],al        { set T_FRAME }
   mov al,[si+7]        { get A_FRAME }
   cmp al,1             { are there more then 1 frames }
   jle @NoReAnim
   mov al,[si+4]        { get C_FRAME }
   mov ah,[si+8]        { get N_FRAME }
   add al,ah            { add together }
   mov [si+4],al        { store back in C_FRAME }
   mov ah,[si+9]        { get bitflags }
   and ah,1             { get correct bit (cycle-animation bit) }
   jz @NoCyclicAnimation
   mov ah,[si+7]        { get A_FRAME }
   add ah,cl            { add A_FRAME and First FRAME }
   inc ah               { add one extra }
   cmp al,ah            { see if c_Frame>=first Frame+a_Frame-1 }
   jge @DoReAnim
   cmp al,cl            { see if C_Frame=first Frame }
   jne @NoReAnim
  @DoReAnim:
   mov ah,[si+8]        { get N_FRAME }
   neg ah               { and make it negative }
   mov [si+8],ah        { set it back }
   jmp @NoReAnim
 @NoCyclicAnimation:
   mov ah,[si+7]        { get A_FRAME }
   add ah,cl            { add A_FRAME and first FRAME }
   cmp al,ah            { see if C_FRAME >= first FRAME+A_FRAME }
   jl @NoReAnim         { if less, nothing happens }
   mov [si+4],cl        { set c_FRAME to first frame }
 @NoReAnim:
   add si,10            { go to next tile-data }
   inc cl               { increase image counter }
   cmp cl,TilesInFile
   jng @SpriteLoop
{=-=-=-=-=-=-=-=- now draw the map graphics -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
  @NoAnimationsNeeded:
      and usecopper,1        { use a copper sky? }
      jz  @NoCopperCall      { no, so don't draw it }
      and copperRevers,1     { reverse the copper color count? }
      jz @CallUpProc         { no, so draw normal color order  }
      call CopperSkyDown     { yes, so draw it }
      jmp @NoCopperCall
   @CallUpProc:
      call CopperSkyUp
   @NoCopperCall:
      and useLayer,1         { use a parallax layer? }
      jz @NoLayerCall        { no, so don't draw it
{=-=-=-=-=-=-=-=- First Create the parallax-layer -=-=-=-=-=-=-=-=-=-=-=-=-=-}
     mov ax,mapx       { get MapX position }
     and ax,127        { MOD with 2 times the layer-image width (64) }
     shr ax,1          { divide with 2 (layer moves at half-speed) }
     neg ax            { make it negative (0-X_offset) }
     mov XPOS,ax       { remember X position }

     mov bx,120        { initial start of single layer row Y position }

     and FullLayer,1    { Using a full layer? }
     jz  @VLoop         { no, so let Y position stay at 120 }
     xor bh,bh          { init the layer-tile counter  }
     mov LayerNR,bh     { set it to 0                  }
     mov bx,192         { set Y counter to 192         }

    @VLoop:
      mov ax,XPOS       { get X starting position back }
      xor ch,ch
      mov cl,6          { 0-6 blocks to set in HORIZONTAL position }
    @SetLayer:
      mov X,AX              { Remember X offset }

      mov si,offset layertile { get offset of layer- tiles data }
      xor ah,ah
      mov al,LayerNR          { get the number of the layer-tile }
      shl al,2                { using pointers, so offset*4      }
      add si,ax               { add tile-offset and layer-tile   }
      les di,[ds:si]          { get image-data pointer           }

      mov AX,X              { get X offset again     }
      mov count,cl          { remember BLOCK counter }
      mov YPOS,bx           { remember Y position    }

{-=-=-=-=-=-=-=-=- Do clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   cmp bx,199              { Y > 199 ? }
   jg @ExitSprite          { JG is for SIGNED integers. If Y pos is
                             > 199 then no blit }
   cmp ax,319              { X > 319 ? }
   jg @ExitSprite          { Yes, Do not do any blits at all }

   mov si,di
   add si,2                { Make SI point to actual sprite data }

   xor ch,ch
   mov cl,[es:di]          { CL holds Clipwidth }

   cmp ah,$80              { Quick test if X position is negative }
   jb @XNotNegativeL       { If not then check if image is off right hand
                             of screen }
   neg ax                  { Make X position positive }

   cmp ax,cx               { If Abs(X) >= Image Width Then Don't Draw }
   ja @ExitSprite

   sub cx,ax               { Dec(ClipWidth, Abs(X)) }
   add si,ax               { Inc(DataStart, Abs(X)) }
   xor ax,ax               { Set X to 0 }
   jmp @NowDoYL            { Do Y portion of data now. }

 @XNotNegativeL:
   mov dx,cx               { Set DX to clipwidth }
   add dx,ax               { If X + ClipWidth < 320 Then }
   cmp dx,320
   jb @NowDoYL             { Do Y part (No need to clip width) }
   mov cx,320
   sub cx,ax               { ClipWidth = 320 - X }

 @NowDoYL:
   xor dh,dh               { Make DX the height of image }
   mov dl,[es:di+1]
   mov ch,dl               { Set CH also to height for main blit routine }

   cmp bh,$80              { Quick test if Y position is negative }
   jb @YNotNegativeL

   neg bx                  { Make Y a positive number }

   cmp bx,dx               { If Y > ClipHeight }
   ja @NoDrawL
   sub dx,bx               { Dec(ClipHeight, Abs(Y) ) }
   mov ch,dl               { As an image can only be 255 bytes high
                             this works fine.. }
   mov TEMPREG,AX          { Save X Coord in variable }
   xor ah,ah
   mov al,[es:di]          { AX = Width }
   mul bx                  { Calculate Y * Width }
   add si,ax               { Inc(DataStart, Abs(Y) * Width ) }
   mov AX,TEMPREG
   xor bx,bx               { Set Y to 0 }
   jmp @NowDoBlitL         { NOW do the blit work. Whew! }

 @YNotNegativeL:
   add dx,bx               { If Y + ClipHeight > 199 Then }
   cmp dx,200
   jb @NowDoBlitL
   mov dx,200
   sub dx,bx               { ClipHeight = 200 - Y }
   mov ch,dl

  @NowDoBlitL:
    or ch,0
    jz @ExitSprite
    or cl,0
    jz @ExitSprite
    mov TEMPREG,CX              { Save ClipWidth & ClipHeight on stack }

{=-=-=-=-=-=-=-=-=-=-=-= Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
     cmp ax,319         { Is X> 319 ? }
     ja @OutOfBoundsL   { Yes }
     cmp bx,199         { Is Y> 199 ?. Do not use BL instead as this is
                          when problems will occur.}
     ja @OutOfBoundsL   { Yes }

     xor ch,ch                  { CX = Y }
     mov cl,bl
     shl cx,6                   { Y * 64 }
     mov bh,bl                  { BX = Y * 256 }
     xor bl,bl
     add bx,cx                  { BX = BX + CX, which gives Y * 320 }
     add bx,ax                  { Add the X position to offset in BX }
     jmp @EndCalcOffsetL        { And exit. }

   @OutOfBoundsL:
     jmp @ExitSprite            { Signal that coordinates were not within
                                  the screen limits }
   @EndCalcOffsetL:
{=-=-=-=-=-=-=-=-=-=-=-= End Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
    mov CX,TEMPREG              { Restore ClipWidth and ClipHeight }

    xor dh,dh
    mov dl,[es:di]              { DX = Modulo }
    mov di,bx                   { Ahhh. Now DI points to the screen offset }
    jmp @EndClipCalcL
  @NoDrawL:
    jmp @ExitSprite            { Indicate no blit possible }
  @EndClipCalcL:
{-=-=-=-=-=-=-=-=- End clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}
   PUSH DS
   PUSH BP

   MOV AX,Vpage_Seg
   MOV BX,ES
   MOV DS,BX                   { Now DS: SI points to correct space }
   MOV ES,AX

   MOV BX,SI                   { BX to be used to reload SI (+Image Width) }
   MOV BP,DI                   { And BP to reload DI (+Screen Width) }

 @OuterL:
   PUSH CX
   MOV CH,CL                   { CH is set to ClipWidth }

   MOV SI,BX
   MOV DI,BP

   CMP CH,4                     { Bytes left < 4 ? }
   JB @CantDoLongWordBlitL      { Yeah, so can't do the 4 byte blit }

   SHR CH,2                     { Divide Bytes left by 4 }

 @CopyLongL:
   DB $66                       { Otherwise, store longword to [ES:DI] ! }
   MOVSW
   DEC CH                       { Reduce long word count }
   JNZ @CopyLongL

   MOV CH,CL                    { Restore CL }
   AND CH,3
   OR CH,CH
   JZ @NoBytesLeftL

 @CantDoLongWordBlitL:
   CMP CH,2                     { Byte count < 2 ? }
   JB @CheckDoByteBlitL         { Yes, can't do a word blit (Shit !)
                                  so that means that there's only 1 byte left}
 @CopyWordL:
   MOVSW                        { Otherwise, write word }
 @CheckDoByteBlitL:
   TEST CH,1                    { Is there a byte left ? }
   JZ @NoBytesLeftL             { No, so no more blits this line }
 @DoByteBlitL:
   MOVSB                        { Store the last byte }
 @NoBytesLeftL:
   ADD BX,DX                    { BP to next byte of image to read }
   ADD BP,320                   { Advance BX to next scan line }

   POP CX
   DEC CH                       { Reduce Y count }
   JNZ @OuterL                  { if <>0 then go to Outer }

   POP BP                       { Restore base pointer and }
   POP DS                       { Data Segment }

 @ExitSprite:
    mov bx,YPOS           { get Y position back    }
    xor ch,ch
    mov cl,count          { get BLOCK counter back }
    mov ax,X              { get X offset back }
    add ax,64             { add 64 to X counter (layer-blocks are 64bytes)}
    dec cx                { decrease layer-line counter }
    jnz @SetLayer         { not done, then draw next }
    and FullLayer,1       { draw multiply lines of layer? }
    jz  @NoLayerCall      { No, so don't do next bit      }
    {
     Calculate values for next go
    }
    inc LayerNR           { increase layer-number for next line }
    mov cl,1
    and MultipleSpeeds,1  { using multiple speeds? }
    jz  @OneSpeed         { no, just one speed for complete background }
    mov cl,LayerNR        { get layerNR into CL }
    inc cl
  @OneSpeed:
    mov bx,64             { block width is 64   }
    shl bx,cl             { multiply with LayerNR }
    dec bx                { decrease by one, so we can do a AND with it }
    mov ax,mapx           { get MapX position }
    and ax,bx             { MOD with 2 times the layer-image width (64) }
    shr ax,cl             { divide with correct speed (2,4,8,16)        }
    neg ax                { make it negative (0-X_offset) }
    mov XPOS,ax           { remember X position }

    mov bx,YPOS           { get Yposition }
    sub bx,64             { increase Y position }
    cmp bx,0              { see if we're at the bottom }
    jge @Vloop            { no, so draw next line }
{=-=-=-=-=-=-=-=- Done the layer -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
  @NoLayerCall:
      mov ax,LeftX           { get X position }
      mov X,AX               { set X position }
      shl ax,TileShiftFactor { multiply with the correct value (tile size)}
      sub ax,mapx            { substract MapX }
      mov xpos,ax            { and copy it to XPOS value }

    @StartXLoop:
      mov ax,TopY            { get first Y position }
      mov BX,AX              { set Y position }
      shl ax,Tileshiftfactor { multiply with tilesize }
      sub ax,mapy            { substract MAPY }
      mov ypos,ax            { and put it in YPOS }

    @StartYLoop:
      mov cx,MapWidth      { get MAP WIDTH }
      inc cx               { add 1 for correction }
      mov ax,bx            { get Y position in map }
      mul cx               { multiply Y with MAPWIDTH }
      add ax,x             { add X position in map }
      shl ax,1             { multiply with 2 (sizeof MAPTYPE) }

      les si,map
      add si,ax            { add calculated offset }
      mov al,[es:si]          { read MAP BASE FRAME }
      mov ah,[es:si+1]        { get BITFLAG }
      cmp ah,3             { check with "INFRONT" code }
      je @NoSpritePutting2 { It's infront of the player }

    { Using copper bar, if not, draw full blocks! }

      and LayerCopper,1      { use a copper sky or parallax? }
      jz @NoNeedToCheck      { yes, so mask all images }

     { MASKED IMAGES check on frame=0 }
      cmp al,0             { see if it's the empty-background image }
      je @NoSpritePutting2 { YES, so don't put it, we use a copper-bar }

    @NoNeedToCheck:
      xor ah,ah
      mov si,offset tiles  { get offset of tiles-images }
      mov cx,ax            { size of SPRITETYPE }
      shl cx,1             { multiply with 2... }
      shl ax,3             { multiply with 8... }
      add ax,cx            { add together (AX*10) }
      add si,ax            { add AX to tiles-offset }

      xor ah,ah
      mov al,[si+4]        { get C_FRAME pointing to new animation }
{=-=- For animation, we got to be at another sprite, so calculate it -=-=-=-=}
      mov si,offset tiles   { get offset of tiles-images }
      mov cx,ax             { get AX in CX }
      shl cx,1              { multiply with 2... }
      shl ax,3              { ... and with 8... }
      add ax,cx             { add together (spritetyp=10 bytes so AX*10) }
      add si,ax             { add AX (C_FRAME) to tiles-offset }
      mov al,[si+9]         { get BitFlags }

    @NoAnimation:
      les di,[si]          { get seg+ofs of image-data }
      mov tempBX,BX        { remember Y counter }
      mov bx,ypos          { Y position of image }

      and al,2             { check if second bit is set }
      jnz @NoNeedToMask    { it's set, so use SPRITENOMASK (FASTER!!!) }
      and LayerCopper,1    { check if using a copper or parallax }
      jz  @NoNeedToMask    { it's not set, so no masking }
      mov ax,xpos          { X position of image }

{-=-=-=-=-=-=-=-=- Do clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   cmp bx,199              { Y > 199 ? }
   jg @nospriteputting     { JG is for SIGNED integers. If Y pos is
                             > 199 then no blit }
   cmp ax,319              { X > 319 ? }
   jg @nospriteputting     { Yes, Do not do any blits at all }

   mov si,di
   add si,2                { Make SI point to actual sprite data }

   xor ch,ch
   mov cl,[es:di]          { CL holds Clipwidth }

   cmp ah,$80              { Quick test if X position is negative }
   jb @XNotNegative        { If not then check if image is off right hand
                             of screen }
   neg ax                  { Make X position positive }

   cmp ax,cx               { If Abs(X) >= Image Width Then Don't Draw }
   ja @nospriteputting

   sub cx,ax               { Dec(ClipWidth, Abs(X)) }
   add si,ax               { Inc(DataStart, Abs(X)) }
   xor ax,ax               { Set X to 0 }
   jmp @NowDoY             { Do Y portion of data now. }

 @XNotNegative:
   mov dx,cx               { Set DX to clipwidth }
   add dx,ax               { If X + ClipWidth < 320 Then }
   cmp dx,320
   jb @NowDoY              { Do Y part (No need to clip width) }
   mov cx,320
   sub cx,ax               { ClipWidth = 320 - X }

{  At this point:

      AX is the X position of the Shape
      BX is the Y position of the Shape
      CL is the clipped width of the Shape.

      Now it is time to do the height part and set the result in CH.
}

 @NowDoY:
   xor dh,dh               { Make DX the height of image }
   mov dl,[es:di+1]
   mov ch,dl               { Set CH also to height for main blit routine }

   cmp bh,$80              { Quick test if Y position is negative }
   jb @YNotNegative

   neg bx                  { Make Y a positive number }

   cmp bx,dx               { If Y > ClipHeight }
   ja @NoDraw
   sub dx,bx               { Dec(ClipHeight, Abs(Y) ) }
   mov ch,dl               { As an image can only be 255 bytes high
                             this works fine.. }
   mov TEMPREG,AX          { Save X Coord on stack }
   xor ah,ah
   mov al,[es:di]          { AX = Width }
   mul bx                  { Calculate Y * Width }
   add si,ax               { Inc(DataStart, Abs(Y) * Width ) }
   mov AX,TEMPREG
   xor bx,bx               { Set Y to 0 }
   jmp @NowDoBlit          { NOW do the blit work. Whew! }

 @YNotNegative:
   add dx,bx               { If Y + ClipHeight > 199 Then }
   cmp dx,200
   jb @NowDoBlit
   mov dx,200
   sub dx,bx               { ClipHeight = 200 - Y }
   mov ch,dl

{
        At this point AX is the X position
                      BX is the Y position
                      CL is the ClipWidth and
                      CH is the ClipHeight.

        As the width/height of an Shape can only be an 8 bit
        quantity (i.e. < 256) I can discard the H portions of
        the registers. Whew!

        Now follows some weird code.. I'm going to make :

        DX = Modulo for datastart (which is the width in bytes of Shape.
        And yes, I do know that Width could be held in DL but adding extra
        code just to satisfy you optimisation junkies is v. boring.)

        DS:SI already points to data
        ES:DI points to active (source) Bitmap

}
  @NowDoBlit:
    or ch,ch
    jz @nospriteputting
    or cl,cl
    jz @nospriteputting

    mov TEMPREG,CX        { Save ClipWidth & ClipHeight on stack }

{=-=-=-=-=-=-=-=-=-=-=-= Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
     cmp ax,319         { Is X> 319 ? }
     ja @OutOfBounds    { Yes }
     cmp bx,199         { Is Y> 199 ?. Do not use BL instead as this is
                          when problems will occur.}
     ja @OutOfBounds    { Yes }

     xor ch,ch                  { CX = Y }
     mov cl,bl
     shl cx,6                   { Y * 64 }
     mov bh,bl                  { BX = Y * 256 }
     xor bl,bl
     add bx,cx                  { BX = BX + CX, which gives Y * 320 }
     add bx,ax                  { Add the X position to offset in BX }

     jmp @EndCalcOffset         { And exit. }

@OutOfBounds:
     jmp @nospriteputting        { coordinates are not within screen limites,
                                   so exit blitting }
@EndCalcOffset:

{=-=-=-=-=-=-=-=-=-=-=-= End Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
    mov CX,TEMPREG              { Restore ClipWidth and ClipHeight }

    xor dh,dh
    mov dl,[es:di]              { DX = Modulo }
    mov di,bx                   { Ahhh. Now DI points to the screen offset }
    jmp @EndClipCalc
  @NoDraw:
    jmp @nospriteputting        { no blit is possible }
  @EndClipCalc:
{-=-=-=-=-=-=-=-=- End clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   PUSH DS
   PUSH BP

   MOV AX,vpage_Seg
   MOV BX,ES
   MOV DS,BX                   { Now DS: SI points to correct space }
   MOV ES,AX

   MOV BX,SI                   { BX to be used to reload SI }
   MOV BP,DI                   { And the screen modulo }

   MOV AH,CL                   { AH = Width }
   CLD                         { Make sure LODSB works OK }

@Outer:
   MOV CL,AH                   { Re-load CL }
   MOV SI,BX                   { And SI with address of next sprite row }
   MOV DI,BP                   { And DI with address of next scan line }


@WriteByte:
   LODSB                       { Read byte from DS:SI }
   OR AL,AL                    { Is byte 0 (transparent) ? }
   JZ @NoBlit                  { yes, so don't blit }
   MOV [ES:DI],AL              { Otherwise store byte }

@NoBlit:
   INC DI                       { Move DI to next pos. on screen }
   DEC CL                       { Reduce shape width count }
   JNZ @WriteByte               { If not zero, end of shape not reached }

   ADD BX,DX                    { BX = BX + Modulo, so BX now points
                                  to first byte of next sprite line
                                  to blit }
   ADD BP,320                   { Make BP point to next line. Note :
                                  If you are going to add some extra
                                  stuff here make sure you're not
                                  accessing local variables! }


   DEC CH
   JNZ @Outer

   POP BP
   POP DS

   jmp @NoSpritePutting { done the image }

     @NoNeedToMask:
      mov ax,xpos          { X position of image }
{-=-=-=-=-=-=-=-=- Do clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   cmp bx,199              { Y > 199 ? }
   jg @nospriteputting     { JG is for SIGNED integers. If Y pos is
                             > 199 then no blit }
   cmp ax,319              { X > 319 ? }
   jg @nospriteputting     { Yes, Do not do any blits at all }

   mov si,di
   add si,2                { Make SI point to actual sprite data }

   xor ch,ch
   mov cl,[es:di]          { CL holds Clipwidth }

   cmp ah,$80              { Quick test if X position is negative }
   jb @XNotNegativemask    { If not then check if image is off right hand
                             of screen }
   neg ax                  { Make X position positive }

   cmp ax,cx               { If Abs(X) >= Image Width Then Don't Draw }
   ja @nospriteputting

   sub cx,ax               { Dec(ClipWidth, Abs(X)) }
   add si,ax               { Inc(DataStart, Abs(X)) }
   xor ax,ax               { Set X to 0 }
   jmp @NowDoYmask         { Do Y portion of data now. }

 @XNotNegativemask:
   mov dx,cx               { Set DX to clipwidth }
   add dx,ax               { If X + ClipWidth < 320 Then }
   cmp dx,320
   jb @NowDoYmask          { Do Y part (No need to clip width) }
   mov cx,320
   sub cx,ax               { ClipWidth = 320 - X }

{  At this point:

      AX is the X position of the Shape
      BX is the Y position of the Shape
      CL is the clipped width of the Shape.

      Now it is time to do the height part and set the result in CH.
}

 @NowDoYmask:
   xor dh,dh               { Make DX the height of image }
   mov dl,[es:di+1]
   mov ch,dl               { Set CH also to height for main blit routine }

   cmp bh,$80              { Quick test if Y position is negative }
   jb @YNotNegativemask

   neg bx                  { Make Y a positive number }

   cmp bx,dx               { If Y > ClipHeight }
   ja @NoDrawmask
   sub dx,bx               { Dec(ClipHeight, Abs(Y) ) }
   mov ch,dl               { As an image can only be 255 bytes high
                             this works fine.. }
   mov TEMPREG,AX          { Save X Coord in variable }
   xor ah,ah
   mov al,[es:di]          { AX = Width }
   mul bx                  { Calculate Y * Width }
   add si,ax               { Inc(DataStart, Abs(Y) * Width ) }
   mov AX,TEMPREG
   xor bx,bx               { Set Y to 0 }
   jmp @NowDoBlitmask      { NOW do the blit work. Whew! }

 @YNotNegativemask:
   add dx,bx               { If Y + ClipHeight > 199 Then }
   cmp dx,200
   jb @NowDoBlitmask
   mov dx,200
   sub dx,bx               { ClipHeight = 200 - Y }
   mov ch,dl

{
        At this point AX is the X position
                      BX is the Y position
                      CL is the ClipWidth and
                      CH is the ClipHeight.

        As the width/height of an Shape can only be an 8 bit
        quantity (i.e. < 256) I can discard the H portions of
        the registers. Whew!

        Now follows some weird code.. I'm going to make :

        DX = Modulo for datastart (which is the width in bytes of Shape.
        And yes, I do know that Width could be held in DL but adding extra
        code just to satisfy you optimisation junkies is v. boring.)

        DS:SI already points to data
        ES:DI points to active (source) Bitmap

}
  @NowDoBlitmask:
    or ch,0
    jz @nospriteputting
    or cl,0
    jz @nospriteputting
    mov TEMPREG,CX              { Save ClipWidth & ClipHeight on stack }

{=-=-=-=-=-=-=-=-=-=-=-= Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
     cmp ax,319         { Is X> 319 ? }
     ja @OutOfBoundsmask{ Yes }
     cmp bx,199         { Is Y> 199 ?. Do not use BL instead as this is
                          when problems will occur.}
     ja @OutOfBoundsmask{ Yes }

     xor ch,ch                  { CX = Y }
     mov cl,bl
     shl cx,6                   { Y * 64 }
     mov bh,bl                  { BX = Y * 256 }
     xor bl,bl
     add bx,cx                  { BX = BX + CX, which gives Y * 320 }
     add bx,ax                  { Add the X position to offset in BX }
     jmp @EndCalcOffsetmask     { And exit. }

   @OutOfBoundsmask:
     jmp @nospriteputting       { Signal that coordinates were not within
                                  the screen limits }
   @EndCalcOffsetmask:
{=-=-=-=-=-=-=-=-=-=-=-= End Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
    mov CX,TEMPREG              { Restore ClipWidth and ClipHeight }

    xor dh,dh
    mov dl,[es:di]              { DX = Modulo }
    mov di,bx                   { Ahhh. Now DI points to the screen offset }
    jmp @EndClipCalcmask
  @NoDrawmask:
    jmp @nospriteputting       { Indicate no blit possible }
  @EndClipCalcmask:
{-=-=-=-=-=-=-=-=- End clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}
   PUSH DS
   PUSH BP

   MOV AX,Vpage_Seg
   MOV BX,ES
   MOV DS,BX                   { Now DS: SI points to correct space }
   MOV ES,AX

   MOV BX,SI                   { BX to be used to reload SI (+Image Width) }
   MOV BP,DI                   { And BP to reload DI (+Screen Width) }

 @Outermask:
   PUSH CX
   MOV CH,CL                   { CH is set to ClipWidth }

   MOV SI,BX
   MOV DI,BP

   CMP CH,4                     { Bytes left < 4 ? }
   JB @CantDoLongWordBlitmask   { Yeah, so can't do the 4 byte blit }

   SHR CH,2                     { Divide Bytes left by 4 }

 @CopyLongmask:
   DB $66                       { Otherwise, store longword to [ES:DI] ! }
   MOVSW
   DEC CH                       { Reduce long word count }
   JNZ @CopyLongmask

   MOV CH,CL                    { Restore CL }
   AND CH,3
   OR CH,CH
   JZ @NoBytesLeftmask


 @CantDoLongWordBlitmask:
   CMP CH,2                     { Byte count < 2 ? }
   JB @CheckDoByteBlitmask      { Yes, can't do a word blit (Shit !)
                                  so that means that there's only
                                  1 byte left. }
 @CopyWordmask:
   MOVSW                        { Otherwise, write word }


 @CheckDoByteBlitmask:
   TEST CH,1                    { Is there a byte left ? }
   JZ @NoBytesLeftmask          { No, so no more blits this line }

 @DoByteBlitmask:
   MOVSB                        { Store the last byte }

 @NoBytesLeftmask:
   ADD BX,DX                    { BP to next byte of image to read }
   ADD BP,320                   { Advance BX to next scan line }

   POP CX
   DEC CH                       { Reduce Y count }
   JNZ @Outermask               { if <>0 then go to Outer }

   POP BP                       { Restore base pointer and }
   POP DS                       { Data Segment }

    @NoSpritePutting:
      mov BX,TempBX        { Get Y counter back }
    @NoSpritePutting2:
      add ypos,tilesize { add TILESIZE for next position }
      inc bx            { increase Y counter }
      cmp bx,boty       { check with bottom Y }
      jng @StartYLoop   { Not yet done Vertical, so draw next }

      add Xpos,tilesize { add TILESIZE for next position }
      mov ax,RightX     { get rightX }
      inc X             { increase X counter }
      cmp x,ax          { check with right X }
      jng @StartXLoop   { not yet done Horizontal, so draw next }

      call DoImages     { draw all sprite/image objects }
      call DoFx         { draw all special effects (explosions, etc...) }

{=-=-=-=-=-=-=-=- Now do all blocks, infront of the images -=-=-=-=-=-=-=-=-=}
      mov ax,LeftX           { get X position }
      mov X,AX               { set X position }
      shl ax,TileShiftFactor { multiply with the correct value }
      sub ax,mapx            { substract MapX }
      mov xpos,ax            { and copy it to XPOS value }

    @StartXLoop_2:
      mov ax,TopY           { get first Y position }
      mov BX,AX             { set Y position }
      shl ax,Tileshiftfactor{ multiply with tilesize }
      sub ax,mapy           { substract MAPY }
      mov ypos,ax           { and put it in YPOS }

    @StartYLoop_2:
      mov cx,MapWidth   { get MAP WIDTH }
      inc cx               { add 1 for correction }
      mov ax,bx            { get Y position in map }
      mul cx               { multiply Y with MAPWIDTH }
      add ax,x             { add X position in map }
      shl ax,1             { multiply with 2 (sizeof MAPTYPE) }

      les si,map
{      mov si,offset map    { get MAP offset }
      add si,ax            { add calculated offset }
      mov al,[es:si]          { read MAP BASE FRAME }
      mov ah,[es:si+1]        { get BITFLAG of block }
      cmp ah,3             { see if it's infront of the player }
      jne @NoSpritePutting2_2{ if not, don't draw it }

      xor ah,ah
      mov si,offset tiles  { get offset of tiles-images }
      mov cx,ax            { size of SPRITETYPE }
      shl cx,1             { multiply with 2... }
      shl ax,3             { multiply with 8... }
      add ax,cx            { add together (AX*10) }
      add si,ax            { add AX to tiles-offset }

      xor ah,ah
      mov al,[si+4]        { get C_FRAME pointing to new animation }
{=-=- For animation, we got to be at another sprite, so calculate it -=-=-=-=}
      mov si,offset tiles   { get offset of tiles-images }
      mov cx,ax             { get AX in CX }
      shl cx,1              { multiply with 2... }
      shl ax,3              { ... and with 8... }
      add ax,cx             { add together (spritetyp=10 bytes so AX*10) }
      add si,ax             { add AX (C_FRAME) to tiles-offset }
      mov al,[si+9]         { get BitFlags }

    @NoAnimation_2:
      les di,[si]          { get seg+ofs of image-data }
      mov tempBX,BX        { remember Y counter }
      mov bx,ypos          { Y position of image }

      and al,2             { check if second bit is set }
      jnz @NoNeedToMask_2  { it's set, so use SPRITENOMASK (FASTER!!!) }
      mov ax,xpos          { X position of image }
      call Sprite          { show ME!!!!! }
      jmp @NoSpritePutting_2{ done the image }

     @NoNeedToMask_2:
      mov ax,xpos          { X position of image }
      call SpriteNoMask    { show ME!!!!! }

    @NoSpritePutting_2:
      mov BX,tempBX     { Get Y counter back }
    @NoSpritePutting2_2:
      add ypos,tilesize { add TILESIZE for next position }
      inc bx            { increase Y counter }
      cmp bx,boty       { check with bottom Y }
      jng @StartYLoop_2 { Not yet done Vertical, so draw next }

      add Xpos,tilesize { add TILESIZE for next position }
      mov ax,RightX     { get rightX }
      inc X             { increase X counter }
      cmp x,ax          { check with right X }
      jng @StartXLoop_2 { not yet done Horizontal, so draw next }
END;
{}
{
        Check on a certain block in the map

        Expects: X,Y positions, and mapVAL... mapval can be passed with
                 mapF_Frame or mapBitflag
        Returns: Value of the specified map-positions byte
}
FUNCTION MapPos(x,y:integer;mapval:word):byte; Assembler;
ASM
   les di,map
   mov ax,y
   mov cx,mapwidth
   inc cx
   imul cx
   add ax,x
   shl ax,1
   add ax,mapVal
   add di,ax
   xor ah,ah
   mov al,es:[di]
END;
{}
{
        Set the value of a certain block in the map

        Expects: X,Y positions, and mapVAL... mapval can be passed with
                 mapF_Frame or mapBitflag
                 and the new value to put there
        Returns: Nothing
}
PROCEDURE SetMapPos(x,y:integer;mapval:word;value:byte); Assembler;
ASM
   les di,map
   mov ax,y
   mov cx,mapwidth
   inc cx
   imul cx
   add ax,x
   shl ax,1
   add ax,mapVal
   add di,ax
   mov al,value
   mov es:[di],al
END;
{}
{
        DeAllocate the current map

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE DeAllocMAP;
BEGIN
  if map<>nil then begin
    {$IFDEF USEDOSMEM}
      DAlloc(map);
    {$ELSE}
      FreeMem(map,(mapheight+1)*(mapwidth+1)*sizeof(MapType));
    {$ENDIF}
  end;
END;
{}
{
        Allocate a new map (deallocates old one if needed)

        Expects: Nothing  but set the MAPWIDTH and MAPHEIGHT values first
        Returns: Nothing
}
PROCEDURE NewMAP;
VAR x,y : integer;
BEGIN
  if map<>nil then begin
    {$IFDEF USEDOSMEM}
      DAlloc(map);
    {$ELSE}
      FreeMem(map,(mapheight+1)*(mapwidth+1)*sizeof(MapType));
    {$ENDIF}
  end;
  {$IFDEF USEDOSMEM}
     MemAlloc(map,(mapheight+1)*(mapwidth+1)*sizeof(maptype));
  {$ELSE}
     GetMem(map,(mapheight+1)*(mapwidth+1)*sizeof(maptype));
  {$ENDIF}
  for x:=0 to Mapwidth do begin
      for y:=0 to Mapheight do begin
          SetMapPos(x,y,mapF_frame,0);
          SetMapPos(x,y,mapBitFlag,0);
      end;
  end;

END;


{}
{

        Add an on-screen image to the list

        Expects: X and Y position, pointer to image-data
        Returns: True if succesfully added the bullet

}
FUNCTION AddIMAGE( Xpos2,Ypos2     : integer;
                   IMGPOINT        : pointer;
                   Flipped2,Blink2 : boolean):boolean;
VAR  Temp     : PActive;
     i        : word;
     add      : word;
BEGIN
 AddIMAGE:=false;

 new(Temp);
 if Temp=NIL then exit;

 if FirstACTIVE=NIL  then begin
    LastACTIVE:=Temp;
    FirstACTIVE:=Temp;
    with FirstACTIVE^ do begin
         next:=NIL;
         prev:=Nil;
    end;
 end else begin
     LastACTIVE^.next :=temp;
     Temp^.prev       :=LastACTIVE;
     LastACTIVE       :=Temp;
     Temp^.next       :=NIL;
 end;


 With TEMP^ do begin
  xpos   :=xpos2;
  ypos   :=ypos2;
  IMG    :=IMGPOINT;
  Flipped:=Flipped2;
  Blink  :=Blink2;
 end;

 AddImage:=true;
END;
{}
{

        Erase an IMAGE from the linked-list

        Expects: pointer to PACTIVE object that needs to be ERASED!
        Returns: True if succesfull

}
FUNCTION EraseIMAGE(Temp:PACTIVE):boolean;
VAR  nextIMG  : PACTIVE;
     prevIMG  : PACTIVE;
     i        : integer;
     msize    : word;
BEGIN
  EraseIMAGE:=false;
  if Temp=NIL then exit;

  prevIMG:=Temp^.prev;
  nextIMG:=Temp^.next;

  if prevIMG=NIL then begin
     FirstACTIVE:=nextIMG;
  end else PrevIMG^.next:=nextIMG;

  if nextIMG=NIL then begin
     LastACTIVE:=prevIMG;
  end else NextIMG^.prev:=prevIMG;

  dispose(Temp);
  EraseImage:=true;
END;
{}
{
        Draw all images for current frame

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE doImages;
VAR temp      : PActive;
    nextIMG   : PActive;
    done      : boolean;
BEGIN
 temp:=FirstACTIVE;
 while temp<>Nil do begin
        done:=false;
        nextIMG:=temp^.next;
         ASM
             mov DX,DS             { remember DS }
             lds si,temp
             mov ax,ds:[si+4]      { get Xposition }
             mov bx,ds:[si+6]      { get Yposition }
             mov cl,ds:[si+8]      { get FLIPPED   }
             mov ch,ds:[si+9]      { get BLINK     }
             les di,ds:[si]        { get pointer to IMAGE data }
             mov DS,DX             { get DS back   }
             and cl,1              { is it flipped? }
             jz  @NotFlipped       { no. }
             and ch,1              { is it blinked? }
             jz  @NoFlipBlink      { no. }
             call XFlipSpriteBlink { call flip+blink }
             jmp @DoneSprite       { done the sprite }
            @NoFlipBlink:
             call XFlipSprite      { flip the sprite }
             jmp @DoneSprite       { done the sprite }
            @NotFlipped:
             and ch,1              { is it blinked? }
             jz  @NoBlink          { no, it's normal! }
             call SpriteBlink      { call blinked }
             jmp @DoneSprite       { done the sprite }
            @NoBlink:
             call Sprite           { call the sprite }
            @DoneSprite:
         END;
         EraseIMAGE(Temp);
         temp:=nextIMG;
   end;
END;
{}
{

        Initialises the SinusTable

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE InitSinus;
VAR i,j : integer;
    val : integer;
BEGIN
 j:=220;                          { don't change the start position!!! }
 for i:=0 to 180 do begin
  val:=round(sin((pi*j)/180)*30);
  with linedata[i] do begin
       if val>0 then begin
          YDest:=val;
          Ysource:=0;
          LineLength:=200-Val;
       end else begin
          YDest:=0;
          YSource:=-Val;
          lineLength:=200+val;
       end;
  end;
  inc(j,2);
  if j>360 then dec(j,360);
 end;

END;
{}
{
        Initialise the WAVE effect

        Expects: Amount of wave-times
        Returns: Nothing
}
PROCEDURE InitWave(WaveAmount:Byte);
BEGIN
 FXSinusPosition := 0;          { start at beginning of sinus table }
 FXWave          := TRUE;       { Using WAVE is TRUE }
 FXLoop          := WaveAmount; { Amount of times to go thru sinus table }
 FXOutCount      := 80;         { Time before stopping the wave }
 FXStart         := true;       { First time in wave-cycle? }
END;
{}
{
        Stop the current WAVE effect

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE StopWave; Assembler;
ASM
  mov fxoutcount,79
  xor al,al
  mov fxloop,al
END;
{}
{
        Show some cool FX... eat this supernintendo, without a FX chip!!!

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE WaveFX; Assembler;
VAR LineOffset : word;
ASM
   and FXStart,1                { starting the FX ? }
   jz  @NotInStartingFase       { nope, so skip next bit }
   DB $66; xor ax,ax            { set EAX to 0 }
   mov es,sega000               { set screen segment }
   mov di,53760                 { set screen offset to bottom few lines }
   mov cx,2560                  { set CX to the amount of bytes/4 }
   DB $66; rep STOSW            { store double-words }
   mov FXStart,false            { starting FX is now false }

 @NotInStartingFase:

  { SET THE BOTTOM and the TOP of the VPAGE to black (to erase old lines) }
   DB $66                        { double word mode }
   xor ax,ax                     { set AX to 0 }
   mov es,vpage_seg              { set screen segment }
   xor di,di                     { set screen offset }
   mov DX,DS                     { remember DS }
   mov ds,vpage_seg              { get screen segment }
   mov si,63680                  { get bottom screen offset }
   mov cx,80                     { store 320 div 4 bytes }
 @BlacknessLoop:
   DB $66;  STOSW                { store top line }
   DB $66;  mov ds:[si],ax       { store bottom line }
   add si,4                      { add 4 to offset 2 }
   loop @Blacknessloop           { loop until CX=0   }
   mov DS,DX                     { get DS back       }

   mov es,sega000                { get screen segment }
 { GET START POSITION IN SINUS TABLE }
   mov bx,FXSinusPosition        { get main sinus-start position }
   mov WaveSinStart,bx           { store it in a temp variable }
   xor ax,ax                     { set AX to 0 }
   mov WaveXlines,ax             { set X counter to 0 }

  { CALCULATE START of LINEDATA table }
   mov si,bx                    { get table offset value }
   mov cx,si                    { get table offset in CX aswell }
   shl cx,1                     { multiply with 2 }
   shl si,2                     { and with 4 ( that's 6 = linedata size ) }
   add si,cx                    { add them together }
   add si,offset LineData       { add offset to SI }

  @MainXLoop:
   mov lineoffset,si            { remember lineoffset }
   mov bx,[si]                  { get YDestination value }
   mov cx,[si+2]                { get LineLength }
   mov dx,[si+4]                { get YSource value }

 { INITIALISE DRAWING POSITIONS, AND VARIABLES }
   mov di,bx            { for multiplying get YDEST in DI aswell }
   shl bx,8             { multiply with 128... }
   shl di,6             { ...and with 64, so thats BX * 320 }
   add di,bx            { add calculated offset to screen offset }

   mov ax,WaveXlines    { get X position }
   shl ax,3             { we draw 8 bytes at once, so multiply X*8 }
   add di,ax            { add X offset to screen offset }

   mov si,dx               { get Source Y start position }
   shl si,8                { multiply with 128... }
   shl dx,6                { ... and with 64, so thats BX * 320 }
   add si,dx               { add together }
   add si,ax               { add precalculate value to AX }

   mov DX,DS            { remember DS }
   mov ds,vpage_seg     { get image segment }

 { GO AND DRAW THE CURRENT VERTICAL LINE (8 bytes thick) }

 @VLoop:
   DB $66; MOVSW        { double words }
   DB $66; MOVSW        { double words }

   mov ax,312           { for faster adding of DI and SI }
   add di,ax            { go to next line }
   add si,ax            { go to next line }
   loop @Vloop          { loop until CX=0 }
   mov DS,DX            { get DS back }

 { GO INITALISE FOR THE NEXT LINE }
   mov si,Lineoffset    { get line table offset }

   mov bx,WaveSinStart  { get WaveSinStart value }
   xor ah,ah            { set AH to 0 }
   mov al,FXOutCount    { get "count-down byte" into AL }
   cmp al,40            { see if we done all pixels (320 div 8) }
   jne @Not80           { nope, so skip next bit }
   inc bx               { increase Sinustable... }
   add si,6             { add 6 (length of linedata type) }
   jmp @Done80          { jump to done }
 @Not80:
   cmp ax,WaveXlines    { check FXOUTCOUNT with X position }
   jl @Done80           { if less, don't change }
   inc bx               { increase Sinustable... }
   add si,6             { add 6 (length of linedata type) }
 @Done80:
   cmp bx,180           { see if we done all the 180 values }
   jl  @NoDecreaseStart { if less, don't change it }
   sub bx,180           { else set it back to start of sinus }
   mov si,offset LineData { reset line data pointer }
 @NoDecreaseStart:
   mov WaveSinStart,bx  { Set WaveSINstart back again }

   inc WaveXLines       { go to next vertical line }
   cmp WaveXLines,39    { done all 40 (320 div 8, using double-words!) }
   jle @MainXloop       { if less or equal, draw next }

 { DRAWING DONE, INITIALISE FOR NEXT TIME THIS IS CALLED }
   mov ax,FXSinusPosition
   inc ax                 { add 1 to the sinus start position... }
   cmp FXOutCount,80      { see if we are busy stopping }
   je  @SkipReset         { nope, so skip it }
   dec FXOutCount         { yes, so decrease until 0 }
   jnz @SkipReset         { if not 0, no reset }
   mov FXWave,false       { else this FX is done... }
 @SkipReset:
   cmp ax,180                   { see if we did all the values }
   jl  @NoChange1               { no, so don't reset it }
   sub ax,180                   { yes, so set to start of sinus }
   cmp fxloop,0                 { see if FX loop is 0 }
   je  @NoChange2               { yes it is }
   dec fxloop                   { not it ain't so decrease it }
   jmp @NoChange1               { skip CHANGE2 part }
 @NoChange2:
   xor bx,bx                    { set BX to 0 }
   mov fxloop,bl                { set FXLoop to 0 }
   mov fxoutcount,79            { set FXOUTCOUNT to 79 }
 @NoChange1:
   mov fxsinusposition,ax       { set FXSinusPosition to 0 }
END;
{}
{
       Initialise the colors, and the tile board for the Checkerd Board

       Expects: The RED,GREEN and BLUE values of the 2 colors
       Returns: True if initialised
}
FUNCTION InitBoard(cr1,cg1,cb1,cr2,cg2,cb2:byte):boolean;
VAR PalXCounter : Byte;
    PalYCounter : Byte;
    TempBX      : word;
    Z           : word;
    TempDi      : word;

    PROCEDURE GetPtrData(pt:pointer; VAR Segm, Offs:word); Assembler;
    ASM
       LES DI,PT            { Point ES:DI to where PT is in memory }
       MOV AX,ES            { Set AX to hold segment }
       MOV BX,DI            { BX to hold offset }

       LES DI,Segm          { Now write directly to variable Segm }
       MOV [ES:DI],AX
       LES DI,Offs          { And variable Offs }
       MOV [ES:DI],BX
    END;

BEGIN
  InitBoard:=false;
  { Get memory for board }
  {$IFDEF USEDOSMEM}
     MemAlloc(Board_PTR,25600);
  {$ELSE}
     GetMem(Board_PTR,25600);
  {$ENDIF}
  if Board_Ptr=nil then begin
     Halt_Error:='Couldn''t spawn board';
     exit;
  end;

  GetPtrData(Board_Ptr,board_seg,board_ofs);

  { First create the colors (colors 1-64 are used for the ground) }
  For PalYCounter := 1 to 64 do
     With Pal[PalYCounter] do begin
       RedLevel   := cr1;
       GreenLevel := cg1;
       BlueLevel  := cb1;
  End;
  For PalYCounter := 0 to 3 do
      For PalXCounter := 0 to 3 do begin
      With Pal[1 + PalXCounter + (PalYCounter shl 3)] do begin
           RedLevel   := cr2;
           GreenLevel := cg2;
           BlueLevel  := cb2;
      End;
      With Pal[37+PalXCounter+(PalYCounter shl 3)] do begin
           RedLevel   := cr2;
           GreenLevel := cg2;
           BlueLevel  := cb2;
      End;
  End;
  {   Now Create the Tile  }
  ASM
   xor bx,bx            { set Y counter to 0 }
 @YLoop:
   xor cx,cx            { set X counter to 0 }
 @XLoop:
   mov SI,offset Tile   { get tile offset    }
   mov ax,cx            { get X counter      }
   shl ax,3             { multiply with 8 (width) }
   add ax,bx            { add Y counter }
   add si,ax            { add to tile-offset }

   mov ax,bx            { get Y counter }
   shl ax,3             { multiply with 8 (height) }
   add ax,cx            { add X counter }
   inc ax               { increase }
   mov ds:[si],al       { store color }
   inc cx               { increase X counter }
   cmp cx,8             { see if we're done }
   jl @Xloop            { not yet... }

   inc bx               { increase Y counter }
   cmp bx,8             { see if we're done }
   jl @Yloop            { not yet... }
  END;

  { Draw the Graphic Board }
  ASM
    mov es,board_seg
    mov bx,120           { starting Y position }

  @DoYLoop:
    mov tempBX,bx          { remember BX }
    shl bx,4               { multiply with 16   }
    add bx,ViewerDist      { add ViewerDistance }
    mov ax,-1700           { make BX -1800 }
    add ax,bx              { add calculated AX to BX }
    mov Z,ax               { remember it in Z }

    mov di,board_Ofs       { start screen offset }
    mov bx,Z               { get Z position }
    mov cx,ViewerDist      { get ViewerDistance }

  @DrawLoop:
    mov TEMPDI,DI
    mov ax,DI               { get X position }
    sub ax,159              { substract 159  }
    imul cx                 { multiply with ViewerDistance }
    idiv bx                 { divide with Z position }
    and ax,7                { MOD with 8 }
    shl ax,3                { multiply with 8 }
    mov X,ax                { remember it in X }

    mov ax,tempBX           { get CounterY }
    mul cx                  { multiply with ViewerDistance }
    div bx                  { divide with Z position }
    and ax,7                { MOD with 8 }
    add X,ax                { remember it in X }

    mov ax,tempBX           { get counter Y in AX... }
    mov dx,ax               { ...and in DX }
    shl ax,8                { multiply with 256 }
    shl dx,6                { ..and with 64... }
    add ax,dx               { add together (=Y*320) }
    add di,ax               { add to screen offset }
    sub di,38400

    mov si,offset Tile      { get Tile array offset }
    add si,X                { add calculated tile Offset }
    movsb                   { copy correct byte }

    mov DI,TEMPDI           { get DI back }
    inc di                  { increase X position }
    cmp di,320              { check on right-border }
    jl @DrawLoop            { Not yet done... }

    mov BX,TEMPBX           { get BX back }
    inc BX                  { increase Y position }
    cmp bx,200              { check on bottom-border }
    jl @DoYLoop             { Not yet done...}

    mov Board_Time,BoardSpeed
  end;

END;
{}
{
          Create the checkerd board

          Expects: Nothing
          Returns: Nothing
}
PROCEDURE UpdateBoard;
VAR   X       : integer;
      TempBX    : word;
      TempDI    : word;
      TempDS    : word;
BEGIN
  { Copy Board image }
  asm
    mov es,vpage_seg
    mov di,vpage_ofs
    add di,38400

    PUSH DS
    mov si,board_ofs
    mov ds,board_seg


    mov cx,6400
    DB $66
    rep movsw

    POP DS
  end;

  if Board_Time>0 then dec(Board_time) else begin
     Board_Time:=BoardSpeed;

     For TempBX := 0 to 7 do
         For TempDI := 0 to 7 do
             Pal[TempDI+(TempBX shl 3)]:=Pal[TempDI+((TempBX+1) shl 3)];
  end;

   asm
    mov ax,ds                { get variables segment }
    mov es,ax                { store it in ES }

    mov di,offset PAL        { get PAL offset }
    mov si,di                { store it in SI aswell }
    add di,171               { add 56*3 for the correct color offset }
    add si,3                 { add 3 for the correct color offset }
    mov cl,8                 { set color counter to 8 }
 @CopyColor:
    movsw                    { move RED+GREEN }
    movsb                    { and move BLUE  }
    loop @CopyColor          { loop thru the colors }
    mov TEMPDS,DS                        { remember DS }
    MOV CX, 192                          { amount of colors to do *3 (R G B) }
    MOV AX, 1
    mov si,offset PAL                    { get palette offset }
    add si,3                             { skip the first color }
    MOV DX, 03C8h                        { get color port }
    OUT DX, AL                           { start at color 1 }
    INC DX                               { get to value port }
    REP OUTSB                            { store the color bytes }
    mov DS,TEMPDS                        { get DS back }
  END;

END;

{}
{
        Flip the screen in VERTICAL direction

        Exects : Nothing
        Returns: Nothing
}
PROCEDURE FlipScreenY; Assembler;
ASM
   mov bx,200                   { 200 lines to flip (0-199) }

   mov es,sega000               { get screen segment }
   xor di,di                    { screen offset is 0 }

   mov DX,DS                    { remember DS }
   mov ds,vpage_seg             { get segment of virtual page }
   mov si,63680                 { get virtual page offset }

 @LoopH:
   mov cx,80                    { copy 80 double-words (320 div 4)}

 @LoopIt:
   DB $66; REP MOVSW            { copy all double words }
   sub si,640                   { decrease 1 line for the virtual page }
   dec bx                       { decrease Y counter }
   jnz @LoopH                   { not yet 0 ? }

   mov DS,DX                    { get DS back }
END;

{}
{
        Split the screen, making the TOP upside down, and the bottom
        normal

        Exects : Nothing
        Returns: Nothing
}
PROCEDURE MirrorSplit; Assembler;
ASM
   mov bx,100                   { 200 lines to flip (0-199) }

   mov es,sega000               { get screen segment }
   xor di,di                    { screen offset is 0 }

   mov DX,DS                    { remember DS }
   mov ds,vpage_seg             { get segment of virtual page }
   mov si,63680                 { get virtual page offset }

 @LoopH:
   mov cx,80                    { copy 80 double-words (320 div 4)}

 @LoopIt:
   DB $66; REP MOVSW            { copy all double words }
   sub si,640                   { decrease 1 line for the virtual page }
   dec bx                       { decrease Y counter }
   jnz @LoopH                   { not yet 0 ? }

   mov cx,8000                  { no copy the final 100 lines normally }
   DB $66; REP MOVSW            { move the double words! }

   mov DS,DX                    { get DS back }
END;

{}
{
        Displace the virtual screen on the visible screen

        Exects : AX to be X position of displacement
                 BX to be Y position of displacement
        Returns: Nothing
}
PROCEDURE Displace; ASSEMBLER;
VAR Sleft,Dleft                   : word;       { Source+Destination LEFT }
    Stop,Dtop                     : word;       { Source+Destination TOP }
    Xlength                       : word;       { Horizontal length }
    YLength                       : word;       { Vertical Length }

    tempDS                        : word;       { to remember DS }
ASM
     xor cx,cx                     { set CX to 0 }
     mov xlength,320               { set X length to 320 bytes }
     mov ylength,200               { set Y length to 200 }
     cmp ax,0                      { see if X is negative }
     jge @XNotNegative             { no it isn't, so perform other calculations }
     mov dleft,cx                  { yes it is, so set destination left to 0 }
     add xlength,ax                { and ADD NEGATIVE X to length }
     neg ax                        { set X value to positive }
     mov Sleft,ax                  { set source left to X position }
     jmp @DoneXpositions           { done X calculations }
   @XNotNegative:
     mov dleft,ax                  { set destination X to X offset }
     mov sleft,cx                  { set source X to 0 }
     sub xlength,ax                { substract X position from length }
   @DoneXpositions:
     cmp bx,0                      { see if Y is negative }
     jge @YNotNegative             { no it isn't, so perform other calculations }
     mov dtop,cx                   { yes it is, so set destination top to 0 }
     add ylength,bx                { ADD NEGATIVE Y to length }
     neg bx                        { make Y positive }
     mov stop,bx                   { add Y to top source Top }
     jmp @DoneYpositions           { done Y calculations }
   @YNotNegative:
     mov dtop,bx                   { set destination Y to Y offset }
     mov stop,cx                   { set source Y to 0 }
     sub ylength,bx                { substract Y position from length }
   @DoneYpositions:
     mov es,sega000                { set screen segment }
     xor di,di                     { set screen offset }
     DB $66; xor ax,ax             { set EAX to 0 }
     mov cx,16000                  { draw 64000 div 4 double words }
     DB $66; REP STOSW             { and make screen black }

     mov bx,YLength     { get amount of vertical pixels }
  @VLoop:
     mov di,DTop        { get Y position on source page }
     mov cx,di          { get Y position in AX aswell }
     shl cx,6           { multiply with 64... }
     shl di,8           { ...and with 128... }
     add di,cx          { and add together (multiplied with 320) }
     add di,Dleft       { add X offset on destination page }

     mov si,Stop        { get Y position on source }
     mov cx,si          { get it in CX aswell }
     shl cx,6           { multiply with 64... }
     shl si,8           { ...and with 128... }
     add si,cx          { and add together (multiplied with 320) }
     add si,Sleft       { add X offset on source page }

     mov TEMPDS,DS      { remember DS }
     mov ds,vpage_seg   { get virtual page segment }

     mov cx,Xlength     { amount of pixels to set }
     mov dx,cx          { remember in DX }
     cmp cx,4           { can we do a double-word }
     jl @NoDoubleWord   { no. }

     shr cx,2           { yes! so divide length with 4 }
     DB $66; rep MOVSW  { store all words }
     mov cx,dx          { get original length back }
     and cx,3           { MOD with 4 }
     or cx,cx           { see if any bytes left }
     jz @NoMoreBytes    { no, so we did it }
   @NoDoubleWord:
     cmp cx,2           { are there 2 bytes left? }
     jb @NoWord         { no, so we can't use a word }
     MOVSW              { yes, so we draw 2 bytes at once }
   @NoWord:
     test cx,1          { still one byte left? }
     jz @NoMoreBytes    { nope, so we're finished }

   @NoMoreBytes:
     mov ds,TEMPDS      { get DS back }

     inc Stop           { increase source Top position }
     inc Dtop           { increase destination top position }
     dec bx             { decrease lines counter }
     jnz @Vloop         { not yet 0, so draw next line }
END;
{}
{
        Zoom in on the screen (not precise, but close enough...)
        this will allways zoom in on the center of the screen!

        Exects : size of zooming (must be higher then 0)
        Returns: Nothing
}
PROCEDURE Zoom(MidX,MidY,size:word);
VAR LEFT    : integer;
    TOP     : integer;
    XLength : word;
    YLength : word;
    y,y1    : word;
    xcount  : word;
    length  : word;
    TEMPDS  : word;
BEGIN
    xcount:=(320 div size)+size;
    ylength:=size;
    length:=size;

    left:=MidX-(Xcount div size);
    if Left<0 then Left:=0;
    if Left+Xcount>320 then Left:=320-Xcount;
    top:=MidY-(50 div size);
    if top+Length>200 then Top:=200-Length;
    if top<0 then top:=0;

    ASM
       mov bx,top
       mov y,bx         { set source Y to Top position }
       xor bx,bx        { set destination Y counter on 0 }
       mov y1,bx        { put it in a variable }
       mov es,sega000   { get screen segment }

    @Vloop:
       mov di,y1        { get Y position }
       mov cx,di        { put it in CX }
       shl cx,6         { multiply with 64... }
       shl di,8         { ... and with 128 (AX*320) }
       add di,cx        { add together }

       mov bx,length    { get amount of pixels per BLOCK loop }

       mov TEMPDS,DS    { remember DS }
       mov si,y         { get Y position source }
       mov ax,si        { put it in AX }
       shl ax,6         { multiply with 64... }
       shl si,8         { ... and with 128 (SI*320) }
       add si,ax        { add together }
       add si,left      { add LEFT offset }
       mov ds,vpage_seg

       mov dx,xcount

    @HLoop:
       lodsb              { load color byte }
       mov ah,al          { get color in AH aswell }
       mov cx,ax          { store color in CX }
       DB $66             { doubleword mode }
       shl ax,16          { and shift the 2 colorbytes to EAX }
       mov ax,cx          { get color back in AX again }

       mov cx,bx          { get length in CX }
       cmp cx,4           { can we do a double-word }
       jl @NoDoubleWord   { no. }

       shr cx,2           { yes! so divide length with 4 }
       DB $66; rep STOSW  { store all words }
       mov cx,bx          { get original length back }
       and cx,3           { MOD with 4 }
       or cx,cx           { see if any bytes left }
       jz @NoMoreBytes    { no, so we did it }
     @NoDoubleWord:
       cmp cx,2           { are there 2 bytes left? }
       jb @NoWord         { no, so we can't use a word }
       STOSW              { yes, so we draw 2 bytes at once }
     @NoWord:
       test cx,1          { still one byte left? }
       jz @NoMoreBytes    { nope, so we're finished }
       STOSB              { store last byte }
     @NoMoreBytes:
       dec DX
       jnz @HLoop
       mov DS,TEMPDS      { get DS back }

       inc y1             { increase Y counter }
       cmp ylength,0      { done complete screen }
       je @SetNewValue    { Yes, so set new value }
       dec ylength        { else decrease, }
       jmp @DoneYValue    { and draw next }
     @SetNewValue:
       mov ax,length      { move the original length }
       mov ylength,ax     { to the temp YLENGTH variable }
       inc y              { increase SCREEN Y counter }
     @DoneYvalue:
       cmp y1,200         { done complete screen? }
       jl @VLoop          { No, so draw next line }
    end;
END;
{}
{
        Flip/Scale the screen.
        Make sure the value is >0 and <199

        Exects : Position of the top line
        Returns: Nothing
}
PROCEDURE FLIP(value:integer);
VAR tabMAX : word;
    yReal  : real;
    BXV    : real;
    tempSI : word;
    tempDS : word;
BEGIN
 if (value=100) then exit;

 if value<100 then begin
     { Calculate table }
        Yreal:=200/(200-(value shl 1));
        bxV:=0;
        tabMAX:=0;
        repeat
           FlipTable[tabMAX]:=round(bxV)*320;
           bxV:=bxV+yreal;
           inc(tabMAX);
        until bxV>199;

        ASM
          {

             First make the top part black

          }
          mov es,sega000  { get screen segment }
          xor di,di       { get screen offset  }

          mov cx,value    { get start value          }
          mov ax,cx       { get it in AX as well,    }
          shl ax,4        { multiply with 256...     }
          shl cx,6        { ... and 64               }
          add cx,ax       { add together (total of *80) }

          db $66
          xor ax,ax       { set EAX to 0 }

          db $66
          rep STOSW       { store all double words }

           mov ax,value   { get begin value        }
           mov cx,ax
           shl ax,8       { multiply with 256      }
           shl cx,6       { and with 64 (total of *320 }
           add ax,cx      { add together           }

           xor bx,bx      { set Y counter to 0     }
           mov di,ax      { set screen offset to   }

           mov tempSI,offset fliptable { get fliptable position }

         @TABLEloop:
            mov si,TEMPSI          { get memory position of table }
            lodsw                  { load }
            mov TEMPSI,si          { store new offset position }

            mov tempDS,DS          { remember DS }

            mov si,vpage_ofs       { get page offset }
            add si,ax              { add start position }
            mov ds,vpage_Seg       { get page segment }

            mov cx,80              { copy double words (320 / 4) }
            db $66
            rep MOVSW              { store the line }

            mov DS,tempDS          { get DS back }
            inc bx                 { increase Y counter }
            cmp bx,tabMAX          { done all lines?    }
            jl @TableLoop          { no, so draw next   }

         {
            Fill bottom with black
         }
            mov cx,64000           { screen size }
            sub cx,di              { minus current position }
            shr cx,2               { divide by 4, for the amount of Dwords }
            db $66
            xor ax,ax              { set EAX to 0 }
            db $66
            rep stosw              { draw the rest of the screen }
        end;
 end else begin  { mirrored aswell }
     {
         Calculate table
     }
     Yreal:=200/((value-100) shl 1);
       bxV:=0;
       tabMAX:=0;
        repeat
           FlipTable[tabMAX]:=round(bxV)*320;
           bxV:=bxV+yreal;
           inc(tabMAX);
        until bxV>199;

         ASM
           mov es,sega000     { get segment of screen }
           xor di,di          { get offset of screen }

           mov cx,value       { get start value }
           mov bx,cx          { also in BX }
           shl cx,8           { multiply with 256, }
           shl bx,6           { and with 64   }
           add cx,bx          { add together (total *320) }
           mov bx,cx          { remember it in BX }

           mov cx,64000       { now, calculate the size }
           sub cx,bx          { we need to draw }
           shr cx,2           { divide by 4 (DWORDS) }

           DB $66
           xor ax,ax          { set EAX to 0 }
           DB $66
           rep stosw          { store all the blackness }

           mov di,bx
           mov ax,bx          { get start position in AX }
           xor bx,bx          { set Y counter to 0 }

           mov tempSI,offset fliptable { get the table offset }

         @TABLEloop:
            mov si,TEMPSI     { get the table offset }
            lodsw             { and load the next value }
            mov TEMPSI,si     { store the next table offset }

            mov tempDS,DS     { remember DS }

            mov si,vpage_ofs  { get page offset }
            add si,ax         { add start position }
            mov ds,vpage_Seg  { get page segment }

            mov cx,80         { draw 320/4 dwords }
            db $66
            rep MOVSW         { copy the line }

            mov DS,tempDS     { get DS back }
            sub di,640        { go to previous line }
            inc bx            { increase Y counter }
            cmp bx,tabMAX     { done complete table? }
            jl @TableLoop     { no, so draw next line }
          {

             now make the bottom part black

          }
          xor di,di
          mov cx,value    { get start value          }
          mov di,cx       { get it in AX as well,    }
          shl di,8        { multiply with 256...     }
          shl cx,6        { ... and 64               }
          add di,cx       { add together (total of *320) }
          mov cx,64000
          sub cx,di
          shr cx,2

          db $66
          xor ax,ax       { set EAX to 0 }

          db $66
          rep STOSW       { store all double words }

        end;
 end;
END;
{}
{
        Show the virtual bitmap

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE ShowBitmap; Assembler;
ASM
   MOV DX,DS                    { remember DS }

   MOV ES,sega000               { get screen SEGMENT }
   xor di,di                    { set screen offset to 0 }
   xor si,si                    { set virtual offset to 0 }
   MOV DS,vpage_seg             { get virtual segment }

   MOV CX,16000                 { draw 64000/4 double words }

   DB $66;
   REP MOVSW                    { draw all bytes }

   MOV DS,DX                    { get DS back }
END;
{}
{
        Clear the virtual screen

        Exects : Nothing
        Returns: Nothing
}
PROCEDURE ClearScreen; ASSEMBLER;
ASM
  mov es,vpage_Seg        { get virtual segment }
  xor di,di               { set virtual offset to 0 }
  DB $66                  { go into DoubleWord mode }
  xor ax,ax               { set EAX to 0 }
  mov cx,16000            { draw 64000/4 double words }
  DB $66; rep STOSW       { draw the bytes }
END;
{}
{
        Clear the video screen

        Exects : Nothing
        Returns: Nothing
}
PROCEDURE ClearVisible; ASSEMBLER;
ASM
  mov es,sega000        { get screen segment }
  xor di,di             { set screen offset to 0 }
  DB $66                { double words }
  xor ax,ax             { set EAX to 0 }
  mov cx,16000          { draw 64000/4 double words }
  DB $66; REP STOSW     { draw them }
END;
{}
{

        this is the routine that takes a frame and put it on the screen

        Expects: Pointer to new frame-buffer, and the amount of chunks in the
                 buffer.
        Returns: Nothing.

}
PROCEDURE FLIDrawFrame(Buffer : Pointer; Chunks : Word); ASSEMBLER;
ASM
  push ds
  lds si,Buffer       {let DS:SI point at the frame to be drawn}

 @Fli_Loop:           {main loop that goes through all the chunks in a frame}
  cmp Chunks,0        {are there any more chunks to draw?}
  je @Exit
  dec Chunks          {decrement Chunks For the chunk to process now}
  mov ax,[Word ptr ds:si+4] {let AX have the ChunkType}
  add si,6            {skip the ChunkHeader}
  cmp ax,04h          {is it a 256 level FLI_COLOR chunk? }
  je @Fli_Color256
  cmp ax,07h
  je @Fli_SS2         {word delta encoding }
  cmp ax,0Bh          {is it a 64 level FLI_COLor chunk?}
  je @Fli_Color64
  cmp ax,0Ch          {is it a FLI_LC chunk?}
  je @Fli_Lc
  cmp ax,0Dh          {is it a FLI_BLACK chunk?}
  je @Fli_Black
  cmp ax,0Fh          {is it a FLI_BRUN chunk?}
  je @Fli_Brun
  cmp ax,10h          {is it a FLI_COPY chunk?}
  je  @Fli_Copy

  jmp @Fli_Loop           {This command should not be necessary }
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
{              This is the 64 color palette loop
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
 @Fli_Color64:
  mov bx,[Word ptr ds:si]   { number of packets in this chunk }
  add si,2                  { skip the NumberofPackets }
  xor al,al                 { start at color 0 }
  xor cx,cx                 { reset CX }

 @Color_Loop:
  or  bx,bx                 {set flags}
  jz @Fli_Loop              {Exit if no more packages}
  dec bx                    {decrement NumberofPackages For the package to process now}
  mov cl,[Byte ptr ds:si+0] {first Byte in packet tells how many colors to skip}
  add al,cl                 {add the skiped colors to the start to get the new start}
  mov dx,$3C8               {PEL Address Write Mode Register}
  out dx,al                 {tell the VGA card what color we start changing}
  inc dx                    {at the port abow the PEL_A_W_M_R is the PEL Data Register}
  mov cl,[Byte ptr ds:si+1] {next Byte in packet tells how many colors to change}
  or cl,cl                  {set the flags}
  jnz @Jump_Over            {if NumberstoChange=0 then NumberstoChange=256}
  inc ch                    {CH=1 and CL=0 => CX=256}

 @Jump_Over:
  add al,cl                 {update the color to start at}
  mov di,cx                 {since each color is made of 3 Bytes (Red, Green & Blue) we have to -}
  shl cx,1                  {multiply CX (the data counter) With 3}
  add cx,di                 {CX = old_CX shl 1 + old_CX   (the fastest way to multiply With 3)}
  add si,2                  {skip the NumberstoSkip and NumberstoChange Bytes}
  rep outsb                 {put the color data to the VGA card FAST!}
  jmp @Color_Loop           {finish With this packet - jump back}
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
{                this is the 256 color palette loop
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
 @Fli_Color256:
  mov bx,[Word ptr ds:si]   { number of packets in this chunk }
  add si,2                  { skip the NumberofPackets }
  xor al,al                 { start at color 0 }
  xor cx,cx                 { reset CX }

 @Color_Loop2:
  or  bx,bx                 {set flags}
  jz @Fli_Loop              {Exit if no more packages}
  dec bx                    {decrement NumberofPackages For the package to process now}
  mov cl,[Byte ptr ds:si+0] {first Byte in packet tells how many colors to skip}
  add al,cl                 {add the skiped colors to the start to get the new start}
  mov dx,$3C8               {PEL Address Write Mode Register}
  out dx,al                 {tell the VGA card what color we start changing}
  inc dx                    {at the port abow the PEL_A_W_M_R is the PEL Data Register}
  mov cl,[Byte ptr ds:si+1] {next Byte in packet tells how many colors to change}
  or cl,cl                  {set the flags}
  jnz @Jump_Over2           {if NumberstoChange=0 then NumberstoChange=256}
  inc ch                    {CH=1 and CL=0 => CX=256}

 @Jump_Over2:
  add al,cl                 {update the color to start at}
  mov di,cx                 {since each color is made of 3 Bytes (Red, Green & Blue) we have to -}
  shl cx,1                  {multiply CX (the data counter) With 3}
  add cx,di                 {CX = old_CX shl 1 + old_CX   (the fastest way to multiply With 3)}
  add si,2                  {skip the NumberstoSkip and NumberstoChange Bytes}
 @ColLoop:
  lodsb                     { load 255-value based color }
  shr al,2                  { transform to 63-value based color }
  out dx,al                 {put the color data to the VGA card }
  loop @ColLoop
  jmp @Color_Loop2          {finish With this packet - jump back}
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
{         This is a byte-encoded data block
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
 @Fli_Lc:
  mov ax,0a000h              {get screen segment}
  mov es,ax                  {put it into ES}
  mov di,[Word ptr ds:si+0]  {get screen offset}
  mov ax,di                  {put it into AX }
  shl ax,8                   {multiply with 128...}
  shl di,6                   {and with 64 (DI*320)}
  add di,ax                  {add together}
  mov bx,[Word ptr ds:si+2]  {put LinestoChange into BX}
  add si,4                   {skip the LinestoSkip and LinestoChange Words}
  xor cx,cx                  {reset cx}

 @Line_Loop:
  or bx,bx                   {set flags}
  jz @Fli_Loop               {Exit if no more lines to change}
  dec bx
  mov dl,[Byte ptr ds:si]    {put PacketsInLine into DL}
  inc si                     {skip the PacketsInLine Byte}
  push di                    {save the offset address of this line}

 @Pack_Loop:
  or dl,dl                   {set flags}
  jz @Next_Line              {Exit if no more packets in this line}
  dec dl
  mov cl,[Byte ptr ds:si+0]  {put BytestoSkip into CL}
  add di,cx                  {update the offset address}
  mov cl,[Byte ptr ds:si+1]  {put BytesofDatatoCome into CL}
  or cl,cl                   {set flags}
  jns @Copy_Bytes            {no SIGN means that CL number of data is to come -}
                             {else the next data should be put -CL number of times}
  mov al,[Byte ptr ds:si+2]  {put the Byte to be Repeated into AL}
  add si,3                   {skip the packet}
  neg cl                     {Repeat CL times}
  rep stosb
  jmp @Pack_Loop             {finish With this packet}

 @Copy_Bytes:
  add si,2                   {skip the two count Bytes at the start of the packet}
  rep movsb
  jmp @Pack_Loop             {finish With this packet}
 @Next_Line:
  pop di                     {restore the old offset address of the current line}
  add di,320                 {offset address to the next line}
  jmp @Line_Loop
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
{         This is a word-encoded data block, most often used!
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
 @Fli_SS2:
  mov ax,0a000h              {get screen segment}
  mov es,ax                  {put it into ES}
  xor di,di                  {get screen offset}
  mov bx,[Word ptr ds:si]    {put linestoChange into BX}
  add si,2                   {skip the LinestoChange Word}

 @Line_Loop2:
  or bx,bx                   {check linescounter on 0}
  jz @Fli_Loop               {Exit if no more lines to change}
  dec bx                     {decrease linescounter }
  mov dx,[word ptr ds:si]    {get OptionalWord into DL}
  add si,2                   {skip the OptionalWord }
  push di                    {save the offset address of this line}

  mov ax,dx
  and ax,49152               { get bit 15 and 16 }

  cmp ah,128                { check on  128  (byte should be stored) }
  je @PutByte
  cmp ah,192                { check on  64+128  (line  skip count) }
  je @SkipLines

 @Pack_LoopSS:
  or dl,dl                   {set flags}
  jz @Next_Line2             {Exit if no more packets in this line}
  dec dl
  xor ch,ch
  mov cl,[Byte ptr ds:si+0]  {put BytestoSkip into CL}
  add di,cx                  {update the offset address}
  mov cl,[Byte ptr ds:si+1]  {put PacketsType into CL}
  or cl,cl                   {set flags}
  jns @Copy_Words            {no SIGN means that CL number of data is to come -}
                             {else the next data should be put -CL number of times}
  mov ax,[word ptr ds:si+2]  {put the word to be Repeated into AX}
  add si,4                   {skip the packet}
  neg cl                     {Repeat CL times}
  rep stosw
  jmp @Pack_LoopSS           {finish With this packet}

 @Copy_Words:
  add si,2                   {skip the two count Bytes at the start of the packet}
  rep movsw
  jmp @Pack_LoopSS           {finish With this packet}

 @PutByte:
  mov al,dl
  stosb
  jmp @Next_Line2

 @SkipLines:
  mov ax,dx
  neg ax
  mov cx,ax
  shl cx,8
  shl ax,6
  add ax,cx
  add di,ax

 @Next_Line2:
  pop di                     {restore the old offset address of the current line}
  add di,320                 {offset address to the next line}
  jmp @Line_Loop2

{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
{             Change the screen to black (all zero-byte-pixels)
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
 @Fli_Black:
  mov ax,0a000h
  mov es,ax                  {let ES:DI point to the start of the screen}
  xor di,di
  mov cx,16000               {number of Words in a screen}
  db $66
  xor ax,ax                  {color 0 is to be put on the screen}
  db $66
  rep stosw
  jmp @Fli_Loop             {jump back to main loop}
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
{            A run-lenght-encode (like PCX) image block
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
 @Fli_Brun:
  mov ax,0a000h
  mov es,ax                 {let ES:DI point at the start of the screen}
  xor di,di
  mov AX,DS
  POP DS
  mov bx,FLIHEIGHT          {numbers of lines in a screen}
  PUSH DS
  mov DS,AX
  xor cx,cx

 @Line_Loop3:
  mov dl,[Byte ptr ds:si]   {put PacketsInLine into DL}
  inc si                    {skip the PacketsInLine Byte}
  push di                   {save the offset address of this line}

 @Pack_Loop3:
  or dl,dl                  {set flags}
  jz @Next_Line3            {Exit if no more packets in this line}
  dec dl
  mov cl,[Byte ptr ds:si]   {put BytesofDatatoCome into CL}
  or cl,cl                  {set flags}
  js @Copy_Bytes3           {SIGN meens that CL number of data is to come }
                            { else the next data should be put CL number of times}
  mov al,[Byte ptr ds:si+1] {put the Byte to be Repeated into AL}
  add si,2                  {skip the packet}
  rep stosb
  jmp @Pack_Loop3           {finish With this packet}
 @Copy_Bytes3:
  inc si                    {skip the count Byte at the start of the packet}
  neg cl                    {Repeat CL times}
  rep movsb
  jmp @Pack_Loop3           {finish With this packet}

 @Next_Line3:
  pop di                    {restore the old offset address of the current line}
  add di,320                {offset address to the next line}
  dec bx                    {any more lines to draw?}
  jnz @Line_Loop3
  jmp @Fli_Loop             {jump back to main loop}
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
{            A normal full-screen copy
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
 @Fli_Copy:
  mov ax,0a000h
  mov es,ax                 {let ES:DI point to the start of the screen}
  xor di,di
  mov cx,16000              {number of DWords in a screen}
  DB $66
  rep movsw
  jmp @Fli_Loop             {jump back to main loop}
 @Exit:
  pop ds

END;
{}
{
        Create a buffer  (virtual page for the FLI playing)

        Expects: Nothing
        Returns: Nothing
}
CONSTRUCTOR TFliPlayer.Init;
BEGIN
   {$IFDEF USEDOSMEM}
     MemAlloc(buffer,BufSize);
   {$ELSE}
     GetMem(Buffer,BufSize);
   {$ENDIF}
END;
{}
{
       Destroy the frame-buffer, and FLIplayer variable

       Expects: Nothing
       Returns: Nothing
}
DESTRUCTOR TFliPlayer.Done;
BEGIN
   {$IFDEF USEDOSMEM}
     DAlloc(buffer);
   {$ELSE}
     FreeMem(Buffer,BufSize);
   {$ENDIF}
END;
{}
{
        Handle the playing of the fli-file

        Expects: FILENAME of FLI
        Returns: Nothing
}
PROCEDURE TFliPlayer.Play(UseLIB:boolean;Filename : String);
VAR MainHeader  : MainHeaderRec;
    FrameHeader : FrameHeaderRec;
    FrameSize   : LongInt;
    RestartPos  : LongInt;
    Frame       : Word;
    Timeout     : LongInt;
    code        : byte;

    FUNCTION ReadHeader : Boolean;
    BEGIN
      BlockRead(lib_file,MainHeader,SizeOf(MainHeader)); { Read header record}
      with MainHeader do begin
        if ((ID<>$AF11) and (ID<>$AF12)) or (width>320) or (height>200)then
          ReadHeader:=FALSE                       { Not a correct .FLI File}
        else begin
          ReadHeader:=TRUE;
        end;
        FLIHEIGHT:=height;
      end;
    END;

    PROCEDURE ReadFrame;
    BEGIN
      BlockRead(Lib_File,FrameHeader,SizeOf(FrameHeader));
      if frameheader.id=$F100 then begin { unneeded information in file }
         blockread(lib_file,buffer^,frameheader.size-sizeof(frameheader));
         BlockRead(lib_file,FrameHeader,SizeOf(FrameHeader));
      end;
      FrameSize := FrameHeader.Size - SizeOf(FrameHeader);
    END;

    PROCEDURE ProcessFrame;
    BEGIN
      BlockRead(lib_file,Buffer^,FrameSize);
      FLIDrawFrame(Buffer,FrameHeader.Chunks);
    END;

BEGIN
    if UseLib then begin
       code:=LIB_reset(filename);
       if code<>0 then begin
          halt_Error:='unable to open entry '+filename;
          exit;
       end;
    end else begin
       Assign(lib_file,Filename);
       key_start:=0;
       {$I-}
         Reset(lib_file,1);
       {$I+}
       if (IOResult<>0) then begin
          halt_Error:='unable to open entry '+filename;
          exit;
       end;
    end;
    if ReadHeader then begin
       ReadFrame;
       RestartPos:=SizeOf(MainHeader)+SizeOf(FrameHeader)+FrameSize;
       ProcessFrame;
       Frame:=1;
        REPEAT
           ReadFrame;
           if FrameSize<>0 then
              for code:=1 to 7 do retrace;
              ProcessFrame;
              inc(Frame);
        UNTIL (Frame>MainHeader.Frames) or AnyPressed;
    end;
   Close(lib_file);
END;
{}
{
        This will play a FLI file and handle ALL the things

        Expects: Filename of FLI file
        Returns: Nothing
}
PROCEDURE AAPlay(UseLib:boolean;Filename : String);
VAR Player : TFliPlayer;
BEGIN
   with Player do
     if Init then begin
            Play(UseLib,Filename);
            Done;
     end;
END;
{}
{
        Load in the color map for light-sourcing

        Expects: LIB  - True if loading from DFP file
                  and filename of the colormap
        Returns: TRUE if succesfull
}
FUNCTION LoadColorMap(lib:boolean;filename:string):boolean;
VAR code : byte;
BEGIN
 LoadColorMap:=false;
 if lib then begin              { use a lib file? }
    code:=LIB_RESET(filename);      { yes, so reset it }
    if code<>0 then exit;       { if code<>0 something went wrong }
 end else begin
    assign(lib_file,filename);      { use dos file }
    {$I-}
       reset(lib_file,1);       { reset the file }
    {$I+}
    if ioresult<>0 then begin
       exit;
    end;
 end;
 blockread(lib_file,colormap,sizeof(colormap));
END;
{}
{
        Draw a lit-up box, making a light-sourced impression

        Expects: top-left corner and bot-right corner,
                 brightness (0..15=darker  16=normal 17..31=brighter )
                 If MAPX,MAPY should be substracted
        Returns: Nothing
}
PROCEDURE DrawLight(x1,y1,x2,y2:integer;bright:word;SubMap:boolean); ASSEMBLER;
VAR tempBX : word;
    tempDI : word;
    tempCX : word;
    tempSI : word;
ASM
  mov bx,mapx    { MAPX position }
  mov di,318     { use DI for screen width... faster }
  mov ax,x1      { get LEFT X }
  mov cx,x2      { get RIGHT X }
  cmp SubMap,TRUE
  jne @NoSub1
  sub ax,bx      { substract LEFT-MAPX }
  sub cx,bx      { substract RIGHT-MAPX }
 @NoSub1:
  cmp ax,di      { check left on right-screen pos }
  jg @Exit       { larger, so exit! }
  cmp ax,0       { check left on left-screen pos }
  jge @X1Ok      { greater or equal, so it's ok }
  xor ax,ax      { set it to 0 }
 @X1Ok:
  inc di         { change right-screen pos to 319 }
  cmp cx,0       { check right on left-screen pos }
  jng @Exit      { it's less, so EXIT }
  cmp cx,di      { check right on right-screen pos }
  jbe @X2Ok      { below or equal, so it's ok }
  mov cx,di      { set right to right-screen pos }
 @X2Ok:
  mov x1,ax      { set X1 to new coordinate }
  sub cx,ax      { substract RIGHT-LEFT, leaving the width in CX }
  mov TEMPCX,CX  { put width in TEMPCX }

  mov di,199     { use DI for screen height... faster }
  mov bx,mapy    { get MAPY }
  mov ax,y1      { get TOP }
  mov cx,y2      { get BOTTOM }
  cmp SubMap,TRUE
  jne @NoSub2
  sub ax,bx      { substract top-mapy }
  sub cx,bx      { substract bottom-mapy }
 @NoSub2:
  cmp ax,di      { check top on bottom-screen pos }
  jg @Exit       { larger, so EXIT }
  cmp ax,0       { check top on top-screen pos }
  jge @Y1Ok      { greater or equal, so it's ok }
  xor ax,ax      { set top to 0 }
 @Y1Ok:
  inc di         { set bottom-screen pos to 200 }
  cmp cx,0       { check bottom on top-screen pos }
  jng @Exit      { not greater, so EXIT }
  cmp cx,di      { check bottom on bottom-screen pos }
  jbe @Y2Ok      { below or equal, so it's ok }
  mov cx,di      { set bottom to bottom-screen pos }
 @Y2Ok:
  mov bx,cx      { set BX to bottom value }


  mov es,vpage_seg      { get screen segment }
  mov cx,ax             { put TOP Y value also in CX }

  sub bx,ax             { substract top Y  from BOTTOM Y to get height }
  shl ax,6              { multiply top Y with 64... }
  shl cx,8              { ... and with 256 }
  mov di,ax             { add to the screen... }
  add di,cx             { ...segment }
  add di,x1             { and add LEFT X position }

  mov si,offset colormap { get offset of the colormap }
  mov TEMPSI,SI         { and remember it }

 @YLoop:
  mov TEMPDI,DI         { remember calculated DI }
  mov TEMPBX,BX         { remember BX }

  mov CX,TEMPCX         { get width back }
  mov bx,bright         { get brightness in BX }

 @Xloop:
  xor ah,ah             { set AH to 0 }
  mov al,es:[di]        { get color value on-screen }
  mov SI,TEMPSI         { get offset colormap back }

  shl ax,5              { multiply with 32 (0-31 tints) }
  add si,ax             { add to colormap offset }
  add si,bx             { add brightness to offset }
  mov al,[si]           { get new color value }
  stosb                 { store it on screen }

  LOOP @Xloop           { loop until CX=0 }

  mov DI,TEMPDI         { get DI back }
  add di,320            { add 320, for the next line }
  mov BX,TEMPBX         { get BX back }
  dec bx                { and decrease the Y counter }
  jnz @YLoop            { not 0, draw next line }
 @Exit:
END;
{}
{
        Add a Light source on the map

        Expects: top-left, bottom-right position, start-brightness,
                 brightADD, and if  MAPX,MAPY should be substracted
        Returns: True if succesfully added the bullet
}
FUNCTION AddLight(  xx1,yy1,xx2,yy2 : integer;
                    bright  :word;
                    SubMap2 : boolean;
                    LType   : byte): boolean;
VAR  Temp     : PLight;
     i        : integer;
BEGIN
 AddLight:=true;
 if (xx1=xx2) or (yy1=yy2) then exit;

 new(Temp);
 IF Temp=NIL then begin
    AddLight:=false;
    halt_error:='unable to spawn light-source';
    exit;
 END;

 IF FirstLight=NIL  then begin
    LastLight:=Temp;
    FirstLight:=Temp;
    with FirstLight^ do begin
         next:=NIL;
         prev:=Nil;
    end;
 END ELSE BEGIN
     LastLight^.next:=temp;
     Temp^.prev:=LastLight;
     LastLight:=Temp;
     Temp^.next:=NIL;
 END;


 WITH TEMP^ do begin
  if xx1>xx2 then begin
     i:=xx1;
     xx1:=xx2;
     xx2:=i;
  end;
  if yy1>yy2 then begin
     i:=yy1;
     yy1:=yy2;
     yy2:=i;
  end;

  x1:=xx1;  y1:=yy1;
  x2:=xx2;  y2:=yy2;
  LightFlag:=LType;
  StartBright:=Bright;
  CurBright:=StartBright;
    CASE LType of
     1 :  CurBright:=random(StartBright);
     2 :  BrAdd:=1;
     3 :  BrAdd:=-1;
     4 :  begin
           BrAdd:=1;
     end;
     5 :  begin
           BrAdd:=-1;
     end;
    END;
    SubMap:=SubMap2;

 END;
END;
{}
{

        Erase a LIGHT source from the linked-list

        Expects: pointer to Light object that needs to be ERASED!
        Returns: True if succesfull

}
FUNCTION EraseLight(Temp:PLight):boolean;
VAR  next_light,
     prev_light  : Plight;
     i        : integer;
     msize    : word;
BEGIN
  eraselight:=true;
  if Temp=NIL then begin
     eraselight:=false;
     halt_error:='unable to deallocate light-source';
     exit;
  end;

  prev_light:=Temp^.prev;
  next_light:=Temp^.next;

  if prev_light=NIL then begin
     Firstlight:=next_light;
  end else Prev_light^.next:=next_light;

  if next_light=NIL then begin
     Lastlight:=prev_light;
  end else Next_light^.prev:=prev_light;

  dispose(Temp);
END;
{}
{

        Erase ALL LIGHT sources

        Expects: Nothing
        Returns: True if succesfull

}
FUNCTION EraseLightAll:boolean;
VAR  next_light,
     prev_light  : Plight;
     i        : integer;
     msize    : word;
     temp     : plight;
     nxt      : plight;
BEGIN
  eraselightAll:=true;
  temp:=FirstLight;
  while temp<>nil do begin
        nxt:=temp^.next;
        if not EraseLight(temp) then begin
           Halt_Error:=('unable to erase lights');
           EraseLightAll:=false;
           exit;
        end;
        temp:=nxt;
  end;
END;
{}
{
        Handle the LIGHT-SOURCE linked list

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE DoLights;
VAR temp      : PLight;
    next_Light: PLight;
    done      : boolean;
BEGIN
 temp:=FirstLight;
 while temp<>Nil do begin
       with temp^ do begin
            done:=false;
            next_Light:=temp^.next;
             case LightFlag of
              {0  : Normal light, no changes }
              1 : begin    { random flickering }
                    if BrAdd>0 then dec(BrAdd) else begin
                       CurBright:=random(StartBright);
                       BrAdd:=3;
                    end;
              end;
              2 : begin { Bright pulsating, continously }
                    inc(curBright,BrAdd);
                    if (CurBright>=31) or (CurBright<=StartBright) then BrAdd:=-BrAdd;
              end;
              3 : begin { Dark pulsating, continously }
                    inc(curBright,BrAdd);
                    if (CurBright>=StartBright) or (CurBright=0) then BrAdd:=-BrAdd;
              end;
              4 : begin { Bright pulsating, once }
                    inc(curBright,BrAdd);
                    if (CurBright=31) then BrAdd:=-BrAdd;
                    if CurBright=16 then begin
                       if not EraseLight(Temp) then halt;
                       done:=true;
                    end;
              end;
              5 : begin { Dark pulsating, once }
                    inc(curBright,BrAdd);
                    if (CurBright=0) then BrAdd:=-BrAdd;
                    if CurBright=16 then begin
                       if not EraseLight(Temp) then halt;
                       done:=true;
                    end;
              end;
            end;
            if not DONE then DrawLight(x1,y1,x2,y2,CurBright,SubMap)
       end;
       temp:=next_Light;
  end;
END;

{}
{
        Initialise the copper bar

        Exects : Nothing
        Returns: Nothing
}
PROCEDURE InitCopper; ASSEMBLER;
ASM
    and ForceHight,1     { see if FORCEHIGHT = true }
    jnz @NoHightCalculate { yes, so we don't have to calculate it! }

    mov al,coppertop     { get top color in AL (AH is stil 0, so this is... }
    mov dx,ax            { ...faster to get it in DX }
    mov al,copperbottom  { get bottom color }
    sub ax,dx            { substract top color }
    add ax,2             { add 2 (first and last color) }
    mov cx,ax            { get calculated value in CX }
    mov ax,200           { get 200 in AX }

    and UseLAyer,1       { using parallax layer effect? }
    jz  @FullScreenCopper  { no, so we have full-screen copper }
    mov ax,152             { yes, so copper ends at 152 (one spare bar) }
   @FullScreenCopper:
    cwd                  { convert AX word to EAX Dword }
    idiv cx              { and divide with calculated value }
    mov Copperhight,ax   { get AX in barhight }
   @NoHightCalculate:
    mov LayerCopper,false
    mov al,usecopper
    mov ah,uselayer
    or al,ah
    jz  @NoBackground
    mov LayerCopper,true
  @NoBackground:

    mov dx,copperhight  { get bar hight in copperhight }
    mov ax,320          { screen width }
    mul dx              { multiply screen width with bar height }
    shr ax,2            { and divide by 4 (double-words are used) }
    mov dx,cx           { get CX (AX color values) in DX for later }
    mov BytesPerBar,ax  { get calculated value in CX }

END;
{}
{
        Create copper background sky...
        The colors will be decreased from color2 downto color1, no checking
        on the color values, so make sure color2 is LARGER/HIGHER then color1
        !!!

        Note that this is not a real copper sky, since it uses colors in
        the palette to DRAW them on screen, not using an interrupt to change
        color 0...but it works!!

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE CopperSkyDown; Assembler;
ASM
    mov es,vpage_seg    { get virtual page segment }
    xor ax,ax           { set AX to 0 }
    mov di,ax           { set screen offset set to 0 }


  @NoHightCalculate:
    mov bl,CopperBottom { get color 2 in BL }
    mov al,bl           { get color in AL for later use }
    sub bl,CopperTop    { substract color 1 }
    inc bl              { increase 1 because the last color is also valid }

    mov ah,al           { get color in AH aswell }
    mov cx,BytesPerBar  { Size of the !complete! bar (width*height pixels) }

    mov DX,CX           { remember CX }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { shift AX to double-word EAX }
    mov ax,cx           { get values back in AX aswell }
    mov CX,DX           { get CX back }

  @LoopColorSet:
    mov DX,CX           { remember CX }
    DB $66              { double-word mode }
    rep STOSW           { Store the color }

    dec al              { decrease color value }
    dec ah              { decrease color value High aswell }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { copy AX to EAX }
    mov ax,cx           { get colors back in AX }

    mov CX,DX           { get CX back }
    dec bl              { decrease lines left }
    jnz @LoopColorSet   { done all lines? }

    and UseLayer,1      { if true, skip drawing rest of screen }
    jnz @NoMorePutting
    cmp di,64000        { see if we got to the bottom }
    ja @NoMorePutting  { no, so we won't have to put it }
   @Startputtin:
    inc al              { increase color value }
    inc ah              { increase color value High aswell }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { copy AX to EAX }
    mov ax,cx           { get colors back in AX }

    mov cx,64000        { get 64000 in CX }
    sub cx,di           { and substract the position were we are }
    shr cx,2            { divide by 4 (using double-words) }

    DB $66
    rep STOSW

   @NoMorePutting:

    {

        Put some more lines in it for better effect, if possible...

    }


    mov bl,byte ptr Copperhight { get barhight in BL (BH will be 0 since
                                  copperhight won't be more then 255) }
    mov bh,184         { bottom Y is 184 }
    and UseLayer,1     { see if we use a layer }
    jz  @NotUsingLayer { we're not using a layer }
    mov bh,152         { we are using a layer, so draw only half-screen }
   @NotUsingLayer:
    cmp bl,5           { see if we need to put lines in... }
    jle @NotPossible   { nope, so skip this part (faster aswell!) }
    sub bl,3           { substract 3 lines }

    xor ah,ah
    mov al,bl          { get Y position }
    mov di,ax
    shl di,8
    shl ax,6
    add di,ax

    mov ax,320
    mul Copperhight     { multiply screen width with bar height }
    mov cx,ax           { get it in CX }
    sub cx,320          { decrease with one line }

    mov DX,CX           { remember CX }

    mov al,CopperBottom { first color }
    dec al              { decrease with one }
    mov ah,al           { get color in AH and AL }
    mov cx,ax           { remember color }
    DB $66              { double word mode }
    shl ax,16           { move AX to EAX }
    mov ax,cx           { get color back in AX }

    mov CX,DX           { get bar-hight back in CX }

  @NextLine:
    mov DX,CX           { remember CX }

    mov cx,80           { draw 1 line of double words (320/4) }
    DB $66              { double word mode }
    rep STOSW           { store all words }

    cmp al,coppertop
    je @NoDecreases
    dec al              { decrease color value }
    dec ah              { decrease color value High aswell }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { copy AX to EAX }
    mov ax,cx           { get colors back in AX }
   @NoDecreases:
    mov CX,DX           { get CX back }
    add di,cx           { add CX to the screen offset }
    add bl,byte ptr copperhight  { add hight of the bar to BX }

    cmp bl,bh           { see if we hit the bottom of the screen }
    jb @NextLine
   @NoTpossible:
END;
{}
{
        Create copper background sky...
        The colors will be INCREASED from color1 to color2, no checking
        on the color values, so make sure color2 is LARGER/HIGHER then color1
        !!!

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE CopperSkyUP; Assembler;
ASM
    mov es,vpage_seg    { get virtual page segment }
    xor ax,ax           { set AX to 0 }
    xor di,di           { get screen offset set to 0 }

    mov bl,Copperbottom { get color 2 in BL }
    mov al,CopperTop    { get color in AL for later use }
    sub bl,al           { substract color 1 }
    inc bl              { increase 1 because the last color is also valid }

    mov ah,al           { get color in AH aswell }
    mov cx,BytesPerBar  { get full amount of pixels per bar (width*height) }

    mov DX,CX           { remember CX }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { shift AX to double-word EAX }
    mov ax,cx           { get values back in AX aswell }
    mov CX,DX           { get CX back }

  @LoopColorSet:
    mov DX,CX           { remember CX }
    DB $66              { double-word mode }
    rep STOSW           { Store the color }

    inc al              { increase color value }
    inc ah              { increase color value High aswell }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { copy AX to EAX }
    mov ax,cx           { get colors back in AX }

    mov CX,DX           { get CX back }
    dec bl              { decrease lines left }
    jnz @LoopColorSet   { done all lines? }

    and UseLayer,1      { if true, skip drawing rest of screen }
    jnz @NoMorePutting
    cmp di,64000        { see if we got to the bottom }
    ja @NoMorePutting  { no, so we won't have to put it }
   @Startputtin:
    dec al              { decrease color value }
    dec ah              { decrease color value High aswell }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { copy AX to EAX }
    mov ax,cx           { get colors back in AX }

    mov cx,64000        { get 64000 in CX }
    sub cx,di           { and substract the position were we are }
    shr cx,2            { divide by 4 (using double-words) }

    DB $66
    rep STOSW

   @NoMorePutting:

    {

        Put some more lines in it for better effect, if possible...

    }


    mov bl,byte ptr Copperhight { get barhight in BL (BH will be 0 since
                                  copperhight won't be more then 255) }
    mov bh,184         { bottom Y is 184 }
    and UseLayer,1     { see if we use a layer }
    jz  @NotUsingLayer { we're not using a layer }
    mov bh,152         { we are using a layer, so draw only half-screen }
   @NotUsingLayer:
    cmp bl,5           { see if we need to put lines in... }
    jle @NotPossible   { nope, so skip this part (faster aswell!) }
    sub bl,3           { substract 3 lines }

    xor ah,ah
    mov al,bl          { get Y position }
    mov di,ax
    shl di,8
    shl ax,6
    add di,ax

    mov ax,320
    mul Copperhight     { multiply screen width with bar height }
    mov cx,ax           { get it in CX }
    sub cx,320          { decrease with one line }

    mov DX,CX           { remember CX }

    mov al,CopperTop    { first color }
    inc al              { increase with one }
    mov ah,al           { get color in AH and AL }
    mov cx,ax           { remember color }
    DB $66              { double word mode }
    shl ax,16           { move AX to EAX }
    mov ax,cx           { get color back in AX }

    mov CX,DX           { get bar-hight back in CX }

  @NextLine:
    mov DX,CX           { remember CX }

    mov cx,80           { draw 1 line of double words (320/4) }
    DB $66              { double word mode }
    rep STOSW           { store all words }

    cmp al,copperbottom
    je @NoDecreases
    inc al              { increase color value }
    inc ah              { increase color value High aswell }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { copy AX to EAX }
    mov ax,cx           { get colors back in AX }
   @NoDecreases:
    mov CX,DX           { get CX back }
    add di,cx           { add CX to the screen offset }
    add bl,byte ptr copperhight  { add hight of the bar to BX }

    cmp bl,bh           { see if we hit the bottom of the screen }
    jb @NextLine
   @NoTpossible:
END;
{}
{
        Put a sprite on screen console style (clipping, and masking)
        Original procedure by Scott Tunstall.
        simple modifications done by P.Bestebroer, it now includes the
        CLIPCALCULATIONS and OFFSETCALCULATION inside the procedure, so no
        jump is needed, and a few command could be taken out...everything for
        speed!!

        Expects: AX to be X position
                 BX to be Y position
                 and ES:[DI] pointing at image data
        Returns: Nothing
}
PROCEDURE Sprite; ASSEMBLER;
VAR TempREG       : word;
ASM
{-=-=-=-=-=-=-=-=- Do clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   cmp bx,199              { Y > 199 ? }
   jg @ExitSprite          { JG is for SIGNED integers. If Y pos is
                             > 199 then no blit }
   cmp ax,319              { X > 319 ? }
   jg @ExitSprite          { Yes, Do not do any blits at all }

   mov si,di
   add si,2                { Make SI point to actual sprite data }

   xor ch,ch
   mov cl,[es:di]          { CL holds Clipwidth }

   cmp ah,$80              { Quick test if X position is negative }
   jb @XNotNegative        { If not then check if image is off right hand
                             of screen }
   neg ax                  { Make X position positive }

   cmp ax,cx               { If Abs(X) >= Image Width Then Don't Draw }
   ja @ExitSprite

   sub cx,ax               { Dec(ClipWidth, Abs(X)) }
   add si,ax               { Inc(DataStart, Abs(X)) }
   xor ax,ax               { Set X to 0 }
   jmp @NowDoY             { Do Y portion of data now. }

 @XNotNegative:
   mov dx,cx               { Set DX to clipwidth }
   add dx,ax               { If X + ClipWidth < 320 Then }
   cmp dx,320
   jb @NowDoY              { Do Y part (No need to clip width) }
   mov cx,320
   sub cx,ax               { ClipWidth = 320 - X }

{  At this point:

      AX is the X position of the Shape
      BX is the Y position of the Shape
      CL is the clipped width of the Shape.

      Now it is time to do the height part and set the result in CH.
}

 @NowDoY:
   xor dh,dh               { Make DX the height of image }
   mov dl,[es:di+1]
   mov ch,dl               { Set CH also to height for main blit routine }

   cmp bh,$80              { Quick test if Y position is negative }
   jb @YNotNegative

   neg bx                  { Make Y a positive number }

   cmp bx,dx               { If Y > ClipHeight }
   ja @NoDraw
   sub dx,bx               { Dec(ClipHeight, Abs(Y) ) }
   mov ch,dl               { As an image can only be 255 bytes high
                             this works fine.. }
   mov TEMPREG,AX          { Save X Coord on stack }
   xor ah,ah
   mov al,[es:di]          { AX = Width }
   mul bx                  { Calculate Y * Width }
   add si,ax               { Inc(DataStart, Abs(Y) * Width ) }
   mov AX,TEMPREG
   xor bx,bx               { Set Y to 0 }
   jmp @NowDoBlit          { NOW do the blit work. Whew! }

 @YNotNegative:
   add dx,bx               { If Y + ClipHeight > 199 Then }
   cmp dx,200
   jb @NowDoBlit
   mov dx,200
   sub dx,bx               { ClipHeight = 200 - Y }
   mov ch,dl

{
        At this point AX is the X position
                      BX is the Y position
                      CL is the ClipWidth and
                      CH is the ClipHeight.

        As the width/height of an Shape can only be an 8 bit
        quantity (i.e. < 256) I can discard the H portions of
        the registers. Whew!

        Now follows some weird code.. I'm going to make :

        DX = Modulo for datastart (which is the width in bytes of Shape.
        And yes, I do know that Width could be held in DL but adding extra
        code just to satisfy you optimisation junkies is v. boring.)

        DS:SI already points to data
        ES:DI points to active (source) Bitmap

}
  @NowDoBlit:
    or ch,ch
    jz @ExitSprite
    or cl,cl
    jz @ExitSprite

    mov TEMPREG,CX        { Save ClipWidth & ClipHeight on stack }

{=-=-=-=-=-=-=-=-=-=-=-= Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
     cmp ax,319         { Is X> 319 ? }
     ja @OutOfBounds    { Yes }
     cmp bx,199         { Is Y> 199 ?. Do not use BL instead as this is
                          when problems will occur.}
     ja @OutOfBounds    { Yes }

     xor ch,ch                  { CX = Y }
     mov cl,bl
     shl cx,6                   { Y * 64 }
     mov bh,bl                  { BX = Y * 256 }
     xor bl,bl
     add bx,cx                  { BX = BX + CX, which gives Y * 320 }
     add bx,ax                  { Add the X position to offset in BX }

     jmp @EndCalcOffset         { And exit. }

@OutOfBounds:
     jmp @ExitSprite             { coordinates are not within screen limites,
                                   so exit blitting }
@EndCalcOffset:

{=-=-=-=-=-=-=-=-=-=-=-= End Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
    mov CX,TEMPREG              { Restore ClipWidth and ClipHeight }

    xor dh,dh
    mov dl,[es:di]              { DX = Modulo }
    mov di,bx                   { Ahhh. Now DI points to the screen offset }
    jmp @EndClipCalc
  @NoDraw:
    jmp @ExitSprite             { no blit is possible }
  @EndClipCalc:
{-=-=-=-=-=-=-=-=- End clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   PUSH DS
   PUSH BP

   MOV AX,vpage_Seg
   MOV BX,ES
   MOV DS,BX                   { Now DS: SI points to correct space }
   MOV ES,AX

   MOV BX,SI                   { BX to be used to reload SI }
   MOV BP,DI                   { And the screen modulo }

   MOV AH,CL                   { AH = Width }
   CLD                         { Make sure LODSB works OK }

@Outer:
   MOV CL,AH                   { Re-load CL }
   MOV SI,BX                   { And SI with address of next sprite row }
   MOV DI,BP                   { And DI with address of next scan line }


@WriteByte:
   LODSB                       { Read byte from DS:SI }
   OR AL,AL                    { Is byte 0 (transparent) ? }
   JZ @NoBlit                  { yes, so don't blit }
   MOV [ES:DI],AL              { Otherwise store byte }

@NoBlit:
   INC DI                       { Move DI to next pos. on screen }
   DEC CL                       { Reduce shape width count }
   JNZ @WriteByte               { If not zero, end of shape not reached }

   ADD BX,DX                    { BX = BX + Modulo, so BX now points
                                  to first byte of next sprite line
                                  to blit }
   ADD BP,320                   { Make BP point to next line. Note :
                                  If you are going to add some extra
                                  stuff here make sure you're not
                                  accessing local variables! }


   DEC CH
   JNZ @Outer

   POP BP
   POP DS

 @ExitSprite:
END;
{}
{
        This is the same as the SPRITE procedure, but this one mirrors the
        image in X direction.

        Expects: AX to be X position
                 BX to be Y position
                 and ES:[DI] pointing at image data
        Returns: Nothing
}
PROCEDURE XFlipSprite; ASSEMBLER;
VAR TempREG       : word;
    TempCH        : byte;
ASM
{-=-=-=-=-=-=-=-=- Do clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   cmp bx,199              { Y > 199 ? }
   jg @ExitSprite          { JG is for SIGNED integers. If Y pos is
                             > 199 then no blit }
   cmp ax,319              { X > 319 ? }
   jg @ExitSprite          { Yes, Do not do any blits at all }

   mov si,di
   add si,2                { Make SI point to actual sprite data }

   xor ch,ch
   mov cl,[es:di]          { CL holds Clipwidth }

   cmp ah,$80              { Quick test if X position is negative }
   jb @XNotNegative        { If not then check if image is off right hand
                             of screen }
   neg ax                  { Make X position positive }

   cmp ax,cx               { If Abs(X) >= Image Width Then Don't Draw }
   ja @ExitSprite

   sub cx,ax               { Dec(ClipWidth, Abs(X)) }
   xor ax,ax               { Set X to 0 }
   jmp @NowDoY             { Do Y portion of data now. }

 @XNotNegative:
   mov dx,cx               { Set DX to clipwidth }
   add dx,ax               { If X + ClipWidth < 320 Then }
   cmp dx,320
   jb @NowDoY              { Do Y part (No need to clip width) }
   mov cx,320
   sub dx,cx               { substract 320, to get clip-position in data }
   add si,dx
   sub cx,ax               { ClipWidth = 320 - X }

{  At this point:

      AX is the X position of the Shape
      BX is the Y position of the Shape
      CL is the clipped width of the Shape.

      Now it is time to do the height part and set the result in CH.
}

 @NowDoY:
   xor dh,dh               { Make DX the height of image }
   mov dl,[es:di+1]
   mov ch,dl               { Set CH also to height for main blit routine }

   cmp bh,$80              { Quick test if Y position is negative }
   jb @YNotNegative

   neg bx                  { Make Y a positive number }

   cmp bx,dx               { If Y > ClipHeight }
   ja @NoDraw
   sub dx,bx               { Dec(ClipHeight, Abs(Y) ) }
   mov ch,dl               { As an image can only be 255 bytes high
                             this works fine.. }
   mov TEMPREG,AX          { Save X Coord on stack }
   xor ah,ah
   mov al,[es:di]          { AX = Width }
   mul bx                  { Calculate Y * Width }
   add si,ax               { Inc(DataStart, Abs(Y) * Width ) }
   mov AX,TEMPREG
   xor bx,bx               { Set Y to 0 }
   jmp @NowDoBlit          { NOW do the blit work. Whew! }

 @YNotNegative:
   add dx,bx               { If Y + ClipHeight > 199 Then }
   cmp dx,200
   jb @NowDoBlit
   mov dx,200
   sub dx,bx               { ClipHeight = 200 - Y }
   mov ch,dl

{
        At this point AX is the X position
                      BX is the Y position
                      CL is the ClipWidth and
                      CH is the ClipHeight.

        As the width/height of an Shape can only be an 8 bit
        quantity (i.e. < 256) I can discard the H portions of
        the registers. Whew!

        Now follows some weird code.. I'm going to make :

        DX = Modulo for datastart (which is the width in bytes of Shape.
        And yes, I do know that Width could be held in DL but adding extra
        code just to satisfy you optimisation junkies is v. boring.)

        DS:SI already points to data
        ES:DI points to active (source) Bitmap

}
  @NowDoBlit:
    or ch,0
    jz @ExitSprite
    or cl,0
    jz @ExitSprite
    mov TEMPREG,CX        { Save ClipWidth & ClipHeight on stack }

{=-=-=-=-=-=-=-=-=-=-=-= Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
     cmp ax,319         { Is X> 319 ? }
     ja @OutOfBounds    { Yes }
     cmp bx,199         { Is Y> 199 ?. Do not use BL instead as this is
                          when problems will occur.}
     ja @OutOfBounds    { Yes }

     xor ch,ch                  { CX = Y }
     mov cl,bl
     shl cx,6                   { Y * 64 }
     mov bh,bl                  { BX = Y * 256 }
     xor bl,bl
     add bx,cx                  { BX = BX + CX, which gives Y * 320 }
     add bx,ax                  { Add the X position to offset in BX }

     jmp @EndCalcOffset         { And exit. }

@OutOfBounds:
     jmp @ExitSprite             { coordinates are not within screen limites,
                                   so exit blitting }
@EndCalcOffset:

{=-=-=-=-=-=-=-=-=-=-=-= End Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
    mov CX,TEMPREG              { Restore ClipWidth and ClipHeight }

    xor dh,dh
    mov dl,[es:di]              { DX = Modulo }
    mov di,bx                   { Ahhh. Now DI points to the screen offset }
    jmp @EndClipCalc
  @NoDraw:
    jmp @ExitSprite             { no blit is possible }
  @EndClipCalc:
{-=-=-=-=-=-=-=-=- End clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   PUSH DS
   PUSH BP

   MOV AX,vpage_seg
   MOV BX,ES
   MOV DS,BX                   { Now DS: SI points to correct space }
   MOV ES,AX

   MOV BX,SI                   { BX to be used to reload SI }
   MOV BP,DI                   { And the screen modulo }

   MOV AH,CL                   { AH = Width }
   xor al,al                   { set CH to 0 }
   xchg al,ah
   ADD BP,AX                   { add clipping width to DI }
   dec BP                      { minus one (trust me, this is needed) }
   xchg al,ah
   CLD                         { Make sure LODSB works OK }

@Outer:
   MOV CL,AH                   { Re-load CL }
   MOV SI,BX                   { And SI with address of next sprite row }
   MOV DI,BP                   { And DI with address of next scan line }

@WriteByte:
   LODSB                       { Read byte from DS:SI }
   OR AL,AL                    { Is byte 0 (transparent) ? }
   JZ @NoBlit                  { yes, so don't blit }
   MOV [ES:DI],AL              { Otherwise store byte }

@NoBlit:
   DEC DI                       { Move DI to next pos. on screen }
   DEC CL                       { Reduce shape width count }
   JNZ @WriteByte               { If not zero, end of shape not reached }

   ADD BX,DX                    { BX = BX + Modulo, so BX now points
                                  to first byte of next sprite line
                                  to blit }
   ADD BP,320                   { Make BP point to next line. Note :
                                  If you are going to add some extra
                                  stuff here make sure you're not
                                  accessing local variables! }

   DEC CH                       { Decrease Hight Counter }
   JNZ @Outer

   POP BP
   POP DS

 @ExitSprite:
END;
{}
{
        Put a sprite on screen fast style (only clipping, no masking)
        I know this could be done faster without clipping, but it's written
        for pentiums and the speed difference is not noticeable...

        Expects: AX to be X position
                 BX to be Y position
                 ES:[DI] to point to image data
        Returns: Nothing
}
PROCEDURE SpriteNoMask; Assembler;
VAR TempREG : word;
ASM
{-=-=-=-=-=-=-=-=- Do clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   cmp bx,199              { Y > 199 ? }
   jg @ExitSprite          { JG is for SIGNED integers. If Y pos is
                             > 199 then no blit }
   cmp ax,319              { X > 319 ? }
   jg @ExitSprite          { Yes, Do not do any blits at all }

   mov si,di
   add si,2                { Make SI point to actual sprite data }

   xor ch,ch
   mov cl,[es:di]          { CL holds Clipwidth }

   cmp ah,$80              { Quick test if X position is negative }
   jb @XNotNegative        { If not then check if image is off right hand
                             of screen }
   neg ax                  { Make X position positive }

   cmp ax,cx               { If Abs(X) >= Image Width Then Don't Draw }
   ja @ExitSprite

   sub cx,ax               { Dec(ClipWidth, Abs(X)) }
   add si,ax               { Inc(DataStart, Abs(X)) }
   xor ax,ax               { Set X to 0 }
   jmp @NowDoY             { Do Y portion of data now. }

 @XNotNegative:
   mov dx,cx               { Set DX to clipwidth }
   add dx,ax               { If X + ClipWidth < 320 Then }
   cmp dx,320
   jb @NowDoY              { Do Y part (No need to clip width) }
   mov cx,320
   sub cx,ax               { ClipWidth = 320 - X }

{  At this point:

      AX is the X position of the Shape
      BX is the Y position of the Shape
      CL is the clipped width of the Shape.

      Now it is time to do the height part and set the result in CH.
}

 @NowDoY:
   xor dh,dh               { Make DX the height of image }
   mov dl,[es:di+1]
   mov ch,dl               { Set CH also to height for main blit routine }

   cmp bh,$80              { Quick test if Y position is negative }
   jb @YNotNegative

   neg bx                  { Make Y a positive number }

   cmp bx,dx               { If Y > ClipHeight }
   ja @NoDraw
   sub dx,bx               { Dec(ClipHeight, Abs(Y) ) }
   mov ch,dl               { As an image can only be 255 bytes high
                             this works fine.. }
   mov TEMPREG,AX          { Save X Coord in variable }
   xor ah,ah
   mov al,[es:di]          { AX = Width }
   mul bx                  { Calculate Y * Width }
   add si,ax               { Inc(DataStart, Abs(Y) * Width ) }
   mov AX,TEMPREG
   xor bx,bx               { Set Y to 0 }
   jmp @NowDoBlit          { NOW do the blit work. Whew! }

 @YNotNegative:
   add dx,bx               { If Y + ClipHeight > 199 Then }
   cmp dx,200
   jb @NowDoBlit
   mov dx,200
   sub dx,bx               { ClipHeight = 200 - Y }
   mov ch,dl

{
        At this point AX is the X position
                      BX is the Y position
                      CL is the ClipWidth and
                      CH is the ClipHeight.

        As the width/height of an Shape can only be an 8 bit
        quantity (i.e. < 256) I can discard the H portions of
        the registers. Whew!

        Now follows some weird code.. I'm going to make :

        DX = Modulo for datastart (which is the width in bytes of Shape.
        And yes, I do know that Width could be held in DL but adding extra
        code just to satisfy you optimisation junkies is v. boring.)

        DS:SI already points to data
        ES:DI points to active (source) Bitmap

}
  @NowDoBlit:
    or ch,0
    jz @ExitSprite
    or cl,0
    jz @ExitSprite
    mov TEMPREG,CX              { Save ClipWidth & ClipHeight on stack }

{=-=-=-=-=-=-=-=-=-=-=-= Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
     cmp ax,319         { Is X> 319 ? }
     ja @OutOfBounds    { Yes }
     cmp bx,199         { Is Y> 199 ?. Do not use BL instead as this is
                          when problems will occur.}
     ja @OutOfBounds    { Yes }

     xor ch,ch                  { CX = Y }
     mov cl,bl
     shl cx,6                   { Y * 64 }
     mov bh,bl                  { BX = Y * 256 }
     xor bl,bl
     add bx,cx                  { BX = BX + CX, which gives Y * 320 }
     add bx,ax                  { Add the X position to offset in BX }
     jmp @EndCalcOffset         { And exit. }

   @OutOfBounds:
     jmp @ExitSprite            { Signal that coordinates were not within
                                  the screen limits }
   @EndCalcOffset:
{=-=-=-=-=-=-=-=-=-=-=-= End Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
    mov CX,TEMPREG              { Restore ClipWidth and ClipHeight }

    xor dh,dh
    mov dl,[es:di]              { DX = Modulo }
    mov di,bx                   { Ahhh. Now DI points to the screen offset }
    jmp @EndClipCalc
  @NoDraw:
    jmp @ExitSprite            { Indicate no blit possible }
  @EndClipCalc:
{-=-=-=-=-=-=-=-=- End clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}
   PUSH DS
   PUSH BP

   MOV AX,Vpage_Seg
   MOV BX,ES
   MOV DS,BX                   { Now DS: SI points to correct space }
   MOV ES,AX

   MOV BX,SI                   { BX to be used to reload SI (+Image Width) }
   MOV BP,DI                   { And BP to reload DI (+Screen Width) }

 @Outer:
   PUSH CX
   MOV CH,CL                   { CH is set to ClipWidth }

   MOV SI,BX
   MOV DI,BP

   CMP CH,4                     { Bytes left < 4 ? }
   JB @CantDoLongWordBlit       { Yeah, so can't do the 4 byte blit }

   SHR CH,2                     { Divide Bytes left by 4 }

 @CopyLong:
   DB $66                       { Otherwise, store longword to [ES:DI] ! }
   MOVSW
   DEC CH                       { Reduce long word count }
   JNZ @CopyLong

   MOV CH,CL                    { Restore CL }
   AND CH,3
   OR CH,CH
   JZ @NoBytesLeft


 @CantDoLongWordBlit:
   CMP CH,2                     { Byte count < 2 ? }
   JB @CheckDoByteBlit          { Yes, can't do a word blit (Shit !)
                                  so that means that there's only
                                  1 byte left. }
 @CopyWord:
   MOVSW                        { Otherwise, write word }


 @CheckDoByteBlit:
   TEST CH,1                    { Is there a byte left ? }
   JZ @NoBytesLeft              { No, so no more blits this line }

 @DoByteBlit:
   MOVSB                        { Store the last byte }

 @NoBytesLeft:
   ADD BX,DX                    { BP to next byte of image to read }
   ADD BP,320                   { Advance BX to next scan line }

   POP CX
   DEC CH                       { Reduce Y count }
   JNZ @Outer                   { if <>0 then go to Outer }

   POP BP                       { Restore base pointer and }
   POP DS                       { Data Segment }

 @ExitSprite:
END;
{}
{
        Put a sprite on screen in one color, for when a enemy get's hit
        it can be "blinked" to white for a few frames...

        Expects: AX to be X position
                 BX to be Y position
                 and ES:[DI] pointing at image data
        Returns: Nothing
}
PROCEDURE SpriteBLINK; ASSEMBLER;
VAR TempREG       : word;
ASM
{-=-=-=-=-=-=-=-=- Do clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   cmp bx,199              { Y > 199 ? }
   jg @ExitSprite          { JG is for SIGNED integers. If Y pos is
                             > 199 then no blit }
   cmp ax,319              { X > 319 ? }
   jg @ExitSprite          { Yes, Do not do any blits at all }

   mov si,di
   add si,2                { Make SI point to actual sprite data }

   xor ch,ch
   mov cl,[es:di]          { CL holds Clipwidth }

   cmp ah,$80              { Quick test if X position is negative }
   jb @XNotNegative        { If not then check if image is off right hand
                             of screen }
   neg ax                  { Make X position positive }

   cmp ax,cx               { If Abs(X) >= Image Width Then Don't Draw }
   ja @ExitSprite

   sub cx,ax               { Dec(ClipWidth, Abs(X)) }
   add si,ax               { Inc(DataStart, Abs(X)) }
   xor ax,ax               { Set X to 0 }
   jmp @NowDoY             { Do Y portion of data now. }

 @XNotNegative:
   mov dx,cx               { Set DX to clipwidth }
   add dx,ax               { If X + ClipWidth < 320 Then }
   cmp dx,320
   jb @NowDoY              { Do Y part (No need to clip width) }
   mov cx,320
   sub cx,ax               { ClipWidth = 320 - X }

{  At this point:

      AX is the X position of the Shape
      BX is the Y position of the Shape
      CL is the clipped width of the Shape.

      Now it is time to do the height part and set the result in CH.
}

 @NowDoY:
   xor dh,dh               { Make DX the height of image }
   mov dl,[es:di+1]
   mov ch,dl               { Set CH also to height for main blit routine }

   cmp bh,$80              { Quick test if Y position is negative }
   jb @YNotNegative

   neg bx                  { Make Y a positive number }

   cmp bx,dx               { If Y > ClipHeight }
   ja @NoDraw
   sub dx,bx               { Dec(ClipHeight, Abs(Y) ) }
   mov ch,dl               { As an image can only be 255 bytes high
                             this works fine.. }
   mov TEMPREG,AX          { Save X Coord on stack }
   xor ah,ah
   mov al,[es:di]          { AX = Width }
   mul bx                  { Calculate Y * Width }
   add si,ax               { Inc(DataStart, Abs(Y) * Width ) }
   mov AX,TEMPREG
   xor bx,bx               { Set Y to 0 }
   jmp @NowDoBlit          { NOW do the blit work. Whew! }

 @YNotNegative:
   add dx,bx               { If Y + ClipHeight > 199 Then }
   cmp dx,200
   jb @NowDoBlit
   mov dx,200
   sub dx,bx               { ClipHeight = 200 - Y }
   mov ch,dl

{
        At this point AX is the X position
                      BX is the Y position
                      CL is the ClipWidth and
                      CH is the ClipHeight.

        As the width/height of an Shape can only be an 8 bit
        quantity (i.e. < 256) I can discard the H portions of
        the registers. Whew!

        Now follows some weird code.. I'm going to make :

        DX = Modulo for datastart (which is the width in bytes of Shape.
        And yes, I do know that Width could be held in DL but adding extra
        code just to satisfy you optimisation junkies is v. boring.)

        DS:SI already points to data
        ES:DI points to active (source) Bitmap

}
  @NowDoBlit:
    or ch,0
    jz @ExitSprite
    or cl,0
    jz @ExitSprite
    mov TEMPREG,CX        { Save ClipWidth & ClipHeight on stack }

{=-=-=-=-=-=-=-=-=-=-=-= Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
     cmp ax,319         { Is X> 319 ? }
     ja @OutOfBounds    { Yes }
     cmp bx,199         { Is Y> 199 ?. Do not use BL instead as this is
                          when problems will occur.}
     ja @OutOfBounds    { Yes }

     xor ch,ch                  { CX = Y }
     mov cl,bl
     shl cx,6                   { Y * 64 }
     mov bh,bl                  { BX = Y * 256 }
     xor bl,bl
     add bx,cx                  { BX = BX + CX, which gives Y * 320 }
     add bx,ax                  { Add the X position to offset in BX }

     jmp @EndCalcOffset         { And exit. }

@OutOfBounds:
     jmp @ExitSprite             { coordinates are not within screen limites,
                                   so exit blitting }
@EndCalcOffset:

{=-=-=-=-=-=-=-=-=-=-=-= End Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
    mov CX,TEMPREG              { Restore ClipWidth and ClipHeight }

    xor dh,dh
    mov dl,[es:di]              { DX = Modulo }
    mov di,bx                   { Ahhh. Now DI points to the screen offset }
    jmp @EndClipCalc
  @NoDraw:
    jmp @ExitSprite             { no blit is possible }
  @EndClipCalc:
{-=-=-=-=-=-=-=-=- End clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   PUSH DS
   PUSH BP

   MOV AX,vpage_Seg
   MOV BX,ES
   MOV DS,BX                   { Now DS: SI points to correct space }
   MOV ES,AX

   MOV BX,SI                   { BX to be used to reload SI }
   MOV BP,DI                   { And the screen modulo }

   MOV AH,CL                   { AH = Width }
   CLD                         { Make sure LODSB works OK }

@Outer:
   MOV CL,AH                   { Re-load CL }
   MOV SI,BX                   { And SI with address of next sprite row }
   MOV DI,BP                   { And DI with address of next scan line }


@WriteByte:
   LODSB                       { Read byte from DS:SI }
   OR AL,AL                    { Is byte 0 (transparent) ? }
   JZ @NoBlit                  { yes, so don't blit }
   MOV AL,ColorWhite           { set the color to white }
   MOV [ES:DI],al              { Otherwise store byte }

@NoBlit:
   INC DI                       { Move DI to next pos. on screen }
   DEC CL                       { Reduce shape width count }
   JNZ @WriteByte               { If not zero, end of shape not reached }

   ADD BX,DX                    { BX = BX + Modulo, so BX now points
                                  to first byte of next sprite line
                                  to blit }
   ADD BP,320                   { Make BP point to next line. Note :
                                  If you are going to add some extra
                                  stuff here make sure you're not
                                  accessing local variables! }


   DEC CH
   JNZ @Outer

   POP BP
   POP DS

 @ExitSprite:
END;
{}
{
        This is the same as the SPRITEBLINK procedure, but this one
        mirrors the image in X direction.

        Expects: AX to be X position
                 BX to be Y position
                 and ES:[DI] pointing at image data
        Returns: Nothing
}
PROCEDURE XFlipSpriteBlink; ASSEMBLER;
VAR TempREG       : word;
    TempCH        : byte;
ASM
{-=-=-=-=-=-=-=-=- Do clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   cmp bx,199              { Y > 199 ? }
   jg @ExitSprite          { JG is for SIGNED integers. If Y pos is
                             > 199 then no blit }
   cmp ax,319              { X > 319 ? }
   jg @ExitSprite          { Yes, Do not do any blits at all }

   mov si,di
   add si,2                { Make SI point to actual sprite data }

   xor ch,ch
   mov cl,[es:di]          { CL holds Clipwidth }

   cmp ah,$80              { Quick test if X position is negative }
   jb @XNotNegative        { If not then check if image is off right hand
                             of screen }
   neg ax                  { Make X position positive }

   cmp ax,cx               { If Abs(X) >= Image Width Then Don't Draw }
   ja @ExitSprite

   sub cx,ax               { Dec(ClipWidth, Abs(X)) }
   xor ax,ax               { Set X to 0 }
   jmp @NowDoY             { Do Y portion of data now. }

 @XNotNegative:
   mov dx,cx               { Set DX to clipwidth }
   add dx,ax               { If X + ClipWidth < 320 Then }
   cmp dx,320
   jb @NowDoY              { Do Y part (No need to clip width) }
   mov cx,320
   sub dx,cx               { substract 320, to get clip-position in data }
   add si,dx
   sub cx,ax               { ClipWidth = 320 - X }

{  At this point:

      AX is the X position of the Shape
      BX is the Y position of the Shape
      CL is the clipped width of the Shape.

      Now it is time to do the height part and set the result in CH.
}

 @NowDoY:
   xor dh,dh               { Make DX the height of image }
   mov dl,[es:di+1]
   mov ch,dl               { Set CH also to height for main blit routine }

   cmp bh,$80              { Quick test if Y position is negative }
   jb @YNotNegative

   neg bx                  { Make Y a positive number }

   cmp bx,dx               { If Y > ClipHeight }
   ja @NoDraw
   sub dx,bx               { Dec(ClipHeight, Abs(Y) ) }
   mov ch,dl               { As an image can only be 255 bytes high
                             this works fine.. }
   mov TEMPREG,AX          { Save X Coord on stack }
   xor ah,ah
   mov al,[es:di]          { AX = Width }
   mul bx                  { Calculate Y * Width }
   add si,ax               { Inc(DataStart, Abs(Y) * Width ) }
   mov AX,TEMPREG
   xor bx,bx               { Set Y to 0 }
   jmp @NowDoBlit          { NOW do the blit work. Whew! }

 @YNotNegative:
   add dx,bx               { If Y + ClipHeight > 199 Then }
   cmp dx,200
   jb @NowDoBlit
   mov dx,200
   sub dx,bx               { ClipHeight = 200 - Y }
   mov ch,dl

{
        At this point AX is the X position
                      BX is the Y position
                      CL is the ClipWidth and
                      CH is the ClipHeight.

        As the width/height of an Shape can only be an 8 bit
        quantity (i.e. < 256) I can discard the H portions of
        the registers. Whew!

        Now follows some weird code.. I'm going to make :

        DX = Modulo for datastart (which is the width in bytes of Shape.
        And yes, I do know that Width could be held in DL but adding extra
        code just to satisfy you optimisation junkies is v. boring.)

        DS:SI already points to data
        ES:DI points to active (source) Bitmap

}
  @NowDoBlit:
    or ch,0
    jz @ExitSprite
    or cl,0
    jz @ExitSprite
    mov TEMPREG,CX        { Save ClipWidth & ClipHeight on stack }

{=-=-=-=-=-=-=-=-=-=-=-= Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
     cmp ax,319         { Is X> 319 ? }
     ja @OutOfBounds    { Yes }
     cmp bx,199         { Is Y> 199 ?. Do not use BL instead as this is
                          when problems will occur.}
     ja @OutOfBounds    { Yes }

     xor ch,ch                  { CX = Y }
     mov cl,bl
     shl cx,6                   { Y * 64 }
     mov bh,bl                  { BX = Y * 256 }
     xor bl,bl
     add bx,cx                  { BX = BX + CX, which gives Y * 320 }
     add bx,ax                  { Add the X position to offset in BX }

     jmp @EndCalcOffset         { And exit. }

@OutOfBounds:
     jmp @ExitSprite             { coordinates are not within screen limites,
                                   so exit blitting }
@EndCalcOffset:

{=-=-=-=-=-=-=-=-=-=-=-= End Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
    mov CX,TEMPREG              { Restore ClipWidth and ClipHeight }

    xor dh,dh
    mov dl,[es:di]              { DX = Modulo }
    mov di,bx                   { Ahhh. Now DI points to the screen offset }
    jmp @EndClipCalc
  @NoDraw:
    jmp @ExitSprite             { no blit is possible }
  @EndClipCalc:
{-=-=-=-=-=-=-=-=- End clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   PUSH DS
   PUSH BP

   MOV AX,vpage_seg
   MOV BX,ES
   MOV DS,BX                   { Now DS: SI points to correct space }
   MOV ES,AX

   MOV BX,SI                   { BX to be used to reload SI }
   MOV BP,DI                   { And the screen modulo }

   MOV AH,CL                   { AH = Width }
   xor al,al                   { set CH to 0 }
   xchg al,ah
   ADD BP,AX                   { add clipping width to DI }
   dec BP                      { minus one (trust me, this is needed) }
   xchg al,ah
   CLD                         { Make sure LODSB works OK }

@Outer:
   MOV CL,AH                   { Re-load CL }
   MOV SI,BX                   { And SI with address of next sprite row }
   MOV DI,BP                   { And DI with address of next scan line }

@WriteByte:
   LODSB                       { Read byte from DS:SI }
   OR AL,AL                    { Is byte 0 (transparent) ? }
   JZ @NoBlit                  { yes, so don't blit }
   mov al,ColorWhite
   MOV [ES:DI],AL              { Otherwise store byte }

@NoBlit:
   DEC DI                       { Move DI to next pos. on screen }
   DEC CL                       { Reduce shape width count }
   JNZ @WriteByte               { If not zero, end of shape not reached }

   ADD BX,DX                    { BX = BX + Modulo, so BX now points
                                  to first byte of next sprite line
                                  to blit }
   ADD BP,320                   { Make BP point to next line. Note :
                                  If you are going to add some extra
                                  stuff here make sure you're not
                                  accessing local variables! }

   DEC CH                       { Decrease Hight Counter }
   JNZ @Outer

   POP BP
   POP DS

 @ExitSprite:
END;
{}
{
        This will put a shape on screen in SCALED form, No clipping on
        screen edges!!!
        Scaling by Sean Palmer, assembler code by Scott Tunstall

        Expects: Pointer to data, and the corner-values of the
                 area it should be scaled in
        Returns: Nothing

}
PROCEDURE SCALESHAPE(var DataPtr; x1:word;y1:byte;x2:word;y2:byte); ASSEMBLER;
TYPE  fixed = record
          case boolean of
               true  : (w : longint);
               false : (f, i : word);
          end;

VAR  x,y        : word;  { Makes those muls easier }
     s, w, h    : word;
     sx, sy, cy : fixed;

ASM
     MOV SI, WORD PTR DataPtr
     MOV ES, WORD PTR DataPtr+2

     XOR AH,AH                  { Get shape width into X }
     MOV AL,[ES:SI]
     MOV x,AX
     INC SI

     MOV AL,[ES:SI]             { Get shape height into Y }
     MOV y,AX
     INC SI

     MOV AX,x1
     XOR BH,BH
     MOV BL,y1

{=-=-=-=-=-=-=-=-=-=-=-= Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
     cmp ax,319         { Is X> 319 ? }
     ja @OutOfBounds    { Yes }
     cmp bx,199         { Is Y> 199 ?. Do not use BL instead as this is
                          when problems will occur.}
     ja @OutOfBounds    { Yes }

     xor ch,ch                  { CX = Y }
     mov cl,bl
     shl cx,6                   { Y * 64 }
     mov bh,bl                  { BX = Y * 256 }
     xor bl,bl
     add bx,cx                  { BX = BX + CX, which gives Y * 320 }
     add bx,ax                  { Add the X position to offset in BX }

     jmp @EndCalcOffset         { And exit. }

@OutOfBounds:
     jmp @ExitSprite             { coordinates are not within screen limites,
                                   so exit blitting }
@EndCalcOffset:

{=-=-=-=-=-=-=-=-=-=-=-= End Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}

     MOV DI,BX

     MOV BX,x2
     XCHG AX,BX                 { AX = X2, BX = X1 }
     SUB AX,BX
     INC AX
     MOV CX,AX
     MOV w,AX

     MOV AX,320                 { s = 320 - w }
     SUB AX,CX
     MOV s,AX

     XOR DX,DX                  { Make DX:AX = 65536 }
     INC DL
     XOR AX,AX
     DIV CX                     { 65536 / w }

     MUL x                      { * x }
     MOV WORD [sx.w],AX
     MOV WORD [sx.w+2],DX


     XOR AH,AH                  { Calc (y2 - y1) + 1 }
     MOV AL,y2
     SUB AL,y1
     INC AL
     MOV h,AX                   { h = result }
     MOV BX,AX

     XOR DX,DX                  { Make DX:AX = 65536 }
     INC DL
     XOR AX,AX
     DIV BX                     { 65536 / h }
     MUL y                      { * y }
     MOV WORD [sy.w],AX
     MOV WORD [sy.w+2],DX

     DB $66; XOR AX,AX
     DB $66; MOV WORD PTR cy.w, AX



     PUSH DS

     MOV AX,ES
     MOV ES,Vpage_Seg
     MOV DS,AX




{
At this point

   CX    = width
   DX    = height
   DS:SI = points to top left of shape
   ES:DI = points to ADDress on screen where scaled shape
           will be placed
}


    cld


@L2:

    MOV AX,SI                   { I THINK this is faster than a push }
    DB $66; SHL SI,16           { I mean, there are no memory accesses }
    MOV SI,AX                   { right ? Nor any stack pointer updates }


    MOV  AX, cy.i
    MUL  X                      { It would have been nice if intel
                                  created a 16 bit MUL which didn't
                                  f**k up DX }
    ADD  SI,AX


    MOV  AX,CX                  { Get width }
    DB $66; shl CX,16           { Put it in MSW of EAX }
    MOV  CX, AX

    XOR  BX, BX
    MOV  DX, sx.f

@L:
    MOV AL,[SI]
    cmp al,0
    je @NoBlit
    mov es:[di],al
 @NoBlit:
    inc di

    ADD  BX, DX
    ADC  SI, sx.i               { if carry or sx.i<>0,
				  new source pixel }

    DEC CX
    JNZ @L

    DB $66; SHR SI,16           { Restore SI }
    DB $66; SHR CX,16           { And CX }

    ADD  DI, s                  { skip to next screen row}
    DB $66; MOV  AX, sy.f       { MOV EAX, sy.f }
    DB $66; ADD  cy.f, AX       { ADD DWORD PTR cy.f, EAX }

    DEC  WORD PTR h
    JNZ  @L2
    POP  DS
  @ExitSprite:
END;
{}
{
        Load in a palette from a DFPLIB file, or just from DOS

        Expects: LIB      - TRUE if you use a library file
                 name     - name of the palette- file
        Returns: TRUE if file succesfully loaded.

}
FUNCTION Loadpal(lib:boolean;name:string):boolean;
VAR i,code : byte;
    r,g,b  : byte;
BEGIN
 LoadPal:=false;            { not yet loaded }
 if lib then begin              { use a lib file? }
    code:=LIB_RESET(name);      { yes, so reset it }

    if code<>0 then exit;       { if code<>0 something went wrong }

 end else begin
    assign(lib_file,name);      { use dos file }
    {$I-}
       reset(lib_file,1);       { reset the file }
    {$I+}
    if ioresult<>0 then begin
       exit;
    end;
 end;
 FOR i:=0 to 255 do begin
     blockread(lib_file,r,sizeof(r));
     blockread(lib_file,g,sizeof(g));
     blockread(lib_file,b,sizeof(b));
     if r>63 then begin              { 0-255 based color value }
        r:=r shr 2;
        g:=g shr 2;
        b:=b shr 2;
     end;
     pal[i].redlevel:=r;
     pal[i].greenlevel:=g;
     pal[i].bluelevel:=b;
 end;
 close(lib_file);
 loadpal:=true;
END;
{}
{
        Set Palette

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE SetPal; ASSEMBLER;
ASM
  xor ch,ch
  mov si,offset pal

  mov cl,0
 @ColorLoop:
  mov dx,$03c8
  mov al,cl
  out dx,al
  inc dx

  lodsb;  out dx,al
  lodsb;  out dx,al
  lodsb;  out dx,al

  inc cl
  jnz @ColorLoop
END;
{}
{
        Black Palette

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE BlackPal; ASSEMBLER;
ASM
  xor ch,ch

  mov cl,255
 @ColorLoop:
  mov dx,$03c8
  mov al,cl
  out dx,al
  inc dx
  xor al,al

  out dx,al
  out dx,al
  out dx,al

  Loop @ColorLoop
END;


{}
{
        Go into black&white mode

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE GreyPal(col1,col2:Byte);
VAR   i ,r,g,b : byte;
      total    : byte;
BEGIN
 for i:=col1 to col2 do begin
     port[$03c7]:=i;
     r:=port[$03c9];
     g:=port[$03c9];
     b:=port[$03c9];
     total:=round( (r*0.3)+ (g*0.59)+ (b*0.11) );
     port[$03c8]:=i;
     port[$03c9]:=total;
     port[$03c9]:=total;
     port[$03c9]:=total;
 end;
END;
{}
{
        Create a Fade out

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE FadeOut(col1,col2:byte);
VAR j,i,r,g,b : byte;
BEGIN
 for j:=0 to 63 do begin
    for i:=col1 to col2 do begin
      port[$03c7]:=i;
      r:=port[$03c9];
      g:=port[$03c9];
      b:=port[$03c9];
      if r>1 then dec(r,2) else r:=0;
      if g>1 then dec(g,2) else g:=0;
      if b>1 then dec(B,2) else b:=0;
      port[$03c8]:=i;
      port[$03c9]:=r;
      port[$03c9]:=g;
      port[$03c9]:=b;
    end;
    Retrace;
  end;
END;
{}
{
        Create a Fade in

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE FadeIn(col1,col2:byte);
VAR j,i,r,g,b : byte;
BEGIN
 for j:=0 to 63 do begin
    for i:=col1 to col2 do begin
      port[$03c7]:=i;
      r:=port[$03c9];
      g:=port[$03c9];
      b:=port[$03c9];
      if r<pal[i].redlevel-1 then inc(r,2) else r:=pal[i].redlevel;
      if g<pal[i].greenlevel-1 then inc(g,2) else g:=pal[i].greenlevel;
      if b<pal[i].bluelevel-1 then inc(B,2) else b:=pal[i].bluelevel;
      port[$03c8]:=i;
      port[$03c9]:=r;
      port[$03c9]:=g;
      port[$03c9]:=b;
    end;
    retrace;
 end;
END;
{}
{
        Create a Fade in to grey (using the loaded color-palette)

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE FadetoGrey(col1,col2:Byte);
VAR j,i,r,g,b : byte;
    total     : byte;
BEGIN
 for j:=0 to 63 do begin
    for i:=col1 to col2 do begin
      r:=pal[i].redlevel;
      g:=pal[i].greenlevel;
      b:=pal[i].bluelevel;
      total:=round( (r*0.3)+ (g*0.59)+ (b*0.11) );

      port[$03c7]:=i;
      r:=port[$03c9];
      g:=port[$03c9];
      b:=port[$03c9];
      if r<total-1 then inc(r,2) else
         if r>total+1 then dec(r,2) else
            r:=total;
      if g<total-1 then inc(g,2) else
         if g>total+1 then dec(g,2) else
            g:=total;
      if b<total-1 then inc(B,2) else
         if b>total+1 then dec(b,2) else
            b:=total;
     port[$03c8]:=i;
     port[$03c9]:=r;
     port[$03c9]:=g;
     port[$03c9]:=b;
    end;
    retrace;
 end;
END;

{}
{
        Get a XAS file....

        Expects: LIB      - true if dfplib file used.
                 filename - name of XAS file
                 storing  - array of sprites in wich the XAS will be stored

        Returns: The amount of shapes that where loaded, if a 0 is returned
                 there was probably something wrong with the file, or the
                 file was not found.
}
FUNCTION GetXAS(lib:boolean; filename:string; var storing:array of spritetyp):Byte;
VAR TID     : string [6];
    k       : integer;
    l       : integer;
    msize   : word;
    dtx,dty : word;
    x,y     : word;
    ent     : word;
    cycle   : boolean;
    datamem : longint;
BEGIN
  GetXAS:=0;
  if lib then begin
     k:=LIB_RESET(filename);        {Open the LIB_File}
     if k<>0 then exit;
  end else begin
     assign(lib_file,filename);
     {$I-}
        reset(lib_file,1);
     {$I+}
     if ioresult<>0 then begin
        GetXAS:=0;
        exit;
     end;
  end;
   blockread(lib_file,tid[1],5);
   tid[0]:=#5;
   if tid<>'XASv3' then begin
      halt_Error:='Not a valid XAS file';
      close(lib_file);
      exit;
   end;
   blockread(lib_file,ent,sizeof(ent));
   blockread(lib_file,datamem,sizeof(datamem)); { only used with XMS version }

   k:=low(storing);
   l:=1;
   repeat
    if storing[k].data<>NIL then begin   { dispose old first }
       dtx:=mem[seg(storing[k].data^):ofs(storing[k].data^)];
       dty:=mem[seg(storing[k].data^):ofs(storing[k].data^)+1];
       msize:=(dtx*dty)+2;
       if (msize mod 16)<>0 then msize:=msize+16;
       msize:=16*(msize div 16);
       {$IFDEF USEDOSMEM}
          DALLOC(storing[k].data);
       {$ELSE}
          freemem(storing[k].data,msize);
       {$ENDIF}
    end;
    storing[k].bitflags:=0;

    blockread(lib_file,dtx,2);
    blockread(lib_file,dty,2);
    blockread(lib_file,storing[k].a_frame,1); {sizeof(storing[k].a_frame));}
    blockread(lib_file,storing[k].s_frame,1);
    blockread(lib_file,cycle,1);
    if cycle then
       storing[k].BitFlags:=storing[k].BitFlags or 1;

    storing[k].c_Frame:=k;
    storing[k].t_Frame:=storing[k].s_frame;
    storing[k].n_Frame:=1;

    msize:=(dtx*dty)+2;
    if (msize mod 16)<>0 then msize:=msize+16;
    msize:=16*(msize div 16);
    {$IFDEF USEDOSMEM}
        MemAlloc(storing[k].data,dtx*dty);
    {$ELSE}
        GetMem(storing[k].data,msize);
    {$ENDIF}

    mem[seg(storing[k].data^):ofs(storing[k].data^)]:=byte(dtx);
    mem[seg(storing[k].data^):ofs(storing[k].data^)+1]:=byte(dty);

    blockread(lib_file,mem[seg(storing[k].data^):ofs(storing[k].data^)+2],dtx*dty);

    { check to see if we can skip the masking }
    with storing[k] do begin
      y:=0;
      cycle:=false;
      repeat
        x:=0;
        repeat
          if mem[seg(data^):ofs(Data^)+2+(y*dtx)+x]=0 then begin
             Cycle:=true;
          end;
          inc(x);
        until (x=dtx) or (cycle);
        inc(y);
      until (y=dty) or (cycle);
    end;
    if not Cycle then
       storing[k].BitFlags:=storing[k].BitFlags or 2;
    inc(k);
    inc(l);
   until l>ent;
   close(lib_file);
   GetXas:=ent;
   if (seg(storing)=seg(tiles)) and (ofs(storing)=ofs(tiles)) then begin
      TilesInFile:=ent;
      cycle:=false;
      for k:=low(storing) to ent do
          if storing[k].a_frame>1 then cycle:=true;
      animated:=cycle;
   end;
END;
{}
{
        Get an image file....

        Expects: LIB      - true if dfplib file used.
                 filename - name of XAS file
                 storing  - array of images in wich the XAS will be stored

        Returns: The amount of shapes that where loaded, if a 0 is returned
                 there was probably something wrong with the file, or the
                 file was not found.
}
FUNCTION GetImages(lib:boolean; filename:string; var storing:array of imagetyp):Byte;
VAR TID     : string [6];
    k       : integer;
    l       : integer;
    frame   : byte;
    msize   : word;
    dtx,dty : word;
    x,y     : word;
    ent     : word;
    cycle   : boolean;
    datamem : longint;
BEGIN
  GetImages:=0;
  if lib then begin
     k:=LIB_RESET(filename);        {Open the LIB_File}
     if k<>0 then exit;
  end else begin
     assign(lib_file,filename);
     {$I-}
        reset(lib_file,1);
     {$I+}
     if ioresult<>0 then begin
        GetImages:=0;
        exit;
     end;
  end;
   blockread(lib_file,tid[1],5);
   tid[0]:=#5;
   if tid<>'XASv3' then begin
      halt_error:='Not a valid XAS file';
      close(lib_file);
      exit;
   end;
   blockread(lib_file,ent,sizeof(ent));
   blockread(lib_file,datamem,sizeof(datamem)); {only needed with XMS version}

   k:=low(storing);
   l:=1;
   repeat
    if storing[k].data<>NIL then begin   { dispose old first }
       dtx:=mem[seg(storing[k].data^):ofs(storing[k].data^)];
       dty:=mem[seg(storing[k].data^):ofs(storing[k].data^)+1];
       msize:=(dtx*dty)+2;
       if (msize mod 16)<>0 then msize:=msize+16;
       msize:=16*(msize div 16);
       {$IFDEF USEDOSMEM}
          DALLOC(storing[k].data);
       {$ELSE}
          freemem(storing[k].data,msize);
       {$ENDIF}
    end;
    storing[k].bitflags:=0;

    blockread(lib_file,dtx,2);
    blockread(lib_file,dty,2);
    blockread(lib_file,frame,1);
    blockread(lib_file,frame,1);
    blockread(lib_file,cycle,1);
    if cycle then
       storing[k].BitFlags:=storing[k].BitFlags or 1;

    msize:=(dtx*dty)+2;
    if (msize mod 16)<>0 then msize:=msize+16;
    msize:=16*(msize div 16);
    {$IFDEF USEDOSMEM}
        MemAlloc(storing[k].data,dtx*dty);
    {$ELSE}
        GetMem(storing[k].data,msize);
    {$ENDIF}

    mem[seg(storing[k].data^):ofs(storing[k].data^)]:=byte(dtx);
    mem[seg(storing[k].data^):ofs(storing[k].data^)+1]:=byte(dty);

    blockread(lib_file,mem[seg(storing[k].data^):ofs(storing[k].data^)+2],dtx*dty);

    { check to see if we can skip the masking }
    with storing[k] do begin
      y:=0;
      cycle:=false;
      repeat
        x:=0;
        repeat
          if mem[seg(data^):ofs(Data^)+2+(y*dtx)+x]=0 then begin
             Cycle:=true;
          end;
          inc(x);
        until (x=dtx) or (cycle);
        inc(y);
      until (y=dty) or (cycle);
    end;
    if not Cycle then
       storing[k].BitFlags:=storing[k].BitFlags or 2;
    inc(k);
    inc(l);
   until l>ent;
   close(lib_file);
   GetImages:=ent;
END;

{}
{
        Get a single LAYER image

        Expects: LIB      - true if dfplib file used.
                 filename - name of XAS file
                 image    - the image-number to get from the XAS file
                 storing  - Pointer for image to be put at
        Returns: TRUE if succesfull
}
FUNCTION LoadLayerImage(lib:boolean; filename:string; image:byte):boolean;
VAR TID     : string [6];
    k       : integer;
    l       : integer;
    msize   : word;
    dtx,dty : word;
    x,y     : word;
    ent     : word;
    cycle   : boolean;
    X_Info  : byte;
    datamem : longint;
BEGIN
  LoadLayerImage:=false;
  if lib then begin
     k:=LIB_RESET(filename);        {Open the LIB_File}
     if k<>0 then exit;
  end else begin
     assign(lib_file,filename);
     {$I-}
       reset(lib_file,1);
     {$I+}
     if ioresult<>0 then begin
        LoadLAyerImage:=false;
        exit;
     end;
  end;
   blockread(lib_file,tid[1],5);
   tid[0]:=#5;
   if tid<>'XASv3' then begin
      close(lib_file);
      exit;
   end;
   blockread(lib_file,ent,sizeof(ent));
   blockread(lib_file,datamem,sizeof(Datamem));
   if ent<Image then begin
      close(lib_file);
      exit;
   end;

   l:=1;
   k:=low(layertile);
   repeat
    if layertile[k]<>NIL then begin   { dispose old first }
       dtx:=mem[seg(layertile[k]^):ofs(layertile[k]^)];
       dty:=mem[seg(layertile[k]^):ofs(layertile[k]^)+1];
       msize:=(dtx*dty)+2;
       if (msize mod 16)<>0 then msize:=msize+16;
       msize:=16*(msize div 16);
       {$IFDEF USEDOSMEM}
          DALLOC(layertile[k]);
       {$ELSE}
          freemem(layertile[k],msize);
       {$ENDIF}
    end;
    blockread(lib_file,dtx,2);
    blockread(lib_file,dty,2);
    blockread(lib_file,X_Info,1);
    blockread(lib_file,X_Info,1);
    blockread(lib_file,X_Info,1);

    msize:=(dtx*dty)+2;
    if (msize mod 16)<>0 then msize:=msize+16;
    msize:=16*(msize div 16);
    {$IFDEF USEDOSMEM}
      MemAlloc(layertile[k],dtx*dty);
    {$ELSE}
      GetMem(layertile[k],msize);
    {$ENDIF}

    mem[seg(layertile[k]^):ofs(layertile[k]^)]:=byte(dtx);
    mem[seg(layertile[k]^):ofs(layertile[k]^)+1]:=byte(dty);

    blockread(lib_file,mem[seg(layertile[k]^):ofs(layertile[k]^)+2],dtx*dty);

    inc(k);
    inc(l);
    if k=image+1 then LayerNR:=k;
   until (l>ent) or (k>5);
   close(lib_file);
   LoadLayerImage:=true;
   LayerNR:=IMAGE;
END;
{}
{
        Read in a charset file.

        Expects: LIB=TRUE if using library file, and the Filename of charset.
        Returns: Nothing
}
FUNCTION LoadCharset(lib:boolean;filename:string):boolean;
VAR TID  : string [4];
    k,l    : integer;
    ent    : word;
    msize : word;
BEGIN
  LoadCharset:=false;
  if lib then begin
     k:=lib_Reset(filename);
     if k<>0 then exit;
  end else begin
      assign(lib_file,filename);
      {$I-}
         reset(lib_file,1);
      {$I+}
      if ioresult<>0 then begin
         LoadCharset:=false;
         halt_error:='unable to open file '+filename;
         exit;
      end;
  end;
   blockread(lib_file,tid[1],3);
   tid[0]:=#3;
   if tid<>'CHR' then begin
      close(lib_file);
      halt_error:='unable to open file '+filename+', non valid';
      exit;
   end;
   blockread(lib_file,ent,sizeof(ent));
   k:=low(charset);
   l:=1;
   repeat
    msize:=(charwidth*charheight);
    if (msize mod 16)<>0 then msize:=msize+16;
    msize:=16*(msize div 16);
    {$IFDEF USEDOSMEM}
      MemAlloc(charset[k],charwidth*charheight);
    {$ELSE}
      GetMem(charset[k],msize);
    {$ENDIF}

    blockread(lib_file,mem[seg(charset[k]^):ofs(charset[k]^)],charwidth*charheight);

    inc(k);
    inc(l);
   until l>ent;
   close(lib_file);
   LoadCharset:=true;
END;
{}
{
        Set the page-segment to draw the text on

        Expects: segment of page to draw one (vpage_Seg or sega000)
        Returns: Nothing
}
PROCEDURE SetTEXTSegment(newseg:word);
BEGIN
 TextSeg:=newseg;
END;
{}
{
        Write text on screen using the graphics charset

        Expects: X+Y position on screen, and the text
        Returns: Nothing

        NOTE: No clipping is performed on the screen edges!!!
}
PROCEDURE Text(Xpos,Ypos:Word;text:String);
VAR i      : word;
    nx     : word;
    dataptr : pointer;
    tempDS  : word;
BEGIN
 nx:=xpos;                                      { start value of X }
 for i:=1 to length(Text) do                    { go thru every character }
     if ord(text[i])<>0 then begin
     dataptr:=charset[ord(text[i])];     { get pointer to char-data }
     ASM
      xor bx,bx         { Y counter per character }
      xor ch,ch

     @Vloop:
      mov es,textseg    { segment of screen }
      mov ax,bx         { get current Y value }
      add ax,ypos       { add Y start value }
      mov di,ax         { get Y value in CX }
      shl di,6          { multiply with 64... }
      shl ax,8          { ...and with 128 }
      add ax,nx         { add drawing start X position }
      add di,ax         { and move calculate offset to DI }

      mov TEMPDS,DS     { remember DS! }

      mov cl,charwidth

      LDS si,dataptr    { get memory location of the data }
      mov ax,bx         { get current Y value }
      mul cx            { multiply with width of charset }
      add si,ax         { add the calculated offset to the offset of the data }

     @HLoop:
      lodsb             { get word }
      cmp al,0          { see if AL is 0 }
      je @NoSet         { yes, so don't draw it }
      mov es:[di],al    { else draw it }
     @NoSet:
      inc di
      loop @Hloop       { loop until CX =0 }

      mov DS,TEMPDS     { get DS back }

      inc bl            { increase the Y scanline }
      cmp bl,CharHeight { are we at the bottom of the character? }
      jl @Vloop         { no, so draw next line }
      mov bl,CharWidth
      add nx,bx         { next X position on screen for the new character }
    end;
 end else inc(nx,CharWidth);    { go to next character position }
END;
{}
{
        Rough check if 2 shapes are colliding. This works faster as a
        pixel by pixel check for a collision, and as long as the shapes don't
        have to much "space" on the edges the collision will be allmost
        perfect.

        Expects: X+Y position and the WIDTH + HEIGHT of the first sprite,
                 X+Y position and the WIDTH + HEIGHT of the second sprite.

        Returns: True if collision has been detected.

}

FUNCTION collision(x1,y1,w1,h1, x2,y2,w2,h2 :integer):boolean;
VAR xd,yd : boolean;
BEGIN
 ASM
  mov xd,false
  mov yd,false
 END;

 if ((x1 <=x2) and (x1+w1>=x2)) then xd:=true else
    if ((x1 <=x2+w2) and (x1+w1>=x2+w2)) then xd:=true else
       if ((x1 >=x2) and (x1+w1<=x2+w2)) then xd:=true;
 if ((y1 <=y2) and (y1+h1>=y2)) then yd:=true else
    if ((y1 <=y2+h2) and (y1+h1>=y2+h2)) then  yd:=true else
       if ((y1 >=y2) and (y1+h1<=y2+h2)) then yd:=true;
 collision:=xd and yd;
END;
{}
{

        Add a FX type to a linked list

        Expects: X and Y position + spriteSET number
        Returns: True if succesfull

}
FUNCTION AddFX(  Xpos2,Ypos2  :  integer;
                  F_Frame2     :  byte):boolean;
VAR  Temp_FX  : PFX;
     i        : word;
     add      : word;
BEGIN
 AddFX:=true;

 new(Temp_FX);
 if Temp_FX=NIL then begin
    AddFX:=false;
    exit;
 end;

 if FirstFX=NIL  then begin
    LastFX:=Temp_FX;
    FirstFX:=Temp_FX;
    with FirstFX^ do begin
         next:=NIL;
         prev:=Nil;
    end;
 end else begin
     LastFX^.next:=temp_FX;
     Temp_FX^.prev:=LastFX;
     LastFX:=Temp_FX;
     Temp_FX^.next:=NIL;
 end;


 With TEMP_FX^ do begin
  xpos:=xpos2;
  ypos:=ypos2;
  i:=1;
  add:=1;
  while i<>f_frame2 do begin
        if FXS[add].a_Frame<>0 then inc(add,FXS[add].a_Frame) else inc(Add);
        inc(i);
  end;
  f_Frame:=add;
  c_frame:=f_frame;
  a_frame:=FXS[f_Frame].a_frame;
  s_frame:=FXS[f_Frame].s_frame;
  t_frame:=s_frame;
  n_frame:=FXS[f_Frame].n_frame;
  bitflag:=FXS[f_Frame].bitflags;
 end;
END;
{}
{

        Erase a FX object from the linked-list

        Expects: pointer to FX object  that needs to be ERASED!

        Returns: True if succesfull

}
FUNCTION EraseFX(Temp_FX:PFX):boolean;
VAR  next_fx,
     prev_fx  : PFX;
     i        : integer;
     msize    : word;
BEGIN
  eraseFX:=true;
  if Temp_FX=NIL then begin
     eraseFX:=false;
     exit;
  end;

  prev_fx:=Temp_fx^.prev;
  next_fx:=Temp_fx^.next;

  if prev_fx=NIL then begin
     FirstFX:=next_fx;
  end else Prev_fx^.next:=next_fx;

  if next_fx=NIL then begin
     LastFX:=prev_fx;
  end else Next_fx^.prev:=prev_fx;

  dispose(Temp_FX);
END;
{}
{
        Handle the FX- linked list

        Expects: Nothing

        Returns: Nothing

}
PROCEDURE DoFX;
VAR temp_fx : PFx;
    next_FX : PFx;
    done    : boolean;
    dataptr : pointer;
    x,y     : integer;
BEGIN
 temp_fx:=FirstFX;
 while temp_fx<>NIL do begin
       with temp_fx^ do begin
            done:=false;
            next_FX:=temp_fx^.next;
            if t_frame>0 then dec(t_frame) else begin
               t_Frame:=s_frame;
               if a_Frame>0 then inc(c_Frame,n_frame);
               if c_Frame>=f_FRame+a_Frame then begin
                  if not eraseFX(temp_fx) then begin
                     halt_error:='Couldn''t dispose FX_object.';
                     halt(1);
                  end;
                  done:=true;
               end;
            end;
            if not done then begin
               x:=xpos-mapx; y:=ypos-mapy;
               dataptr:=fxs[c_frame].data;
               asm
                mov ax,x
                mov bx,y
                les di,dataptr
                call Sprite
               end;
            end;
       end;
       temp_fx:=next_fx;
 end;
END;

{}
{
        View a 360x480x256 image... FAST and sure great looking.

        Expects    : use a LIB file, and the Filename of PCX
        Returns    : True if succesfull in loading

}
FUNCTION LOADPCXHIGH(lib:boolean;filename:string):boolean;
TYPE PCX_Header = record
       manu     : byte;
       version  : byte;
       encoding : byte;
       b_p_pix  : byte;
       xmin     : word;
       ymin     : word;
       xmax     : word;
       ymax     : word;
       hres     : word;
       vres     : word;
       colormap : array[1..48] of byte;
       reserve  : byte;
       nplanes  : byte;
       bpline   : word;
       palinfo  : word;
       filler   : array[1..58] of byte;
    end;

VAR  i,r,g,b     : byte;
     Xsize,Ysize : word;            { Size of image }
     Xscrn,Yscrn : word;            { Screen positions }
     plotdata    : byte;            { Byte-Color-Pixel to plot }
     readbyte    : byte;            { Byte to read from file }
     count       : integer;         { Count of continuous bytes }
     Header      : PCX_Header;
     code        : integer;
     error       : boolean;
     bytesleft   : longint;
     sizeread    : longint;
     bytesmem    : longint;
     mempos      : longint;

      PROCEDURE REadNewBlock;
      BEGIN
        if bytesleft<63000 then sizeread:=bytesleft else sizeread:=63000;
        blockread(lib_file,mem[vpage_seg:vpage_ofs],sizeread);
        dec(bytesleft,sizeread);
        bytesmem:=sizeread;
        mempos:=0;
      END;

      PROCEDURE GetByte(Var return:byte);
      BEGIN
        if mempos>=bytesmem then ReadNewBlock;
        return:=mem[vpage_seg:vpage_ofs+mempos];
        inc(mempos);
      END;

BEGIN
  LoadPCXHigh:=true;                                 { all's well }
  error:=false;                                      { no error's (yet) }

  if lib then begin
     code:=lib_reset(filename);
     if code<>0 then begin
        LoadPCXhigh:=false;
        exit;
     end;
     bytesleft:=(key_size)-897;
  end else begin
     assign(lib_file,filename);
       {$I-}
            reset(lib_file,1);    { open file }
       {$I+}
       bytesleft:=filesize(lib_file)-897;
       if ioresult<>0 then begin
          LoadPCXhigh:=false;
          exit;
       end;
  end;
  blockread(lib_file,header,sizeof(header));      { Read header first}
 {

    Check for correct PCX format

 }
 if header.encoding<>1 then error:=true;        { different encoding used }
 if header.b_p_pix<>8 then error:=true;         { to many bits per pixel }
 if header.nplanes<>1 then error:=true;         { to many color planes }
 if error then begin
    close(lib_file);         { Close the file          }
    LoadPCXHigh:=false;      { not decoded!            }
    exit;                    { And exit this procedure }
 end;

  { Init some values }
  Xsize:=header.xmax-header.xmin+1;             { Get actual X-Size of image }
  Ysize:=header.ymax-header.ymin+1;             { Get actual Y-Size of image }
  Xscrn:=0;                                     { Screen positions }
  Yscrn:=0;                                     { Screen positions }
  {
    Go into HIGH screen mode (ModeX 360x480x256)
  }
  ASM
     mov ax,$13           { select the VGA mode }
     int 10h              { go into it! }

     mov dx,$3c4
     mov ax,$0604
     out dx,ax            { disable chain4 mode }
     mov ax,$0f02
     out dx,ax            { set Write plane mask to all planes }

     mov cx,16000         { let's clear the screen first }
     DB $66
     xor ax,ax            { set EAX to 0 }
     mov es,sega000       { get screen segment }
     xor di,di            { get screen offset  }
     DB $66
     rep STOSW            { store all DOUBLE words }

     mov dx,$3c2
     mov al,$e7
     out dx,al            { use 28mhz dot clock }
     mov dx,$3c4
     mov ax,$0300
     out dx,ax            { restart sequencer }
     mov dx,$3d4
     mov al,$11
     out dx,al            { select CRTC register 11 }
     xor ah,ah
     mov dx,$3d5
     in al,dx
     and al,$7f            { "write protect" }
     out dx,al
     mov dx,$3d4           { write new register values }
     mov ax,$6b00          { horz total                }
     out dx,ax
     mov ax,$5901          { horz displayed            }
     out dx,ax
     mov ax,$5a02          { start horz blanking       }
     out dx,ax
     mov ax,$8e03          { end horz blanking         }
     out dx,ax
     mov ax,$5e04          { start h sync              }
     out dx,ax
     mov ax,$8a05          { end h sync                }
     out dx,ax
     mov ax,$0d06          { vertical total            }
     out dx,ax
     mov ax,$3e07          { overflow                  }
     out dx,ax
     mov ax,$4009          { cell height               }
     out dx,ax
     mov ax,$ea10          { v sync start              }
     out dx,ax
     mov ax,$ac11          { v sync end and protect cr0-cr7  }
     out dx,ax
     mov ax,$df12          { vertical displayed        }
     out dx,ax
     mov ax,$2d13          { offset                    }
     out dx,ax
     mov ax,$0014          { turn off dWord mode       }
     out dx,ax
     mov ax,$e715          { v blank start             }
     out dx,ax
     mov ax,$0616          { v blank end               }
     out dx,ax
     mov ax,$e317          { turn on Byte mode         }
     out dx,ax

     { Make the palette Black }
     call BlackPal
  end;

  bytesmem:=0;
  mempos:=1;

  REPEAT
       getbyte(readbyte);
       if (readbyte and 192)=192 then begin     { Are Top 2 bits set? }
           count:=readbyte and 63;              { Yes, so it's a packed }
           getbyte(plotdata);
       end else begin
           count:=1;                            { Not packed, so 1 byte to set}
           plotdata:=readbyte;                  { Set the color to plot }
       end;
          while count>0 do begin
                PortW[$3c4]:=($100 shl (xscrn and 3))+2;
                ASM
                   mov cx,90            { width of screen in modeX 360.. }
                   mov es,sega000       { get screen segment             }
                   mov ax,yscrn         { get screen Y                   }
                   mul cx               { multiply with screen width     }
                   mov di,ax            { and set to screen offset       }
                   mov ax,xscrn         { get X position                 }
                   shr ax,2             { divide with 4 (4 planes)       }
                   add di,ax            { add to screen offset           }
                   mov al,plotdata      { get color value                }
                   stosb                { store the byte                 }
                   inc xscrn            { increse X position on screen   }
                   dec count            { decrease couter                }
                END;
          end;
          if xscrn>=xsize then begin             { Hit the image-width? }
             xscrn:=0;                           { Yes, so restart at 0 }
             inc(yscrn);                         { And go 1 line down on screen}
          end;
  UNTIL (yscrn=ysize);                           { Repeat until complete image}

  {

    Now load the palette

  }
  seek(lib_file,filesize(lib_file)-769);
  if lib then
     seek(lib_file,Key_Start+Key_Size-769)      { get last 769 bytes }
  else
     seek(lib_file,filesize(lib_file)-769);
  blockread(lib_file,readbyte,1);               { read a byte, }
  if readbyte=12 then begin                     { and check for 12 (palette) }
     for plotdata:=0 to 255 do begin            { walk thru all colors }
         port[$03c8]:=plotdata;

         blockread(lib_file,readbyte,1); readbyte:=readbyte shr 2;
            pal[plotdata].Redlevel:=readbyte;
         blockread(lib_file,readbyte,1); readbyte:=readbyte shr 2;
            pal[plotdata].GreenLevel:=readbyte;
         blockread(lib_file,readbyte,1); readbyte:=readbyte shr 2;
            pal[plotdata].BlueLevel:=readbyte;
     end;
  end;
  close(lib_file);                                 { Close image file }
  FadeIn(0,255);
END;

{}
{
        Wait for a vertical retrace of the vga/monitor

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE RetraceOLD; Assembler;
ASM
    MOV DX,$3DA
 @WaitEnd:
    IN AL,DX
    TEST AL,8
    JNZ @WaitEnd
 @WaitStart:
    IN AL,DX
    TEST AL,8
    JZ @WaitStart

END;
{}
{
        Wait for a vertical retrace of the vga/monitor, and show a vertical
        line at the position you call this procedure, so you can see how
        much time is left for drawing the screen.

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE TestCPULine; Assembler;
ASM
        MOV DX,$03DA
      @WAIT1:
        IN AL,DX
        TEST AL,$01
        JNZ @WAIT1
      @WAIT2:
        IN AL,DX
        TEST AL,$01
        JZ @WAIT2
        MOV DX,$3C8
        MOV AL,$00
        OUT DX,AL
	INC DX
	MOV AL,$20
	OUT DX,AL
	OUT DX,AL
	OUT DX,AL
	MOV DX,$03DA
      @WAIT3:
	IN AL,DX
	TEST AL,$01
	JNZ @WAIT3
      @WAIT4:
	IN AL,DX
	TEST AL,$01
	JZ @WAIT4
	MOV DX,$3C8
	MOV AL,$00
	OUT DX,AL
	INC DX
	OUT DX,AL
	OUT DX,AL
	OUT DX,AL

	MOV DX,$3DA
      @@2:
	IN AL,DX
	TEST AL,$08
	JZ @@2
END;
{}
{
        Deallocate memory from a spritetype array

        Expects: array of the spritetyp
        Returns: Nothing
}

PROCEDURE DeAllocXAS(VAR storing:Array of SpriteTyp);
VAR i            : word;
    msize        : word;
    width,height : byte;
BEGIN
 for i:=low(storing) to high(storing) do begin
     if storing[i].data<>NIL then begin
       Width:=mem[seg(storing[i].data^):ofs(storing[i].data^)];
       Height:=mem[seg(storing[i].data^):ofs(storing[i].data^)+1];
       msize:=(Width*Height)+2;
       if (msize mod 16)<>0 then msize:=msize+16;
       msize:=16*(msize div 16);
       {$IFDEF USEDOSMEM}
          DALLOC(storing[i].data);
       {$ELSE}
          freemem(storing[i].data,msize);
       {$ENDIF}
     end;
 end;
END;
{}
{
   Takes a sample of the joystick state, and button states..

   Expects: Nothing
   Returns: Nothing

}

PROCEDURE SAMPLE; ASSEMBLER;
ASM
 CLI
 xor si,si     {x count}
 xor di,di     {y count}
 mov dx,$201   {Game port}
 out dx,al     {Fire the joystick one-shots}
@@L:
 in  al,dx     {get joystick bits}
 mov ah,al     {save original value}
 shr al,1      {joy 0 x expired? 0 if so, else 1}
 adc si,0      {accumulate in x}
 jc @@TOOLONG  {if overflow, give up}
 shr al,1      {joy 0 y expired? 0 if so, else 1}
 adc di,0      {accumulate in y}
 jc @@TOOLONG  {if overflow, give up}
 test ah,3
 jnz @@L       {keep going til they're both 0 or we overflow}
 not ah        {flip button bits so 1=pressed}
 mov al,ah
 and al,$10    {mask off buttons and store them}
 mov JoystickA,al
 mov al,ah
 and al,$20
 mov JoystickB,al
 mov al,ah
 and al,$40
 mov JoystickC,al
 mov al,ah
 and al,$80
 mov JoystickD,al

 mov X,si      {store x & y coords}
 mov Y,di
 jmp @@X
@@TOOLONG:
 mov X,-1      {overflowed, return -1 as error}
 mov Y,-1
 xor al,al
 mov JoystickA,al
 mov JoystickB,al
 mov JoystickC,al
 mov JoystickD,al
@@X:
 STi
END;
{}
{
   It does the usual "swirl" calibrating of the joystick.
   display message before starting this one!

   Expects: Nothing
   Returns: Nothing

}
PROCEDURE SWIRLCALIBRATE;
BEGIN
 REPEAT
   SAMPLE;
 until NOT (JoystickA or JoystickB or JoystickC or JoystickD);

 REPEAT                           {collect max extents}
  sample;
  if x<Cal_L then Cal_L:=x;
  if x>Cal_R then Cal_R:=x;
  if y<Cal_T then Cal_T:=y;
  if y>Cal_B then Cal_B:=y;
 UNTIL JoystickA or JoystickB or joystickC or joystickD; {until user presses a button}
 Cal_L:=((Cal_L*3)+Cal_R)div 4;      {now adjust for center by}
 Cal_R:=((Cal_R*3)+Cal_L)div 4;      { weighted averaging}
 Cal_T:=((Cal_T*3)+Cal_B)div 4;
 Cal_B:=((Cal_B*3)+Cal_T)div 4;
END;
{}
{
   This one expects the joystick to be in the center, and then takes
   a "SNAP SHOT" of the center positions... not as accurate as the
   "swirl" calibrating...but it should work in most cases.

   Expects: Nothing
   Returns: Nothing

}
PROCEDURE CENTERCALIBRATE;
VAR x2,y2   : word;
BEGIN
 sample;
 x2:=x shr 1;
 y2:=y shr 1;
 Cal_L:=x-x2;
 Cal_R:=x+x2;
 Cal_T:=y-y2;
 Cal_B:=y+y2;
END;
{}
{
   Get the joystick booleans SET to TRUE or FALSE, according to actions
   from the player.

   Expects: Nothing
   Returns: Nothing

}
PROCEDURE GetJoy;
BEGIN
 Sample;
 JoyThings[1]:=x<cal_l;
 JoyThings[2]:=x>cal_R;
 JoyThings[3]:=y>cal_B;
 JoyThings[4]:=y<cal_T;
 JoyThings[5]:=JoystickA;
 JoyThings[6]:=JoystickB;
 JoyThings[7]:=JoystickC;
 JoyThings[8]:=JoystickD;

 JoystickDown:=JoyThings[JoyDown];
 Joystickleft:=JoyThings[JoyLeft];
 JoystickUp:=JoyThings[JoyUp];
 JoystickRight:=JoyThings[Joyright];
 JoystickA:=JoyThings[JoyFire];
END;


{}
{
        Shut down the library, and free all memory... this is also called
        thru the NEWEXIT procedure (every time you HALT, or at the end of the
        program..)

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE ShutSuperFX;
VAR I            : byte;
    MSIZE        : word;
    Width,Height : byte;
    tempFX       : PFX;
    nextFX       : PFX;
BEGIN
 window(1,1,80,25);
 if Vpage_PTR<>NIL then begin
    {$IFDEF USEDOSMEM}
        DAlloc(VPage_PTR);
    {$ELSE}
        FreeMem(VPage_PTR,64000);
    {$ENDIF}
 end;
 if Board_PTR<>NIL then begin
    {$IFDEF USEDOSMEM}
        DAlloc(Board_PTR);
    {$ELSE}
        FreeMem(Board_PTR,25600);
    {$ENDIF}
 end;

  if map<>nil then begin
    {$IFDEF USEDOSMEM}
      DAlloc(map);
    {$ELSE}
      FreeMem(map,(mapheight+1)*(mapwidth+1)*sizeof(MapType));
    {$ENDIF}
  end;

{

    Erase TileData from memory

}
 for i:=0 to 255 do begin
     if Tiles[i].data<>NIL then begin
       Width:=mem[seg(Tiles[i].data^):ofs(Tiles[i].data^)];
       Height:=mem[seg(Tiles[i].data^):ofs(Tiles[i].data^)+1];
       msize:=(Width*Height)+2;
       if (msize mod 16)<>0 then msize:=msize+16;
       msize:=16*(msize div 16);
       {$IFDEF USEDOSMEM}
          DALLOC(Tiles[i].data);
       {$ELSE}
          freemem(Tiles[i].data,msize);
       {$ENDIF}
    end;
 end;

 {

        Erase LAYER from memory

 }
 FOR i:=1 to 5 do begin
  if layertile[i]<>NIL then begin   { dispose old first }
    Width:=mem[seg(layertile[i]^):ofs(layertile[i]^)];
    Height:=mem[seg(layertile[i]^):ofs(layertile[i]^)+1];
    msize:=(Width*Height)+2;
    if (msize mod 16)<>0 then msize:=msize+16;
    msize:=16*(msize div 16);
    {$IFDEF USEDOSMEM}
        DALLOC(layertile[i]);
    {$ELSE}
        freemem(layertile[i],msize);
    {$ENDIF}
   end;
 END;

 {
        Erase CHARSET
 }
 for i:=0 to 65 do begin
     IF Charset[i]<>NIL then begin
        msize:=(charwidth*charheight);
        if (msize mod 16)<>0 then msize:=msize+16;
        msize:=16*(msize div 16);
        {$IFDEF USEDOSMEM}
            DAlloc(charset[i]);
        {$ELSE}
            FreeMem(charset[i],msize);
        {$ENDIF}
     end;
 end;
{

    Erase FX data from memory

}
   tempfx:=FirstFX;
   while tempfx<>NIL do begin
       nextFX:=tempfx^.next;
       eraseFX(tempfx);
       tempfx:=nextfx;
   end;

 {

   Go back into text mode

 }
 if ShowInfo then
 ShowInformation;
 {

   Restore Timer/Keyboard interrupt

 }
 RestoreTimerInterrupt;
 RestoreInt09;

END;
{
                            NEW Timer Procedures
}
PROCEDURE SetTimer(x : word); assembler;
asm
	cli
	mov	al,$36
	out	$43,al
	jmp	@1
@1:mov	ax,[x]
	out	$40,al
	jmp	@2
@2:mov	al,ah
	out	$40,al
	jmp	@3
@3:sti
end;
{}
{$F+,S-}
procedure TimerHandler; interrupt; assembler;
{$F-}
asm
	cli
	inc	[timercount]
	mov	ax,[TIMEOUT]
	cmp	[timercount],ax
	jb		@noretrace
	mov	[timercount],0

	{wait for a vertical retrace}
	mov	dx,$3DA
@vblank:
	in		al,dx
	test	al,8
	jz		@vblank

	{set timer again}
	mov	al,$36
	out	$43,al
	jmp	@1
@1:mov	ax,[TimeSet]
	out	$40,al
	jmp	@2
@2:mov	al,ah
	out	$40,al

	{increase timer counters}
	inc	[retraces]
	inc	[total_retraces]

	{should we call user-defined hook?}
	mov	ax,WORD PTR [TimerProc]
	or		ax,WORD PTR [TimerProc+2]
	jz		@nouserproc
	sti
	call	DWORD PTR [TimerProc]
	cli
@nouserproc:

	cmp	[execbiostimer],FALSE
	je		@nobiostimer
	mov	ax,[TimeSet]
	add	[bioscount],ax
	jno	@nobiostimer
	sti
	pushf
	call	DWORD PTR [Int08Save]
	jmp	NEAR PTR @xit
@nobiostimer:

@noretrace:
	mov	al,$20
	out	$20,al
	sti
@xit:
end;
{}
FUNCTION GetTime : word; assembler;
{Find time between two vertical retraces...}
asm
	mov	dx,$3DA   {wait for a vertical retrace to begin}
@wait1a:
	in		al,dx
	test	al,8
	jnz	@wait1a
@wait1b:
	in		al,dx
	test	al,8
	jz		@wait1b

	mov	al,$36
	out	$43,al
	xor	al,al		{ reset the timer }
	out	$40,al
	out	$40,al

	mov	dx,$3DA   {wait for a new vertical retrace to begin}
@wait2a:
	in		al,dx
	test	al,8
	jnz	@wait2a
@wait2b:
	in		al,dx
	test	al,8
	jz		@wait2b

	xor	al,al
	out	$43,al
	in		al,$40
	mov	ah,al
	in		al,$40		{ read timer count - time between }
	xchg	al,ah       { two Vertical Retraces }
	neg	ax
end;
{}
FUNCTION SyncTimerToVBLANK : word; assembler;
const
	FRAMEPERCENT = 950; {returned time will be 97.5% of measured value}
asm
@GetFrameTime:
	cli									{ Don't bother us while timing things }
	call	GetTime
	push	ax
	call	GetTime
	pop	dx
	sti
	sub	dx,ax
	cmp  	dx,5                    { If the difference between the two }
	jg		@GetFrameTime           { values read was >5, read again }
	cmp	dx,-5
	jl		@GetFrameTime

	mov	bx,FRAMEPERCENT
	mul	bx
	mov	bx,1000
	div	bx
	shr	ax,1
end;
{}
PROCEDURE SetTimerInterrupt;
begin
	retraces:=0; total_retraces:=0; timercount:=0;
	TimeSet:=$FFFF;
	GetIntVec($08,@Int08Save);
	SetIntVec($08,addr(TimerHandler));
	if (TIMEOUT<>0) then TimeSet := ($1234DD DIV 70 DIV TIMEOUT)+TIMESLACK
	else TimeSet:=SyncTimerToVBLANK;
	SetTimer(TimeSet);
	TimerInstalled:=TRUE;
end;
{}
PROCEDURE RestoreTimerInterrupt;
begin
	if NOT TimerInstalled then exit;
	SetIntVec($08,@Int08Save);
	SetTimer(0);
	TimerInstalled:=FALSE;
end;
{}
{
        This is the new RETRACE procedure... it checks on interrupt and not
        on vga-retrace

        Expects: Nothing
        Returns: Nothing
{}
PROCEDURE Retrace; assembler;
{Wait for the next vertical retrace}
asm
 	cmp	[TimerInstalled],TRUE
	je		@timerinstalled
	mov	dx,$3DA
@wait1: {if we are in retrace, wait 'till we are not...}
	in		al,dx
	test	al,8
	jnz	@wait1
@wait2: {wait for a new retrace}
	in		al,dx
	test	al,8
	jz		@wait2
	jmp	NEAR PTR @done

@timerinstalled:
	mov	ax,[total_retraces]
@wait3:
	cmp	ax,[total_retraces]
	je		@wait3
@done:
END;
{}
{
        New exit procedure to quit to dos

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE NewExit; FAR;
var i : byte;
BEGIN
  ExitProc:=OldExit;
  if halt_error<>'' then begin
     writeln(halt_error);
     writeln;
  end;
  ShutSuperFX;
end;
{}
{
        Write Text

        Expects: X,Y position of the text, and the text-string
                 and the forground+background color
        Returns: Nothing
}
PROCEDURE TWRITE(x,y:word;text:string;col1,col2:byte);
BEGIN
 ASM
   dec x
   dec y
   lea di,text
   mov bx,di

   mov es,segb800       { get screen segment }
   mov di,y             { get Y position }
   mov ax,di
   shl di,7             { multiply with 7... }
   shl ax,5             { and with 32        }
   add di,ax            { add together= Y*160}
   mov ax,x             { get X position }
   shl ax,1             { multiply with 2 }
   add di,ax            { add to screen offset }

   mov ah,col2          { get background color }
   shl ah,4             { multiply with 16     }
   add ah,col1          { add forground color  }

   mov DX,DS            { remember DX          }

   mov cx,ss
   mov ds,cx
   mov si,bx

   lodsb                { read length of string }
   xor ch,ch
   mov cl,al            { set length into CL    }
   cmp cl,0
   je @NoSet            { if no text, skip writing }

  @TLoop:
   LODSB                { load character }
   STOSW                { store character+color }
   dec cl               { decrease length counter }
   jnz @TLoop
  @NoSet:
   mov DS,DX            { get DX back }
 END;
END;
{}
{
        Read from screen coordinates

        Expects: X+Y position to read from
        Returns: Character at the specified position
}
FUNCTION TRead(x,y:word):char; Assembler;
ASM
  dec x
  dec y
  mov ax,y      { get Y positions...                                         }
  mov bx,ax     { ...in AX and BX                                            }
  shl ax,7      { multiply Y with 128...                                     }
  shl bx,5      { ... and with 32                                            }
  add ax,bx     { add together = Y*160                                       }
  mov bx,x      { get X position                                             }
  shl bx,1      { multiply with 2                                            }
  add ax,bx     { add to offset                                              }

  mov es,segb800{ get screen segment                                         }
  mov di,ax     { get screen offset in si                                    }

  mov es:[di],al{ load character                                             }
END;
{}
{
        Center text between 2 X values

        Expects: right,left positions, and the text to be centered
        Returns: The left-starting position to start writing
}
FUNCTION CENTER(x2,x1:integer;zin : string):integer;
BEGIN
 center:=x1+((x2-x1) shr 1)-(length(zin) shr 1)+1;
END;
{}
{
        Draw a menu box

        Expects: Corner positions, title of box, forground+background color
        Returns: Nothing
}
PROCEDURE do_mnu(x1,y1,x2,y2:integer;title,title2:string;c1,c2:integer);
VAR x3,y3          : integer;
    zin            : string[80];
    frontcol       : byte;
BEGIN
 zin:='';
 for x3:=1 to x2-x1+1 do zin:=zin+' ';
 for y3:=y1 to y2 do Twrite(x1,y3,zin,c1,c2);

 for x3:=x1 to x2 do begin
  Twrite(x3,y1,'',c1,c2);
  Twrite(x3,y2,'',c1,c2);
 end;
 for y3:=y1 to y2 do begin
   Twrite(x1,y3,'',c1,c2);
   Twrite(x2,y3,'',c1,c2);
 end;
 Twrite(x2,y1,'',c1,c2);
 Twrite(x2,y2,'',c1,c2);
 Twrite(x1,y1,'',c1,c2);
 Twrite(x1,y2,'',c1,c2);
 if x2+1<81 then begin
   for y3:=y1+1 to y2+1 do if y3<26 then twrite(x2+1,y3,tread(x2+1,y3),8,0);
 end;
 if y2+1<26 then begin
   for x3:=x1+1 to x2+1 do if x3<81 then twrite(x3,y2+1,tread(x3,y2+1),8,0);
 end;

 IF Title<>'' then begin
    for x3:=x1+1 to x2-1 do Twrite(x3,y1+2,'',c1,c2);
    Twrite(x1,y1+2,'',c1,c2);
    Twrite(x2,y1+2,'',c1,c2);
    Twrite( x1+1,y1+1,copy(zin,1,length(zin)-2),c1,c2);
    Twrite( center(x1+1,x2-1,title) ,y1+1,title,c1,c2);
 end;

 IF Title2<>'' then begin
    for x3:=x1+1 to x2-1 do Twrite(x3,y2-2,'',c1,c2);
    Twrite(x1,y2-2,'',c1,c2);
    Twrite(x2,y2-2,'',c1,c2);
    twrite(center(x1+1,x2-1,title2), y2-1,title2,c1,c2);
 end;
END;

{}
BEGIN
 port[$03c8]:=0; Port[$03c9]:=0; Port[$03c9]:=0;  Port[$03c9]:=0;
 port[$03c8]:=7; Port[$03c9]:=36; Port[$03c9]:=30; Port[$03c9]:=37;
 port[$03c8]:=5; port[$03c9]:=16; Port[$03c9]:=5; Port[$03c9]:=17;

 do_mnu(1,1,80,25,'SuperFX Initialisation','',7,5);
 textcolor(7); textbackground(5);
 window(2,4,79,24);

 key_start:=0;
 asm
  mov ah,$48
  mov bx,$ffff
  int $21
  mov word ptr key_start,bx
 end;
 key_start:=key_start shl 4;
 writeln('Base memory available : (',key_start div 1024,' kb)');
 write('Initialising wave FX :');
  FXSinusPosition := 0;          write('.');
  FXWave          := false;      write('.');
  FXLoop          := 1;          write('.');
  FXOutCount      := 80;         write('.');
  InitSinus;                     write('.');
 writeln('ok');
{

   Initialise virtual BITMAP

}
 write('Allocating virtual page :');
  InitBitmap;      write('.');
 writeln('ok');
{

   Initialise new KeyBoard Interrupt, and new EXIT procedure

}
 write('Interrupt initialising :');
  ExitSave:=NIL;         write('.');
  InitInt09;             write('.');
  SetTimerInterrupt;     write('.');

  oldexit:=ExitProc;     write('.');{ remember the original exit Procedure    }
  ExitProc:=@NewExit;    write('.');{ Let's put in our OWN exit procedure     }
  ShowInfo:=False;       write('.');
 writeln('ok');
{

   See if a JOYSTICK/GAMEPAD is installed

}
 write('Checking for Joystick :');
  sample;                        write('.');
  JOYinstalled:=(x<>$FFFF);      write('.');
 writeln('ok');
{

   Initialise pointer variables

}
 write('Initialising pointers :');
   FirstFX:=Nil;                  write('.');
   LastFX:=Nil;                   write('.');
   FirstLight:=Nil;               write('.');
   LastLight:=Nil;                write('.');
 writeln('ok');
{

   Set some final values

}
 write('Setting default values :');
   XtilesAmount:=320 shr TileShiftFactor;      write('.');
   YtilesAmount:=(200 shr TileShiftFactor)+1;  write('.');
   SetTEXTsegment(sega000);                    write('.');
 writeln('ok');
 key_start:=0;
 asm
  mov ah,$48
  mov bx,$ffff
  int $21
  mov word ptr key_start,bx
 end;
 key_start:=key_start shl 4;
 writeln('Base memory left: ',key_start,' bytes');
 writeln(' program starts )');

END.
